=== modified file '.bzrignore'
--- .bzrignore	2005-10-03 16:53:39 +0000
+++ .bzrignore	2005-09-13 23:08:19 +0000
@@ -19,4 +19,3 @@
 ./ID
 ./tags
 .bzr-shelf
-bzrlib/plugins/*

=== modified file 'HACKING'
--- HACKING	2005-10-06 22:15:52 +0000
+++ HACKING	2005-08-25 12:46:42 +0000
@@ -1,25 +1,14 @@
 ============================
-Guidelines for modifying bzr
+guidelines for modifying bzr
 ============================
 
-.. contents::
-
-(The current version of this document is available in the file ``HACKING``
-in the source tree, or at http://bazaar-ng.org/hacking.html)
-
-Overall
-=======
-
 * New functionality should have test cases.  Preferably write the
   test before writing the code.
 
   In general, you can test at either the command-line level or the
   internal API level.  Choose whichever is appropriate: if adding a
   new command, or a new command option, then call through run_bzr().
-  It is not necessary to do both. Tests that test the command line level
-  are appropriate for checking the UI behaves well - bug fixes and
-  core improvements should be tested closer to the code that is doing the
-  work. Command line level tests should be placed in 'blackbox.py'.
+  It is not necessary to do both.
 
 * Before fixing a bug, write a test case so that it does not regress.
 
@@ -31,21 +20,17 @@
   function runs.  Import statements have a cost, so try to make sure
   they don't run inside hot functions.
 
+* Please write PEP-8__ compliant code.  
+
+  One often-missed requirement is that the first line of docstrings
+  should be a self-contained one-sentence summary.
+
+__ http://www.python.org/peps/pep-0008.html
+
 * Module names should always be given fully-qualified,
   i.e. ``bzrlib.hashcache`` not just ``hashcache``.
 
-Evolving interfaces
--------------------
-
-If you change the behaviour of an API in an incompatible way, please
-be sure to change its name as well. For instance, if I add a keyword
-parameter to branch.commit - that's fine. On the other hand, if I add
-a keyword parameter to branch.commit which is a *required* transaction
-object, I should rename the api - i.e. to 'branch.commit_transaction'.
-
-This will prevent users of the old api getting surprising results. 
-Instead, they will get an Attribute error as the api is missing, and
-will know to update their code. If in doubt, just ask on #bzr.
+
 
 Documentation
 =============
@@ -61,63 +46,6 @@
 should be done.
 
 
-API documentation
------------------
-
-Functions, methods, classes and modules should have docstrings
-describing how they are used. 
-
-The first line of the docstring should be a self-contained sentence.
-
-For the special case of Command classes, this acts as the user-visible
-documentation shown by the help command.
-
-The docstrings should be formatted as reStructuredText_ (like this
-document), suitable for processing using the epydoc_ tool into HTML
-documentation.
-
-.. _reStructuredText: http://docutils.sourceforge.net/rst.html
-.. _epydoc: http://epydoc.sourceforge.net/
-
-
-
-Coding style
-============
-
-Please write PEP-8__ compliant code.  
-
-One often-missed requirement is that the first line of docstrings
-should be a self-contained one-sentence summary.
-
-__ http://www.python.org/peps/pep-0008.html
-
-
-
-Naming
-------
-
-Functions, methods or members that are in some sense "private" are given
-a leading underscore prefix.  This is just a hint that code outside the
-implementation should probably not use that interface.
-
-We prefer class names to be concatenated capital words (``TestCase``)
-and variables, methods and functions to be lowercase words joined by
-underscores (``revision_id``, ``get_revision``).
-
-For the purposes of naming some names are treated as single compound
-words: "filename", "revno".
-
-Consider naming classes as nouns and functions/methods as verbs.
-
-
-Standard names
---------------
-
-``revision_id`` not ``rev_id`` or ``revid``
-
-Functions that transform one thing to another should be named ``x_to_y``
-(not ``x2y`` as occurs in some old code.)
-
 
 Writing output
 ==============
@@ -155,36 +83,17 @@
 The policy about how output is presented in the text-mode client
 should be only in the command-line tool.
 
-
 Writing tests
 =============
-In general tests should be placed in a file named testFOO.py where 
+In general tests should be placed in a file named test_FOO.py where 
 FOO is the logical thing under test. That file should be placed in the
 tests subdirectory under the package being tested.
 
-For example, tests for merge3 in bzrlib belong in bzrlib/tests/testmerge3.py.
-See bzrlib/selftest/testsampler.py for a template test script.
-
+For example, tests for merge3 in bzrlib belong in bzrlib/tests/test_merge3.py.
 
 Running tests
 =============
 Currently, bzr selftest is used to invoke tests.
 You can provide a pattern argument to run a subset. For example, 
-to run just the whitebox tests, run::
-
-  bzr selftest -v whitebox
-
-
-Errors and exceptions
-=====================
-
-[write me]
-
-
-Jargon
-======
-
-revno
-    Integer identifier for a revision on the main line of a branch.
-    Revision 0 is always the null revision; others are 1-based
-    indexes into the branch's revision history.
+to run just the whitebox tests, run bzr selftest --pattern .*whitebox.*
+

=== modified file 'NEWS'
--- NEWS	2005-10-06 13:08:14 +0000
+++ NEWS	2005-09-28 09:35:50 +0000
@@ -1,5 +1,4 @@
-bzr 0.1 2005-10-06
-
+DEVELOPMENT HEAD
 
   BUG FIXES:
   
@@ -9,14 +8,6 @@
     * Locking is now done with fcntl.lockf which works with NFS
       file systems. Contributed by Harald Meland.
 
-    * Commit will no longer commit without a log message, an 
-      error is returned instead. Contributed by Jelmer Vernooij.
-
-    * If you commit a specific file in a sub directory, any of its
-      parent directories that are added but not listed will be 
-      automatically included. Suggested by Michael Ellerman.
-
-
   IMPROVEMENTS:
 
     * 'branch' now accepts a --basis parameter which will take advantage
@@ -27,37 +18,10 @@
       Existing branches can be upgraded to this format using 
       'bzr upgrade'.
 
-    * Symlinks are now versionable. Initial patch by 
-      Erik Toubro Nielsen, updated to head by Robert Collins.
-
-    * Executable bits are tracked on files. Patch from Gustavo
-      Niemeyer.
-
-    * 'bzr status' now shows unknown files inside a selected directory.
-      Patch from Heikki Paajanen.
-
-    * Merge conflicts are recorded in .bzr. Two new commands 'conflicts'
-      and 'resolve' have needed added, which list and remove those 
-      merge conflicts respectively. A conflicted tree cannot be committed
-      in. Contributed by Aaron Bentley.
-
-
   INTERNALS:
 
-    * Test case failures have the exception printed after the log 
-      for your viewing pleasure.
-
-    * InventoryEntry is now an abstract base class, use one of the
-      concrete InventoryDirectory etc classes instead.
-
-
-  TESTING:
-
-    * Removed testsweet module so that tests can be run after 
-      bzr installed by 'bzr selftest'.
-
-    * 'bzr selftest' command-line arguments can now be partial ids
-      of tests to run, e.g. 'bzr selftest test_weave'
+    * Test case failures have the exception printed after the log for your
+      viewing pleasure.
 
       
 bzr 0.0.9 2005-09-23

=== modified file 'NEWS.developers'
--- NEWS.developers	2005-10-06 06:31:16 +0000
+++ NEWS.developers	2005-09-23 05:57:06 +0000
@@ -8,13 +8,3 @@
 
  * Renamed Branch.last_patch() to Branch.last_revision(), since
    we call them revisions not patches.
-
- * Move copy_branch to bzrlib.clone.copy_branch.  The destination
-   directory is created if it doesn't exist.
-
- * Inventories now identify the files which were present by 
-   giving the revision *of that file*.
-
- * Inventory and Revision XML contains a version identifier.  
-   This must be consistent with the overall branch version
-   but allows for more flexibility in future upgrades.

=== modified file 'bzr'
--- bzr	2005-09-29 05:06:14 +0000
+++ bzr	2005-09-09 14:17:50 +0000
@@ -43,19 +43,10 @@
 if hasattr(os, "unsetenv"):
     os.unsetenv(REINVOKE)
 
-try:
-    import bzrlib
-    import bzrlib.commands
-    import bzrlib.trace
-except ImportError, e:
-    sys.stderr.write("bzr: ERROR: "
-                     "Couldn't import bzrlib and dependencies.\n"
-                     "Please check bzrlib is on your PYTHONPATH.\n"
-                     "\n")
-    raise
+import bzrlib
+import bzrlib.commands
+import bzrlib.trace
 
 if __name__ == '__main__':
     bzrlib.trace.enable_default_logging()
     sys.exit(bzrlib.commands.main(sys.argv))
-else:
-    pass    # should this give an error? - it can't be used as a lib

=== modified file 'bzrlib/__init__.py'
--- bzrlib/__init__.py	2005-10-06 12:34:22 +0000
+++ bzrlib/__init__.py	2005-09-23 09:20:45 +0000
@@ -39,7 +39,7 @@
 del locale
 
 __copyright__ = "Copyright 2005 Canonical Development Ltd."
-__version__ = '0.1rc1'
+__version__ = '0.0.9'
 
 
 def get_bzr_revision():

=== modified file 'bzrlib/add.py'
--- bzrlib/add.py	2005-10-03 02:10:02 +0000
+++ bzrlib/add.py	2005-09-23 09:25:16 +0000
@@ -14,7 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-from bzrlib.inventory import InventoryEntry
 from bzrlib.trace import mutter, note, warning
 from bzrlib.errors import NotBranchError
 from bzrlib.branch import Branch
@@ -96,7 +95,7 @@
 
         kind = bzrlib.osutils.file_kind(af)
 
-        if not InventoryEntry.versionable_kind(kind):
+        if kind != 'file' and kind != 'directory':
             if f in user_list:
                 raise BadFileKindError("cannot add %s of type %s" % (f, kind))
             else:

=== modified file 'bzrlib/annotate.py'
--- bzrlib/annotate.py	2005-09-30 14:27:41 +0000
+++ bzrlib/annotate.py	2005-09-22 13:32:02 +0000
@@ -51,5 +51,5 @@
     rp = b.relpath(sys.argv[1])
     tree = b.revision_tree(b.last_revision())
     file_id = tree.inventory.path2id(rp)
-    file_version = tree.inventory[file_id].revision
+    file_version = tree.inventory[file_id].text_version
     annotate_file(b, file_version, file_id, sys.stdout)

=== modified file 'bzrlib/atomicfile.py'
--- bzrlib/atomicfile.py	2005-09-29 20:34:25 +0000
+++ bzrlib/atomicfile.py	2005-09-23 09:25:16 +0000
@@ -88,6 +88,6 @@
 
 
     def __del__(self):
-        if hasattr(self, 'closed') and not self.closed:
+        if not self.closed:
             warn("%r leaked" % self)
         

=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2005-10-06 07:31:42 +0000
+++ bzrlib/branch.py	2005-09-29 02:01:49 +0000
@@ -19,12 +19,9 @@
 import os
 import errno
 from warnings import warn
-from cStringIO import StringIO
 
 
 import bzrlib
-from bzrlib.inventory import InventoryEntry
-import bzrlib.inventory as inventory
 from bzrlib.trace import mutter, note
 from bzrlib.osutils import (isdir, quotefn, compact_date, rand_bytes, 
                             rename, splitpath, sha_file, appendpath, 
@@ -32,17 +29,14 @@
 from bzrlib.errors import (BzrError, InvalidRevisionNumber, InvalidRevisionId,
                            NoSuchRevision, HistoryMissing, NotBranchError,
                            DivergedBranches, LockError, UnlistableStore,
-                           UnlistableBranch, NoSuchFile)
+                           UnlistableBranch)
 from bzrlib.textui import show_status
-from bzrlib.revision import Revision
+from bzrlib.revision import Revision, validate_revision_id, is_ancestor
 from bzrlib.delta import compare_trees
 from bzrlib.tree import EmptyTree, RevisionTree
 from bzrlib.inventory import Inventory
-from bzrlib.store import copy_all
-from bzrlib.store.compressed_text import CompressedTextStore
-from bzrlib.store.text import TextStore
-from bzrlib.store.weave import WeaveStore
-from bzrlib.transport import Transport, get_transport
+from bzrlib.weavestore import WeaveStore
+from bzrlib.store import copy_all, ImmutableStore
 import bzrlib.xml5
 import bzrlib.ui
 
@@ -61,6 +55,7 @@
     # XXX: leave this here for about one release, then remove it
     raise NotImplementedError('find_branch() is not supported anymore, '
                               'please use one of the new branch constructors')
+
 def _relpath(base, path):
     """Return path relative to base, or raise exception.
 
@@ -88,25 +83,38 @@
     return os.sep.join(s)
         
 
-def find_branch_root(t):
-    """Find the branch root enclosing the transport's base.
-
-    t is a Transport object.
-
-    It is not necessary that the base of t exists.
+def find_branch_root(f=None):
+    """Find the branch root enclosing f, or pwd.
+
+    f may be a filename or a URL.
+
+    It is not necessary that f exists.
 
     Basically we keep looking up until we find the control directory or
     run into the root.  If there isn't one, raises NotBranchError.
     """
-    orig_base = t.base
+    if f == None:
+        f = os.getcwd()
+    elif hasattr(os.path, 'realpath'):
+        f = os.path.realpath(f)
+    else:
+        f = os.path.abspath(f)
+    if not os.path.exists(f):
+        raise BzrError('%r does not exist' % f)
+        
+
+    orig_f = f
+
     while True:
-        if t.has(bzrlib.BZRDIR):
-            return t
-        new_t = t.clone('..')
-        if new_t.base == t.base:
+        if os.path.exists(os.path.join(f, bzrlib.BZRDIR)):
+            return f
+        head, tail = os.path.split(f)
+        if head == f:
             # reached the root, whatever that may be
-            raise NotBranchError('%s is not in a branch' % orig_base)
-        t = new_t
+            raise NotBranchError('%s is not in a branch' % orig_f)
+        f = head
+
+
 
 
 ######################################################################
@@ -124,18 +132,13 @@
         raise NotImplementedError('The Branch class is abstract')
 
     @staticmethod
-    def open_downlevel(base):
-        """Open a branch which may be of an old format.
-        
-        Only local branches are supported."""
-        return _Branch(get_transport(base), relax_version_check=True)
-        
-    @staticmethod
     def open(base):
         """Open an existing branch, rooted at 'base' (url)"""
-        t = get_transport(base)
-        mutter("trying to open %r with transport %r", base, t)
-        return _Branch(t)
+        if base and (base.startswith('http://') or base.startswith('https://')):
+            from bzrlib.remotebranch import RemoteBranch
+            return RemoteBranch(base, find_root=False)
+        else:
+            return LocalBranch(base, find_root=False)
 
     @staticmethod
     def open_containing(url):
@@ -143,24 +146,28 @@
         
         This probes for a branch at url, and searches upwards from there.
         """
-        t = get_transport(url)
-        t = find_branch_root(t)
-        return _Branch(t)
+        if url and (url.startswith('http://') or url.startswith('https://')):
+            from bzrlib.remotebranch import RemoteBranch
+            return RemoteBranch(url)
+        else:
+            return LocalBranch(url)
 
     @staticmethod
     def initialize(base):
         """Create a new branch, rooted at 'base' (url)"""
-        t = get_transport(base)
-        return _Branch(t, init=True)
+        if base and (base.startswith('http://') or base.startswith('https://')):
+            from bzrlib.remotebranch import RemoteBranch
+            return RemoteBranch(base, init=True)
+        else:
+            return LocalBranch(base, init=True)
 
     def setup_caching(self, cache_root):
         """Subclasses that care about caching should override this, and set
         up cached stores located under cache_root.
         """
-        self.cache_root = cache_root
-
-
-class _Branch(Branch):
+
+
+class LocalBranch(Branch):
     """A branch stored in the actual filesystem.
 
     Note that it's "local" in the context of the filesystem; it doesn't
@@ -211,18 +218,19 @@
         except UnlistableStore:
             raise UnlistableBranch(from_store)
 
-    def __init__(self, transport, init=False,
+    def __init__(self, base, init=False, find_root=True,
                  relax_version_check=False):
         """Create new branch object at a particular location.
 
-        transport -- A Transport object, defining how to access files.
-                (If a string, transport.transport() will be used to
-                create a Transport object)
+        base -- Base directory for the branch. May be a file:// url.
         
         init -- If True, create new control files in a previously
              unversioned directory.  If False, the branch must already
              be versioned.
 
+        find_root -- If true and init is false, find the root of the
+             existing branch containing base.
+
         relax_version_check -- If true, the usual check for the branch
             version is not applied.  This is intended only for
             upgrade/recovery type use; it's not guaranteed that
@@ -231,46 +239,36 @@
         In the test suite, creation of new trees is tested using the
         `ScratchBranch` class.
         """
-        assert isinstance(transport, Transport), \
-            "%r is not a Transport" % transport
-        self._transport = transport
         if init:
+            self.base = os.path.realpath(base)
             self._make_control()
+        elif find_root:
+            self.base = find_branch_root(base)
+        else:
+            if base.startswith("file://"):
+                base = base[7:]
+            self.base = os.path.realpath(base)
+            if not isdir(self.controlfilename('.')):
+                raise NotBranchError('not a bzr branch: %s' % quotefn(base),
+                                     ['use "bzr init" to initialize a '
+                                      'new working tree'])
         self._check_format(relax_version_check)
-
-        def get_store(name, compressed=True):
-            # FIXME: This approach of assuming stores are all entirely compressed
-            # or entirely uncompressed is tidy, but breaks upgrade from 
-            # some existing branches where there's a mixture; we probably 
-            # still want the option to look for both.
-            relpath = self._rel_controlfilename(name)
-            if compressed:
-                store = CompressedTextStore(self._transport.clone(relpath))
-            else:
-                store = TextStore(self._transport.clone(relpath))
-            #if self._transport.should_cache():
-            #    cache_path = os.path.join(self.cache_root, name)
-            #    os.mkdir(cache_path)
-            #    store = bzrlib.store.CachedStore(store, cache_path)
-            return store
-        def get_weave(name):
-            relpath = self._rel_controlfilename(name)
-            ws = WeaveStore(self._transport.clone(relpath))
-            if self._transport.should_cache():
-                ws.enable_cache = True
-            return ws
-
+        cfn = self.controlfilename
         if self._branch_format == 4:
-            self.inventory_store = get_store('inventory-store')
-            self.text_store = get_store('text-store')
-            self.revision_store = get_store('revision-store')
+            self.inventory_store = ImmutableStore(cfn('inventory-store'))
+            self.text_store = ImmutableStore(cfn('text-store'))
         elif self._branch_format == 5:
-            self.control_weaves = get_weave([])
-            self.weave_store = get_weave('weaves')
-            self.revision_store = get_store('revision-store', compressed=False)
+            self.control_weaves = WeaveStore(cfn([]))
+            self.weave_store = WeaveStore(cfn('weaves'))
+            if init:
+                # FIXME: Unify with make_control_files
+                self.control_weaves.put_empty_weave('inventory')
+                self.control_weaves.put_empty_weave('ancestry')
+        self.revision_store = ImmutableStore(cfn('revision-store'))
+
 
     def __str__(self):
-        return '%s(%r)' % (self.__class__.__name__, self._transport.base)
+        return '%s(%r)' % (self.__class__.__name__, self.base)
 
 
     __repr__ = __str__
@@ -283,39 +281,16 @@
             warn("branch %r was not explicitly unlocked" % self)
             self._lock.unlock()
 
-        # TODO: It might be best to do this somewhere else,
-        # but it is nice for a Branch object to automatically
-        # cache it's information.
-        # Alternatively, we could have the Transport objects cache requests
-        # See the earlier discussion about how major objects (like Branch)
-        # should never expect their __del__ function to run.
-        if hasattr(self, 'cache_root') and self.cache_root is not None:
-            try:
-                import shutil
-                shutil.rmtree(self.cache_root)
-            except:
-                pass
-            self.cache_root = None
-
-    def _get_base(self):
-        if self._transport:
-            return self._transport.base
-        return None
-
-    base = property(_get_base)
-
-
     def lock_write(self):
-        # TODO: Upgrade locking to support using a Transport,
-        # and potentially a remote locking protocol
         if self._lock_mode:
             if self._lock_mode != 'w':
                 raise LockError("can't upgrade to a write lock from %r" %
                                 self._lock_mode)
             self._lock_count += 1
         else:
-            self._lock = self._transport.lock_write(
-                    self._rel_controlfilename('branch-lock'))
+            from bzrlib.lock import WriteLock
+
+            self._lock = WriteLock(self.controlfilename('branch-lock'))
             self._lock_mode = 'w'
             self._lock_count = 1
 
@@ -326,8 +301,9 @@
                    "invalid lock mode %r" % self._lock_mode
             self._lock_count += 1
         else:
-            self._lock = self._transport.lock_read(
-                    self._rel_controlfilename('branch-lock'))
+            from bzrlib.lock import ReadLock
+
+            self._lock = ReadLock(self.controlfilename('branch-lock'))
             self._lock_mode = 'r'
             self._lock_count = 1
                         
@@ -344,23 +320,19 @@
 
     def abspath(self, name):
         """Return absolute filename for something in the branch"""
-        return self._transport.abspath(name)
+        return os.path.join(self.base, name)
 
     def relpath(self, path):
         """Return path relative to this branch of something inside it.
 
         Raises an error if path is not in this branch."""
-        return self._transport.relpath(path)
-
-
-    def _rel_controlfilename(self, file_or_path):
+        return _relpath(self.base, path)
+
+    def controlfilename(self, file_or_path):
+        """Return location relative to branch."""
         if isinstance(file_or_path, basestring):
             file_or_path = [file_or_path]
-        return [bzrlib.BZRDIR] + file_or_path
-
-    def controlfilename(self, file_or_path):
-        """Return location relative to branch."""
-        return self._transport.abspath(self._rel_controlfilename(file_or_path))
+        return os.path.join(self.base, bzrlib.BZRDIR, *file_or_path)
 
 
     def controlfile(self, file_or_path, mode='r'):
@@ -374,84 +346,42 @@
         Controlfiles should almost never be opened in write mode but
         rather should be atomically copied and replaced using atomicfile.
         """
-        import codecs
-
-        relpath = self._rel_controlfilename(file_or_path)
-        #TODO: codecs.open() buffers linewise, so it was overloaded with
-        # a much larger buffer, do we need to do the same for getreader/getwriter?
-        if mode == 'rb': 
-            return self._transport.get(relpath)
-        elif mode == 'wb':
-            raise BzrError("Branch.controlfile(mode='wb') is not supported, use put_controlfiles")
-        elif mode == 'r':
-            return codecs.getreader('utf-8')(self._transport.get(relpath), errors='replace')
-        elif mode == 'w':
-            raise BzrError("Branch.controlfile(mode='w') is not supported, use put_controlfiles")
+
+        fn = self.controlfilename(file_or_path)
+
+        if mode == 'rb' or mode == 'wb':
+            return file(fn, mode)
+        elif mode == 'r' or mode == 'w':
+            # open in binary mode anyhow so there's no newline translation;
+            # codecs uses line buffering by default; don't want that.
+            import codecs
+            return codecs.open(fn, mode + 'b', 'utf-8',
+                               buffering=60000)
         else:
             raise BzrError("invalid controlfile mode %r" % mode)
 
-    def put_controlfile(self, path, f, encode=True):
-        """Write an entry as a controlfile.
-
-        :param path: The path to put the file, relative to the .bzr control
-                     directory
-        :param f: A file-like or string object whose contents should be copied.
-        :param encode:  If true, encode the contents as utf-8
-        """
-        self.put_controlfiles([(path, f)], encode=encode)
-
-    def put_controlfiles(self, files, encode=True):
-        """Write several entries as controlfiles.
-
-        :param files: A list of [(path, file)] pairs, where the path is the directory
-                      underneath the bzr control directory
-        :param encode:  If true, encode the contents as utf-8
-        """
-        import codecs
-        ctrl_files = []
-        for path, f in files:
-            if encode:
-                if isinstance(f, basestring):
-                    f = f.encode('utf-8', 'replace')
-                else:
-                    f = codecs.getwriter('utf-8')(f, errors='replace')
-            path = self._rel_controlfilename(path)
-            ctrl_files.append((path, f))
-        self._transport.put_multi(ctrl_files)
-
     def _make_control(self):
-        from bzrlib.inventory import Inventory
-        from bzrlib.weavefile import write_weave_v5
-        from bzrlib.weave import Weave
-        
-        # Create an empty inventory
-        sio = StringIO()
+        os.mkdir(self.controlfilename([]))
+        self.controlfile('README', 'w').write(
+            "This is a Bazaar-NG control directory.\n"
+            "Do not change any files in this directory.\n")
+        self.controlfile('branch-format', 'w').write(BZR_BRANCH_FORMAT_5)
+        for d in ('text-store', 'revision-store',
+                  'weaves'):
+            os.mkdir(self.controlfilename(d))
+        for f in ('revision-history',
+                  'branch-name',
+                  'branch-lock',
+                  'pending-merges'):
+            self.controlfile(f, 'w').write('')
+        mutter('created control directory in ' + self.base)
+
         # if we want per-tree root ids then this is the place to set
         # them; they're not needed for now and so ommitted for
         # simplicity.
-        bzrlib.xml5.serializer_v5.write_inventory(Inventory(), sio)
-        empty_inv = sio.getvalue()
-        sio = StringIO()
-        bzrlib.weavefile.write_weave_v5(Weave(), sio)
-        empty_weave = sio.getvalue()
+        f = self.controlfile('inventory','w')
+        bzrlib.xml5.serializer_v5.write_inventory(Inventory(), f)
 
-        dirs = [[], 'revision-store', 'weaves']
-        files = [('README', 
-            "This is a Bazaar-NG control directory.\n"
-            "Do not change any files in this directory.\n"),
-            ('branch-format', BZR_BRANCH_FORMAT_5),
-            ('revision-history', ''),
-            ('branch-name', ''),
-            ('branch-lock', ''),
-            ('pending-merges', ''),
-            ('inventory', empty_inv),
-            ('inventory.weave', empty_weave),
-            ('ancestry.weave', empty_weave)
-        ]
-        cfn = self._rel_controlfilename
-        self._transport.mkdir_multi([cfn(d) for d in dirs])
-        self.put_controlfiles(files)
-        mutter('created control directory in ' + self._transport.base)
 
     def _check_format(self, relax_version_check):
         """Check this branch format is supported.
@@ -464,9 +394,12 @@
         """
         try:
             fmt = self.controlfile('branch-format', 'r').read()
-        except NoSuchFile:
-            raise NotBranchError(self.base)
-        mutter("got branch format %r", fmt)
+        except IOError, e:
+            if e.errno == errno.ENOENT:
+                raise NotBranchError(self.base)
+            else:
+                raise
+
         if fmt == BZR_BRANCH_FORMAT_5:
             self._branch_format = 5
         elif fmt == BZR_BRANCH_FORMAT_4:
@@ -476,8 +409,7 @@
             and self._branch_format != 5):
             raise BzrError('sorry, branch format %r not supported' % fmt,
                            ['use a different bzr version',
-                            'or remove the .bzr directory'
-                            ' and "bzr init" again'])
+                            'or remove the .bzr directory and "bzr init" again'])
 
     def get_root_id(self):
         """Return the id of this branches root"""
@@ -514,22 +446,26 @@
         That is to say, the inventory describing changes underway, that
         will be committed to the next revision.
         """
-        from cStringIO import StringIO
+        from bzrlib.atomicfile import AtomicFile
+        
         self.lock_write()
         try:
-            sio = StringIO()
-            bzrlib.xml5.serializer_v5.write_inventory(inv, sio)
-            sio.seek(0)
-            # Transport handles atomicity
-            self.put_controlfile('inventory', sio)
+            f = AtomicFile(self.controlfilename('inventory'), 'wb')
+            try:
+                bzrlib.xml5.serializer_v5.write_inventory(inv, f)
+                f.commit()
+            finally:
+                f.close()
         finally:
             self.unlock()
         
         mutter('wrote working inventory')
             
+
     inventory = property(read_working_inventory, _write_inventory, None,
                          """Inventory for the working copy.""")
 
+
     def add(self, files, ids=None):
         """Make files versioned.
 
@@ -583,11 +519,10 @@
                     kind = file_kind(fullpath)
                 except OSError:
                     # maybe something better?
-                    raise BzrError('cannot add: not a regular file, symlink or directory: %s' % quotefn(f))
+                    raise BzrError('cannot add: not a regular file or directory: %s' % quotefn(f))
 
-                if not InventoryEntry.versionable_kind(kind):
-                    raise BzrError('cannot add: not a versionable file ('
-                                   'i.e. regular file, symlink or directory): %s' % quotefn(f))
+                if kind != 'file' and kind != 'directory':
+                    raise BzrError('cannot add: not a regular file or directory: %s' % quotefn(f))
 
                 if file_id is None:
                     file_id = gen_file_id(f)
@@ -658,6 +593,7 @@
         finally:
             self.unlock()
 
+
     # FIXME: this doesn't need to be a branch method
     def set_inventory(self, new_inventory_list):
         from bzrlib.inventory import Inventory, InventoryEntry
@@ -666,17 +602,10 @@
             name = os.path.basename(path)
             if name == "":
                 continue
-            # fixme, there should be a factory function inv,add_?? 
-            if kind == 'directory':
-                inv.add(inventory.InventoryDirectory(file_id, name, parent))
-            elif kind == 'file':
-                inv.add(inventory.InventoryFile(file_id, name, parent))
-            elif kind == 'symlink':
-                inv.add(inventory.InventoryLink(file_id, name, parent))
-            else:
-                raise BzrError("unknown kind %r" % kind)
+            inv.add(InventoryEntry(file_id, name, kind, parent))
         self._write_inventory(inv)
 
+
     def unknowns(self):
         """Return all unknown files.
 
@@ -697,15 +626,22 @@
 
 
     def append_revision(self, *revision_ids):
+        from bzrlib.atomicfile import AtomicFile
+
         for revision_id in revision_ids:
             mutter("add {%s} to revision-history" % revision_id)
-        self.lock_write()
+
+        rev_history = self.revision_history()
+        rev_history.extend(revision_ids)
+
+        f = AtomicFile(self.controlfilename('revision-history'))
         try:
-            rev_history = self.revision_history()
-            rev_history.extend(revision_ids)
-            self.put_controlfile('revision-history', '\n'.join(rev_history))
+            for rev_id in rev_history:
+                print >>f, rev_id
+            f.commit()
         finally:
-            self.unlock()
+            f.close()
+
 
     def has_revision(self, revision_id):
         """True if this branch has a copy of the revision.
@@ -715,6 +651,7 @@
         return (revision_id is None
                 or revision_id in self.revision_store)
 
+
     def get_revision_xml_file(self, revision_id):
         """Return XML file object for revision object."""
         if not revision_id or not isinstance(revision_id, basestring):
@@ -729,8 +666,6 @@
         finally:
             self.unlock()
 
-    #deprecated
-    get_revision_xml = get_revision_xml_file
 
     def get_revision_xml(self, revision_id):
         return self.get_revision_xml_file(revision_id).read()
@@ -750,6 +685,7 @@
         assert r.revision_id == revision_id
         return r
 
+
     def get_revision_delta(self, revno):
         """Return the delta for one revision.
 
@@ -771,36 +707,36 @@
 
         return compare_trees(old_tree, new_tree)
 
+
     def get_revision_sha1(self, revision_id):
         """Hash the stored value of a revision, and return it."""
-        # In the future, revision entries will be signed. At that
-        # point, it is probably best *not* to include the signature
-        # in the revision hash. Because that lets you re-sign
-        # the revision, (add signatures/remove signatures) and still
-        # have all hash pointers stay consistent.
-        # But for now, just hash the contents.
         return bzrlib.osutils.sha_file(self.get_revision_xml_file(revision_id))
 
+
+    def _get_ancestry_weave(self):
+        return self.control_weaves.get_weave('ancestry')
+        
+
     def get_ancestry(self, revision_id):
         """Return a list of revision-ids integrated by a revision.
-        
-        This currently returns a list, but the ordering is not guaranteed:
-        treat it as a set.
         """
+        # strip newlines
         if revision_id is None:
             return [None]
-        w = self.control_weaves.get_weave('inventory')
-        return [None] + map(w.idx_to_name,
-                            w.inclusions([w.lookup(revision_id)]))
+        w = self._get_ancestry_weave()
+        return [None] + [l[:-1] for l in w.get_iter(w.lookup(revision_id))]
+
 
     def get_inventory_weave(self):
         return self.control_weaves.get_weave('inventory')
 
+
     def get_inventory(self, revision_id):
         """Get Inventory object by hash."""
         xml = self.get_inventory_xml(revision_id)
         return bzrlib.xml5.serializer_v5.read_inventory_from_string(xml)
 
+
     def get_inventory_xml(self, revision_id):
         """Get inventory XML as a file object."""
         try:
@@ -810,11 +746,13 @@
         except IndexError:
             raise bzrlib.errors.HistoryMissing(self, 'inventory', revision_id)
 
+
     def get_inventory_sha1(self, revision_id):
         """Return the sha1 hash of the inventory entry
         """
         return self.get_revision(revision_id).inventory_sha1
 
+
     def get_revision_inventory(self, revision_id):
         """Return inventory of a past revision."""
         # TODO: Unify this with get_inventory()
@@ -825,6 +763,7 @@
         else:
             return self.get_inventory(revision_id)
 
+
     def revision_history(self):
         """Return sequence of revision hashes on to this branch."""
         self.lock_read()
@@ -834,6 +773,7 @@
         finally:
             self.unlock()
 
+
     def common_ancestor(self, other, self_revno=None, other_revno=None):
         """
         >>> from bzrlib.commit import commit
@@ -1004,12 +944,7 @@
     def working_tree(self):
         """Return a `Tree` for the working copy."""
         from bzrlib.workingtree import WorkingTree
-        # TODO: In the future, WorkingTree should utilize Transport
-        # RobertCollins 20051003 - I don't think it should - working trees are
-        # much more complex to keep consistent than our careful .bzr subset.
-        # instead, we should say that working trees are local only, and optimise
-        # for that.
-        return WorkingTree(self._transport.base, self.read_working_inventory())
+        return WorkingTree(self.base, self.read_working_inventory())
 
 
     def basis_tree(self):
@@ -1189,8 +1124,8 @@
         These are revisions that have been merged into the working
         directory but not yet committed.
         """
-        cfn = self._rel_controlfilename('pending-merges')
-        if not self._transport.has(cfn):
+        cfn = self.controlfilename('pending-merges')
+        if not os.path.exists(cfn):
             return []
         p = []
         for l in self.controlfile('pending-merges', 'r').readlines():
@@ -1198,23 +1133,28 @@
         return p
 
 
-    def add_pending_merge(self, *revision_ids):
+    def add_pending_merge(self, revision_id):
+        validate_revision_id(revision_id)
         # TODO: Perhaps should check at this point that the
         # history of the revision is actually present?
         p = self.pending_merges()
-        updated = False
-        for rev_id in revision_ids:
-            if rev_id in p:
-                continue
-            p.append(rev_id)
-            updated = True
-        if updated:
-            self.set_pending_merges(p)
+        if revision_id in p:
+            return
+        p.append(revision_id)
+        self.set_pending_merges(p)
+
 
     def set_pending_merges(self, rev_list):
+        from bzrlib.atomicfile import AtomicFile
         self.lock_write()
         try:
-            self.put_controlfile('pending-merges', '\n'.join(rev_list))
+            f = AtomicFile(self.controlfilename('pending-merges'))
+            try:
+                for l in rev_list:
+                    print >>f, l
+                f.commit()
+            finally:
+                f.close()
         finally:
             self.unlock()
 
@@ -1271,7 +1211,7 @@
         
 
 
-class ScratchBranch(_Branch):
+class ScratchBranch(LocalBranch):
     """Special test class: a branch that cleans up after itself.
 
     >>> b = ScratchBranch()
@@ -1294,14 +1234,12 @@
         if base is None:
             base = mkdtemp()
             init = True
-        if isinstance(base, basestring):
-            base = get_transport(base)
-        _Branch.__init__(self, base, init=init)
+        LocalBranch.__init__(self, base, init=init)
         for d in dirs:
-            self._transport.mkdir(d)
+            os.mkdir(self.abspath(d))
             
         for f in files:
-            self._transport.put(f, 'content of %s' % f)
+            file(os.path.join(self.base, f), 'w').write('content of %s' % f)
 
 
     def clone(self):
@@ -1324,6 +1262,8 @@
         copytree(self.base, base, symlinks=True)
         return ScratchBranch(base=base)
 
+
+        
     def __del__(self):
         self.destroy()
 
@@ -1342,7 +1282,7 @@
                 for name in files:
                     os.chmod(os.path.join(root, name), 0700)
             rmtree(self.base)
-        self._transport = None
+        self.base = None
 
     
 
@@ -1399,3 +1339,41 @@
     return gen_file_id('TREE_ROOT')
 
 
+def copy_branch(branch_from, to_location, revision=None, basis_branch=None):
+    """Copy branch_from into the existing directory to_location.
+
+    revision
+        If not None, only revisions up to this point will be copied.
+        The head of the new branch will be that revision.  Must be a
+        revid or None.
+
+    to_location
+        The name of a local directory that exists but is empty.
+
+    revno
+        The revision to copy up to
+
+    basis_branch
+        A local branch to copy revisions from, related to branch_from
+    """
+    # TODO: This could be done *much* more efficiently by just copying
+    # all the whole weaves and revisions, rather than getting one
+    # revision at a time.
+    from bzrlib.merge import merge
+
+    assert isinstance(branch_from, Branch)
+    assert isinstance(to_location, basestring)
+    
+    br_to = Branch.initialize(to_location)
+    mutter("copy branch from %s to %s", branch_from, br_to)
+    if basis_branch is not None:
+        basis_branch.push_stores(br_to)
+    br_to.set_root_id(branch_from.get_root_id())
+    if revision is None:
+        revision = branch_from.last_revision()
+    br_to.update_revisions(branch_from, stop_revision=revision)
+    merge((to_location, -1), (to_location, 0), this_dir=to_location,
+          check_clean=False, ignore_zero=True)
+    br_to.set_parent(branch_from.base)
+    mutter("copied")
+    return br_to

=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2005-10-06 13:08:14 +0000
+++ bzrlib/builtins.py	2005-09-28 09:35:50 +0000
@@ -70,7 +70,7 @@
     # relative to a revision, or between revisions
 
     takes_args = ['file*']
-    takes_options = ['all', 'show-ids']
+    takes_options = ['all', 'show-ids', 'revision']
     aliases = ['st', 'stat']
     
     def run(self, all=False, show_ids=False, file_list=None, revision=None):
@@ -323,10 +323,9 @@
     If branches have diverged, you can use 'bzr merge' to pull the text changes
     from one into the other.
     """
-    takes_options = ['remember']
     takes_args = ['location?']
 
-    def run(self, location=None, remember=False):
+    def run(self, location=None):
         from bzrlib.merge import merge
         import tempfile
         from shutil import rmtree
@@ -338,7 +337,7 @@
             if stored_loc is None:
                 raise BzrCommandError("No pull location known or specified.")
             else:
-                print "Using saved location: %s" % stored_loc
+                print "Using last location: %s" % stored_loc
                 location = stored_loc
         cache_root = tempfile.mkdtemp()
         from bzrlib.errors import DivergedBranches
@@ -358,7 +357,7 @@
                     "  Try merge.")
                 
             merge(('.', -1), ('.', old_revno), check_clean=False)
-            if stored_loc is None or remember:
+            if location != stored_loc:
                 br_to.set_parent(location)
         finally:
             rmtree(cache_root)
@@ -383,7 +382,7 @@
     aliases = ['get', 'clone']
 
     def run(self, from_location, to_location=None, revision=None, basis=None):
-        from bzrlib.clone import copy_branch
+        from bzrlib.branch import copy_branch
         import tempfile
         import errno
         from shutil import rmtree
@@ -557,6 +556,7 @@
         bzr commit -m 'imported project'
     """
     def run(self):
+        from bzrlib.branch import Branch
         Branch.initialize('.')
 
 
@@ -652,7 +652,7 @@
         b = Branch.open_containing('.')
         td = compare_trees(b.basis_tree(), b.working_tree())
 
-        for path, id, kind, text_modified, meta_modified in td.modified:
+        for path, id, kind in td.modified:
             print path
 
 
@@ -696,10 +696,11 @@
 
     --message allows you to give a regular expression, which will be evaluated
     so that only matching entries will be displayed.
+
+    TODO: Make --revision support uuid: and hash: [future tag:] notation.
+  
     """
 
-    # TODO: Make --revision support uuid: and hash: [future tag:] notation.
-
     takes_args = ['filename?']
     takes_options = ['forward', 'timezone', 'verbose', 'show-ids', 'revision',
                      'long', 'message', 'short',]
@@ -796,9 +797,16 @@
             tree = b.working_tree()
         else:
             tree = b.revision_tree(revision.in_history(b).rev_id)
-        for fp, fc, kind, fid, entry in tree.list_files():
+
+        for fp, fc, kind, fid in tree.list_files():
             if verbose:
-                kindch = entry.kind_character()
+                if kind == 'directory':
+                    kindch = '/'
+                elif kind == 'file':
+                    kindch = ''
+                else:
+                    kindch = '???'
+
                 print '%-8s %s%s' % (fc, fp, kindch)
             else:
                 print fp
@@ -878,7 +886,7 @@
     See also: bzr ignore"""
     def run(self):
         tree = Branch.open_containing('.').working_tree()
-        for path, file_class, kind, file_id, entry in tree.list_files():
+        for path, file_class, kind, file_id in tree.list_files():
             if file_class != 'I':
                 continue
             ## XXX: Slightly inefficient since this was already calculated
@@ -928,20 +936,13 @@
                 raise BzrError('bzr export --revision takes exactly 1 argument')
             rev_id = revision[0].in_history(b).rev_id
         t = b.revision_tree(rev_id)
-        arg_root, ext = os.path.splitext(os.path.basename(dest))
-        if ext in ('.gz', '.bz2'):
-            new_root, new_ext = os.path.splitext(arg_root)
-            if new_ext == '.tar':
-                arg_root = new_root
-                ext = new_ext + ext
-        if root is None:
-            root = arg_root
+        root, ext = os.path.splitext(dest)
         if not format:
             if ext in (".tar",):
                 format = "tar"
-            elif ext in (".tar.gz", ".tgz"):
+            elif ext in (".gz", ".tgz"):
                 format = "tgz"
-            elif ext in (".tar.bz2", ".tbz2"):
+            elif ext in (".bz2", ".tbz2"):
                 format = "tbz2"
             else:
                 format = "dir"
@@ -998,7 +999,7 @@
     
     def run(self, message=None, file=None, verbose=True, selected_list=None,
             unchanged=False):
-        from bzrlib.errors import PointlessCommit, ConflictsInTree
+        from bzrlib.errors import PointlessCommit
         from bzrlib.msgeditor import edit_commit_message
         from bzrlib.status import show_status
         from cStringIO import StringIO
@@ -1006,14 +1007,13 @@
         b = Branch.open_containing('.')
         if selected_list:
             selected_list = [b.relpath(s) for s in selected_list]
-
             
-        if message is None and not file:
+        if not message and not file:
             catcher = StringIO()
             show_status(b, specific_files=selected_list,
                         to_file=catcher)
             message = edit_commit_message(catcher.getvalue())
-
+            
             if message is None:
                 raise BzrCommandError("please specify a commit message"
                                       " with either --message or --file")
@@ -1024,9 +1024,6 @@
             import codecs
             message = codecs.open(file, 'rt', bzrlib.user_encoding).read()
 
-        if message == "":
-                raise BzrCommandError("empty commit message specified")
-            
         try:
             b.commit(message,
                      specific_files=selected_list,
@@ -1036,9 +1033,6 @@
             # perhaps prepare the commit; get the message; then actually commit
             raise BzrCommandError("no changes to commit",
                                   ["use --unchanged to commit anyhow"])
-        except ConflictsInTree:
-            raise BzrCommandError("Conflicts detected in working tree.  "
-                'Use "bzr conflicts" to list, "bzr resolve FILE" to resolve.')
 
 
 class cmd_check(Command):
@@ -1108,20 +1102,10 @@
 
 
 class cmd_selftest(Command):
-    """Run internal test suite.
-    
-    This creates temporary test directories in the working directory,
-    but not existing data is affected.  These directories are deleted
-    if the tests pass, or left behind to help in debugging if they
-    fail.
-    
-    If arguments are given, they are regular expressions that say
-    which tests should run."""
-    # TODO: --list should give a list of all available tests
+    """Run internal test suite"""
     hidden = True
-    takes_args = ['testnames*']
     takes_options = ['verbose', 'pattern']
-    def run(self, testnames_list=None, verbose=False, pattern=".*"):
+    def run(self, verbose=False, pattern=".*"):
         import bzrlib.ui
         from bzrlib.selftest import selftest
         # we don't want progress meters from the tests to go to the
@@ -1131,9 +1115,7 @@
         bzrlib.trace.info('running tests...')
         try:
             bzrlib.ui.ui_factory = bzrlib.ui.SilentUIFactory()
-            result = selftest(verbose=verbose, 
-                              pattern=pattern,
-                              testnames=testnames_list)
+            result = selftest(verbose=verbose, pattern=pattern)
             if result:
                 bzrlib.trace.info('tests passed')
             else:
@@ -1239,18 +1221,13 @@
     takes_args = ['branch?']
     takes_options = ['revision', 'force', 'merge-type']
 
-    def run(self, branch=None, revision=None, force=False, 
+    def run(self, branch='.', revision=None, force=False, 
             merge_type=None):
         from bzrlib.merge import merge
         from bzrlib.merge_core import ApplyMerge3
         if merge_type is None:
             merge_type = ApplyMerge3
-        if branch is None:
-            branch = Branch.open_containing('.').get_parent()
-            if branch is None:
-                raise BzrCommandError("No merge location known or specified.")
-            else:
-                print "Using saved location: %s" % branch 
+
         if revision is None or len(revision) < 1:
             base = [None, None]
             other = [branch, -1]
@@ -1263,6 +1240,7 @@
                 if None in revision:
                     raise BzrCommandError(
                         "Merge doesn't permit that revision specifier.")
+                from bzrlib.branch import Branch
                 b = Branch.open(branch)
 
                 base = [branch, revision[0].in_history(b).revno]
@@ -1293,6 +1271,7 @@
 
     def run(self, revision=None, no_backup=False, file_list=None):
         from bzrlib.merge import merge
+        from bzrlib.branch import Branch
         from bzrlib.commands import parse_spec
 
         if file_list is not None:
@@ -1397,9 +1376,11 @@
             # should not change the parent
             b.set_parent(remote)
         br_remote = Branch.open_containing(remote)
+
         return show_missing(b, br_remote, verbose=verbose, quiet=quiet)
 
 
+
 class cmd_plugins(Command):
     """List plugins"""
     hidden = True

=== modified file 'bzrlib/changeset.py'
--- bzrlib/changeset.py	2005-10-03 19:50:36 +0000
+++ bzrlib/changeset.py	2005-09-26 08:56:15 +0000
@@ -19,7 +19,6 @@
 import stat
 from bzrlib.trace import mutter
 from bzrlib.osutils import rename
-import bzrlib
 
 # XXX: mbp: I'm not totally convinced that we should handle conflicts
 # as part of changeset application, rather than only in the merge
@@ -358,10 +357,9 @@
         else:
             assert(status == 1)
             def get_lines(filename):
-                my_file = file(filename, "rb")
+                my_file = file(base, "rb")
                 lines = my_file.readlines()
                 my_file.close()
-                return lines
             base_lines = get_lines(base)
             other_lines = get_lines(other)
             conflict_handler.merge_conflict(new_file, filename, base_lines, 
@@ -864,7 +862,7 @@
             continue
         new_path = os.path.join(dir, new_tree_path)
         old_path = changed_inventory.get(entry.id)
-        if bzrlib.osutils.lexists(new_path):
+        if os.path.exists(new_path):
             if conflict_handler.target_exists(entry, new_path, old_path) == \
                 "skip":
                 continue
@@ -1385,20 +1383,18 @@
 
         if cs_entry is None:
             return None
+        if id in self.tree_a and id in self.tree_b:
+            a_sha1 = self.tree_a.get_file_sha1(id)
+            b_sha1 = self.tree_b.get_file_sha1(id)
+            if None not in (a_sha1, b_sha1) and a_sha1 == b_sha1:
+                return cs_entry
 
         full_path_a = self.tree_a.readonly_path(id)
         full_path_b = self.tree_b.readonly_path(id)
         stat_a = self.lstat(full_path_a)
         stat_b = self.lstat(full_path_b)
-
+        
         cs_entry.metadata_change = self.make_mode_change(stat_a, stat_b)
-
-        if id in self.tree_a and id in self.tree_b:
-            a_sha1 = self.tree_a.get_file_sha1(id)
-            b_sha1 = self.tree_b.get_file_sha1(id)
-            if None not in (a_sha1, b_sha1) and a_sha1 == b_sha1:
-                return cs_entry
-
         cs_entry.contents_change = self.make_contents_change(full_path_a,
                                                              stat_a, 
                                                              full_path_b, 

=== modified file 'bzrlib/check.py'
--- bzrlib/check.py	2005-09-30 02:54:51 +0000
+++ bzrlib/check.py	2005-09-27 07:24:40 +0000
@@ -28,7 +28,7 @@
 
 import bzrlib.ui
 from bzrlib.trace import note, warning
-from bzrlib.osutils import rename, sha_string, fingerprint_file
+from bzrlib.osutils import rename, sha_string, fingerprint_file, sha_strings
 from bzrlib.trace import mutter
 from bzrlib.errors import BzrCheckError, NoSuchRevision
 from bzrlib.inventory import ROOT_ID
@@ -148,8 +148,7 @@
                                     % (file_id, rev_id))
             seen_ids[file_id] = True
         for file_id in inv:
-            ie = inv[file_id]
-            ie.check(self, rev_id, inv, tree)
+            self._check_one_entry(rev_id, inv, tree, file_id)
         seen_names = {}
         for path, ie in inv.iter_entries():
             if path in seen_names:
@@ -158,6 +157,42 @@
                                     % (path, rev_id))
             seen_names[path] = True
 
+        
+    def _check_one_entry(self, rev_id, inv, tree, file_id):
+        ie = inv[file_id]
+        if ie.parent_id != None:
+            if not inv.has_id(ie.parent_id):
+                raise BzrCheckError('missing parent {%s} in inventory for revision {%s}'
+                        % (ie.parent_id, rev_id))
+        if ie.kind == 'file':
+            text_version = ie.text_version
+            t = (file_id, text_version)
+            if t in self.checked_texts:
+                prev_sha = self.checked_texts[t] 
+                if prev_sha != ie.text_sha1:
+                    raise BzrCheckError('mismatched sha1 on {%s} in {%s}' %
+                                        (file_id, rev_id))
+                else:
+                    self.repeated_text_cnt += 1
+                    return
+            mutter('check version {%s} of {%s}', rev_id, file_id)
+            file_lines = tree.get_file_lines(file_id)
+            self.checked_text_cnt += 1 
+            if ie.text_size != sum(map(len, file_lines)):
+                raise BzrCheckError('text {%s} wrong size' % ie.text_id)
+            if ie.text_sha1 != sha_strings(file_lines):
+                raise BzrCheckError('text {%s} wrong sha1' % ie.text_id)
+            self.checked_texts[t] = ie.text_sha1
+        elif ie.kind == 'directory':
+            if ie.text_sha1 != None or ie.text_size != None or ie.text_id != None:
+                raise BzrCheckError('directory {%s} has text in revision {%s}'
+                        % (file_id, rev_id))
+        elif ie.kind == 'root_directory':
+            pass
+        else:
+            raise BzrCheckError('unknown entry kind %r in revision {%s}' % 
+                                (ie.kind, rev_id))
+
 
 def check(branch):
     """Run consistency checks on a branch."""

=== removed file 'bzrlib/clone.py'
--- bzrlib/clone.py	2005-10-06 06:31:33 +0000
+++ bzrlib/clone.py	1970-01-01 00:00:00 +0000
@@ -1,157 +0,0 @@
-# Copyright (C) 2004, 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Make a copy of an entire branch and all its history.
-
-This is the underlying function for the branch/get/clone commands."""
-
-# TODO: This could be done *much* more efficiently by just copying
-# all the whole weaves and revisions, rather than getting one
-# revision at a time.
-
-# TODO: Optionally, after copying, discard any irrelevant information from
-# the destination, such as revisions committed after the last one we're interested 
-# in.  This needs to apply a weave prune operation (not written yet) to each
-# weave one by one.
-
-# Copying must be done in a way that supports http transports, where we
-# can't list a directory, and therefore have to rely on information
-# retrieved from top-level objects whose names we do know.
-#
-# In practice this means we first fetch the revision history and ancestry.
-# These give us a list of all the revisions that need to be fetched.  We 
-# also get the inventory weave.  We then just need to get a list of all 
-# file-ids ever referenced by this tree.  (It might be nice to keep a list
-# of them directly.)  This is done by walking over the inventories of all
-# copied revisions and accumulating a list of file ids.
-#
-# For local branches it is possible to optimize this considerably in two
-# ways.  One is to hardlink the files (if possible and requested), rather
-# than copying them.  Another is to simply list the directory rather than
-# walking through the inventories to find out what files are present -- but
-# there it may be better to just be consistent with remote branches.
-
-import os
-import sys
-
-import bzrlib
-from bzrlib.merge import build_working_dir
-from bzrlib.branch import Branch
-from bzrlib.trace import mutter, note
-from bzrlib.store import copy_all
-
-def copy_branch(branch_from, to_location, revision=None, basis_branch=None):
-    """Copy branch_from into the existing directory to_location.
-
-    Returns the newly created branch object.
-
-    revision
-        If not None, only revisions up to this point will be copied.
-        The head of the new branch will be that revision.  Must be a
-        revid or None.
-
-    to_location -- The destination directory; must either exist and be 
-        empty, or not exist, in which case it is created.
-
-    basis_branch
-        A local branch to copy revisions from, related to branch_from. 
-        This is used when branching from a remote (slow) branch, and we have
-        a local branch that might contain some relevant revisions.
-    """
-    assert isinstance(branch_from, Branch)
-    assert isinstance(to_location, basestring)
-    if basis_branch is not None:
-        note("basis_branch is not supported for fast weave copy yet.")
-    if not (branch_from.weave_store.listable()
-            and branch_from.revision_store.listable()):
-        return copy_branch_slower(branch_from, to_location, revision,
-                                  basis_branch)
-    history = _get_truncated_history(branch_from, revision)
-    if not bzrlib.osutils.lexists(to_location):
-        os.mkdir(to_location)
-    branch_to = Branch.initialize(to_location)
-    mutter("copy branch from %s to %s", branch_from, branch_to)
-    branch_to.set_root_id(branch_from.get_root_id())
-    branch_to.append_revision(*history)
-    _copy_control_weaves(branch_from, branch_to)
-    _copy_text_weaves(branch_from, branch_to)
-    _copy_revision_store(branch_from, branch_to)
-    build_working_dir(to_location)
-    branch_to.set_parent(branch_from.base)
-    mutter("copied")
-    return branch_to
-
-
-def _get_truncated_history(branch_from, revision):
-    history = branch_from.revision_history()
-    if revision is None:
-        return history
-    try:
-        idx = history.index(revision)
-    except ValueError:
-        raise InvalidRevisionId('revision {%s} is not on the mainline of %s' 
-                                % (revision, branch_from))
-    return history[:idx+1]
-
-def _copy_text_weaves(branch_from, branch_to):
-    copy_all(branch_from.weave_store, branch_to.weave_store)
-
-
-def _copy_revision_store(branch_from, branch_to):
-    copy_all(branch_from.revision_store, branch_to.revision_store)
-
-
-def _copy_control_weaves(branch_from, branch_to):
-    to_control = branch_to.control_weaves
-    from_control = branch_from.control_weaves
-    to_control.copy_multi(from_control, ['inventory'])
-
-    
-def copy_branch_slower(branch_from, to_location, revision=None, basis_branch=None):
-    """Copy branch_from into the existing directory to_location.
-
-    revision
-        If not None, only revisions up to this point will be copied.
-        The head of the new branch will be that revision.  Must be a
-        revid or None.
-
-    to_location -- The destination directory; must either exist and be 
-        empty, or not exist, in which case it is created.
-
-    revno
-        The revision to copy up to
-
-    basis_branch
-        A local branch to copy revisions from, related to branch_from. 
-        This is used when branching from a remote (slow) branch, and we have
-        a local branch that might contain some relevant revisions.
-    """
-    assert isinstance(branch_from, Branch)
-    assert isinstance(to_location, basestring)
-    if not bzrlib.osutils.lexists(to_location):
-        os.mkdir(to_location)
-    br_to = Branch.initialize(to_location)
-    mutter("copy branch from %s to %s", branch_from, br_to)
-    if basis_branch is not None:
-        basis_branch.push_stores(br_to)
-    br_to.set_root_id(branch_from.get_root_id())
-    if revision is None:
-        revision = branch_from.last_revision()
-    br_to.update_revisions(branch_from, stop_revision=revision)
-    build_working_dir(to_location)
-    br_to.set_parent(branch_from.base)
-    mutter("copied")
-    return br_to

=== modified file 'bzrlib/commands.py'
--- bzrlib/commands.py	2005-10-06 13:08:14 +0000
+++ bzrlib/commands.py	2005-09-28 09:35:50 +0000
@@ -24,8 +24,14 @@
 # Those objects can specify the expected type of the argument, which
 # would help with validation and shell completion.
 
-# TODO: "--profile=cum", to change sort order.  Is there any value in leaving
-# the profile output behind so it can be interactively examined?
+
+# TODO: Help messages for options.
+
+# TODO: Define arguments by objects, rather than just using names.
+# Those objects can specify the expected type of the argument, which
+# would help with validation and shell completion.
+
+
 
 import sys
 import os
@@ -355,7 +361,6 @@
     'root':                   str,
     'no-backup':              None,
     'pattern':                str,
-    'remember':               None,
     }
 
 SHORT_OPTIONS = {
@@ -520,7 +525,6 @@
 def apply_profiled(the_callable, *args, **kwargs):
     import hotshot
     import tempfile
-    import hotshot.stats
     pffileno, pfname = tempfile.mkstemp()
     try:
         prof = hotshot.Profile(pfname)
@@ -528,12 +532,15 @@
             ret = prof.runcall(the_callable, *args, **kwargs) or 0
         finally:
             prof.close()
+
+        import hotshot.stats
         stats = hotshot.stats.load(pfname)
-        stats.strip_dirs()
-        stats.sort_stats('cum')   # 'time'
+        #stats.strip_dirs()
+        stats.sort_stats('time')
         ## XXX: Might like to write to stderr or the trace file instead but
         ## print_stats seems hardcoded to stdout
         stats.print_stats(20)
+
         return ret
     finally:
         os.close(pffileno)
@@ -564,8 +571,6 @@
     --profile
         Run under the Python profiler.
     """
-    # Load all of the transport methods
-    import bzrlib.transport.local, bzrlib.transport.http
     
     argv = [a.decode(bzrlib.user_encoding) for a in argv]
 
@@ -625,10 +630,14 @@
 def run_bzr_catch_errors(argv):
     try:
         try:
-            return run_bzr(argv)
-        finally:
-            # do this here inside the exception wrappers to catch EPIPE
-            sys.stdout.flush()
+            try:
+                return run_bzr(argv)
+            finally:
+                # do this here inside the exception wrappers to catch EPIPE
+                sys.stdout.flush()
+        #wrap common errors as CommandErrors.
+        except (NotBranchError,), e:
+            raise BzrCommandError(str(e))
     except BzrCommandError, e:
         # command line syntax error, etc
         log_error(str(e))
@@ -650,10 +659,9 @@
             bzrlib.trace.note('broken pipe')
             return 2
         else:
-            ## import pdb
-            ## pdb.pm()
             bzrlib.trace.log_exception()
             return 2
 
+
 if __name__ == '__main__':
     sys.exit(main(sys.argv))

=== modified file 'bzrlib/commit.py'
--- bzrlib/commit.py	2005-10-06 13:08:14 +0000
+++ bzrlib/commit.py	2005-09-29 00:24:44 +0000
@@ -44,6 +44,11 @@
 # TODO: Update hashcache before and after - or does the WorkingTree
 # look after that?
 
+# This code requires all merge parents to be present in the branch.
+# We could relax this but for the sake of simplicity the constraint is
+# here for now.  It's not totally clear to me how we'd know which file
+# need new text versions if some parents are absent.  -- mbp 20050915
+
 # TODO: Rather than mashing together the ancestry and storing it back,
 # perhaps the weave should have single method which does it all in one
 # go, avoiding a lot of redundant work.
@@ -74,12 +79,11 @@
 from bzrlib.branch import gen_file_id
 from bzrlib.errors import (BzrError, PointlessCommit,
                            HistoryMissing,
-                           ConflictsInTree
                            )
 from bzrlib.revision import Revision
 from bzrlib.trace import mutter, note, warning
 from bzrlib.xml5 import serializer_v5
-from bzrlib.inventory import Inventory, ROOT_ID
+from bzrlib.inventory import Inventory
 from bzrlib.weave import Weave
 from bzrlib.weavefile import read_weave, write_weave_v5
 from bzrlib.atomicfile import AtomicFile
@@ -98,38 +102,26 @@
 
 class NullCommitReporter(object):
     """I report on progress of a commit."""
-
-    def snapshot_change(self, change, path):
-        pass
-
-    def completed(self, revno, rev_id):
-        pass
-
-    def deleted(self, file_id):
-        pass
-
-    def escaped(self, escape_count, message):
-        pass
-
-    def missing(self, path):
-        pass
+    def added(self, path):
+        pass
+
+    def removed(self, path):
+        pass
+
+    def renamed(self, old_path, new_path):
+        pass
+
 
 class ReportCommitToLog(NullCommitReporter):
-
-    def snapshot_change(self, change, path):
-        note("%s %s", change, path)
-
-    def completed(self, revno, rev_id):
-        note('committed r%d {%s}', revno, rev_id)
-    
-    def deleted(self, file_id):
-        note('deleted %s', file_id)
-
-    def escaped(self, escape_count, message):
-        note("replaced %d control characters in message", escape_count)
-
-    def missing(self, path):
-        note('missing %s', path)
+    def added(self, path):
+        note('added %s', path)
+
+    def removed(self, path):
+        note('removed %s', path)
+
+    def renamed(self, old_path, new_path):
+        note('renamed %s => %s', old_path, new_path)
+
 
 class Commit(object):
     """Task of committing a new revision.
@@ -222,33 +214,35 @@
             self._check_parents_present()
             
             self._remove_deleted()
-            self._populate_new_inv()
-            self._store_snapshot()
+            self.new_inv = Inventory()
+            self._store_entries()
             self._report_deletes()
+            self._set_name_versions()
 
             if not (self.allow_pointless
                     or len(self.parents) > 1
                     or self.new_inv != self.basis_inv):
                 raise PointlessCommit()
 
-            if len(list(self.work_tree.iter_conflicts()))>0:
-                raise ConflictsInTree
-
             self._record_inventory()
+            self._record_ancestry()
             self._make_revision()
-            self.reporter.completed(self.branch.revno()+1, self.rev_id)
+            note('committed r%d {%s}', (self.branch.revno() + 1),
+                 self.rev_id)
             self.branch.append_revision(self.rev_id)
             self.branch.set_pending_merges([])
         finally:
             self.branch.unlock()
 
+
+
     def _record_inventory(self):
         """Store the inventory for the new revision."""
         inv_text = serializer_v5.write_inventory_to_string(self.new_inv)
         self.inv_sha1 = sha_string(inv_text)
         s = self.branch.control_weaves
         s.add_text('inventory', self.rev_id,
-                   split_lines(inv_text), self.present_parents)
+                   split_lines(inv_text), self.parents)
 
     def _escape_commit_message(self):
         """Replace xml-incompatible control characters."""
@@ -267,32 +261,49 @@
             lambda match: match.group(0).encode('unicode_escape'),
             self.message)
         if escape_count:
-            self.reporter.escaped(escape_count, self.message)
+            note("replaced %d control characters in message", escape_count)
+
+    def _record_ancestry(self):
+        """Append merged revision ancestry to the ancestry file.
+
+        This should be the merged ancestry of all parents, plus the
+        new revision id."""
+        s = self.branch.control_weaves
+        w = s.get_weave_or_empty('ancestry')
+        lines = self._make_ancestry(w)
+        w.add(self.rev_id, self.parents, lines)
+        s.put_weave('ancestry', w)
+
+
+    def _make_ancestry(self, ancestry_weave):
+        """Return merged ancestry lines.
+
+        The lines are revision-ids followed by newlines."""
+        parent_ancestries = [ancestry_weave.get(p) for p in self.parents]
+        new_lines = merge_ancestry_lines(self.rev_id, parent_ancestries)
+        mutter('merged ancestry of {%s}:\n%s', self.rev_id, ''.join(new_lines))
+        return new_lines
+
 
     def _gather_parents(self):
-        """Record the parents of a merge for merge detection."""
         pending_merges = self.branch.pending_merges()
         self.parents = []
-        self.parent_invs = []
-        self.present_parents = []
+        self.parent_trees = []
         precursor_id = self.branch.last_revision()
         if precursor_id:
             self.parents.append(precursor_id)
+            self.parent_trees.append(self.basis_tree)
         self.parents += pending_merges
-        for revision in self.parents:
-            if self.branch.has_revision(revision):
-                self.parent_invs.append(self.branch.get_inventory(revision))
-                self.present_parents.append(revision)
+        self.parent_trees.extend(map(self.branch.revision_tree, pending_merges))
+
 
     def _check_parents_present(self):
         for parent_id in self.parents:
             mutter('commit parent revision {%s}', parent_id)
             if not self.branch.has_revision(parent_id):
-                if parent_id == self.branch.last_revision():
-                    warning("parent is missing %r", parent_id)
-                    raise HistoryMissing(self.branch, 'revision', parent_id)
-                else:
-                    mutter("commit will ghost revision %r", parent_id)
+                warning("can't commit a merge from an absent parent")
+                raise HistoryMissing(self.branch, 'revision', parent_id)
+
             
     def _make_revision(self):
         """Record a new revision object for this commit."""
@@ -306,9 +317,10 @@
         rev_tmp = StringIO()
         serializer_v5.write_revision(self.rev, rev_tmp)
         rev_tmp.seek(0)
-        self.branch.revision_store.add(rev_tmp, self.rev_id)
+        self.branch.revision_store.add(rev_tmp, self.rev_id, compressed=True)
         mutter('new revision_id is {%s}', self.rev_id)
 
+
     def _remove_deleted(self):
         """Remove deleted files from the working inventories.
 
@@ -326,92 +338,197 @@
             if specific and not is_inside_any(specific, path):
                 continue
             if not self.work_tree.has_filename(path):
-                self.reporter.missing(path)
-                deleted_ids.append((path, ie.file_id))
+                note('missing %s', path)
+                deleted_ids.append(ie.file_id)
         if deleted_ids:
-            deleted_ids.sort(reverse=True)
-            for path, file_id in deleted_ids:
+            for file_id in deleted_ids:
                 del self.work_inv[file_id]
             self.branch._write_inventory(self.work_inv)
 
-    def _store_snapshot(self):
-        """Pass over inventory and record a snapshot.
-
-        Entries get a new revision when they are modified in 
-        any way, which includes a merge with a new set of
-        parents that have the same entry. 
-        """
+
+    def _find_file_parents(self, file_id):
+        """Return the text versions and hashes for all file parents.
+
+        Returned as a map from text version to inventory entry.
+
+        This is a set containing the file versions in all parents
+        revisions containing the file.  If the file is new, the set
+        will be empty."""
+        r = {}
+        for tree in self.parent_trees:
+            if file_id in tree.inventory:
+                ie = tree.inventory[file_id]
+                assert ie.kind == 'file'
+                assert ie.file_id == file_id
+                if ie.text_version in r:
+                    assert r[ie.text_version] == ie
+                else:
+                    r[ie.text_version] = ie
+        return r
+
+
+    def _set_name_versions(self):
+        """Pass over inventory and mark new entry version as needed.
+
+        Files get a new name version when they are new, have a
+        different parent, or a different name from in the
+        basis inventory, or if the file is in a different place
+        to any of the parents."""
         # XXX: Need to think more here about when the user has
         # made a specific decision on a particular value -- c.f.
         # mark-merge.  
         for path, ie in self.new_inv.iter_entries():
-            previous_entries = ie.find_previous_heads(
-                self.parent_invs, 
-                self.weave_store.get_weave_or_empty(ie.file_id))
-            if ie.revision is None:
-                change = ie.snapshot(self.rev_id, path, previous_entries,
-                                     self.work_tree, self.weave_store)
+            old_version = None
+            file_id = ie.file_id
+            for parent_tree in self.parent_trees:
+                parent_inv = parent_tree.inventory
+                if file_id not in parent_inv:
+                    continue
+                parent_ie = parent_inv[file_id]
+                if parent_ie.parent_id != ie.parent_id:
+                    old_version = None
+                    break
+                elif parent_ie.name != ie.name:
+                    old_version = None
+                    break
+                elif old_version is None:
+                    old_version = parent_ie.name_version
+                elif old_version != parent_ie.name_version:
+                    old_version = None
+                    break
+                else:
+                    pass                # so far so good
+            if old_version is None:
+                mutter('new name_version for {%s}', file_id)
+                ie.name_version = self.rev_id
             else:
-                change = "unchanged"
-            self.reporter.snapshot_change(change, path)
-
-    def _populate_new_inv(self):
-        """Build revision inventory.
-
-        This creates a new empty inventory. Depending on
-        which files are selected for commit, and what is present in the
-        current tree, the new inventory is populated. inventory entries 
-        which are candidates for modification have their revision set to
-        None; inventory entries that are carried over untouched have their
-        revision set to their prior value.
+                mutter('name_version for {%s} inherited as {%s}',
+                       file_id, old_version)
+                ie.name_version = old_version
+
+
+    def _store_entries(self):
+        """Build revision inventory and store modified files.
+
+        This is called with new_inv a new empty inventory.  Depending on
+        which files are selected for commit, and which ones have
+        been modified or merged, new inventory entries are built
+        based on the working and parent inventories.
+
+        As a side-effect this stores new text versions for committed
+        files with text changes or merges.
+
+        Each entry can have one of several things happen:
+
+        carry_file -- carried from the previous version (if not
+            selected for commit)
+
+        commit_nonfile -- no text to worry about
+
+        commit_old_text -- same text, may have moved
+
+        commit_file -- new text version
         """
-        mutter("Selecting files for commit with filter %s", self.specific_files)
-        self.new_inv = Inventory()
         for path, new_ie in self.work_inv.iter_entries():
             file_id = new_ie.file_id
             mutter('check %s {%s}', path, new_ie.file_id)
             if self.specific_files:
                 if not is_inside_any(self.specific_files, path):
                     mutter('%s not selected for commit', path)
-                    self._carry_entry(file_id)
-                    continue
-                else:
-                    # this is selected, ensure its parents are too.
-                    parent_id = new_ie.parent_id
-                    while parent_id != ROOT_ID:
-                        if not self.new_inv.has_id(parent_id):
-                            ie = self._select_entry(self.work_inv[parent_id])
-                            mutter('%s selected for commit because of %s',
-                                   self.new_inv.id2path(parent_id), path)
-
-                        ie = self.new_inv[parent_id]
-                        if ie.revision is not None:
-                            ie.revision = None
-                            mutter('%s selected for commit because of %s',
-                                   self.new_inv.id2path(parent_id), path)
-                        parent_id = ie.parent_id
-            mutter('%s selected for commit', path)
-            self._select_entry(new_ie)
-
-    def _select_entry(self, new_ie):
-        """Make new_ie be considered for committing."""
-        ie = new_ie.copy()
-        ie.revision = None
-        self.new_inv.add(ie)
-        return ie
-
-    def _carry_entry(self, file_id):
+                    self._carry_file(file_id)
+                    continue
+            if new_ie.kind != 'file':
+                self._commit_nonfile(file_id)
+                continue
+            
+            file_parents = self._find_file_parents(file_id)
+            mutter('parents of %s are %r', path, file_parents)
+            if len(file_parents) == 1:
+                parent_ie = file_parents.values()[0]
+                wc_sha1 = self.work_tree.get_file_sha1(file_id)
+                if parent_ie.text_sha1 == wc_sha1:
+                    # text not changed or merged
+                    self._commit_old_text(file_id, parent_ie)
+                    continue
+            # file is either new, or a file merge; need to record
+            # a new version
+            if len(file_parents) > 1:
+                note('merged %s', path)
+            elif len(file_parents) == 0:
+                note('added %s', path)
+            else:
+                note('modified %s', path)
+            self._commit_file(new_ie, file_id, file_parents)
+
+
+    def _commit_nonfile(self, file_id):
+        self.new_inv.add(self.work_inv[file_id].copy())
+
+
+    def _carry_file(self, file_id):
         """Carry the file unchanged from the basis revision."""
         if self.basis_inv.has_id(file_id):
             self.new_inv.add(self.basis_inv[file_id].copy())
 
+
+    def _commit_old_text(self, file_id, parent_ie):
+        """Keep the same text as last time, but possibly a different name."""
+        ie = self.work_inv[file_id].copy()
+        ie.text_version = parent_ie.text_version
+        ie.text_size = parent_ie.text_size
+        ie.text_sha1 = parent_ie.text_sha1
+        self.new_inv.add(ie)
+
+
     def _report_deletes(self):
         for file_id in self.basis_inv:
             if file_id not in self.new_inv:
-                self.reporter.deleted(self.basis_inv.id2path(file_id))
+                note('deleted %s', self.basis_inv.id2path(file_id))
+
+
+    def _commit_file(self, new_ie, file_id, file_parents):                    
+        mutter('store new text for {%s} in revision {%s}',
+               file_id, self.rev_id)
+        new_lines = self.work_tree.get_file(file_id).readlines()
+        self._add_text_to_weave(file_id, new_lines, file_parents)
+        new_ie.text_version = self.rev_id
+        new_ie.text_sha1 = sha_strings(new_lines)
+        new_ie.text_size = sum(map(len, new_lines))
+        self.new_inv.add(new_ie)
+
+
+    def _add_text_to_weave(self, file_id, new_lines, parents):
+        self.weave_store.add_text(file_id, self.rev_id, new_lines, parents)
+
 
 def _gen_revision_id(branch, when):
     """Return new revision-id."""
     s = '%s-%s-' % (user_email(branch), compact_date(when))
     s += hexlify(rand_bytes(8))
     return s
+
+
+
+    
+def merge_ancestry_lines(rev_id, ancestries):
+    """Return merged ancestry lines.
+
+    rev_id -- id of the new revision
+    
+    ancestries -- a sequence of ancestries for parent revisions,
+        as newline-terminated line lists.
+    """
+    if len(ancestries) == 0:
+        return [rev_id + '\n']
+    seen = set(ancestries[0])
+    ancs = ancestries[0][:]    
+    for parent_ancestry in ancestries[1:]:
+        for line in parent_ancestry:
+            assert line[-1] == '\n'
+            if line not in seen:
+                ancs.append(line)
+                seen.add(line)
+    r = rev_id + '\n'
+    assert r not in seen
+    ancs.append(r)
+    return ancs

=== modified file 'bzrlib/delta.py'
--- bzrlib/delta.py	2005-10-03 03:30:02 +0000
+++ bzrlib/delta.py	2005-09-27 07:24:40 +0000
@@ -14,7 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-from bzrlib.inventory import InventoryEntry
 from bzrlib.trace import mutter
 
 class TreeDelta(object):
@@ -27,18 +26,16 @@
     removed
         (path, id, kind)
     renamed
-        (oldpath, newpath, id, kind, text_modified, meta_modified)
+        (oldpath, newpath, id, kind, text_modified)
     modified
-        (path, id, kind, text_modified, meta_modified)
+        (path, id, kind)
     unchanged
         (path, id, kind)
 
     Each id is listed only once.
 
     Files that are both modified and renamed are listed only in
-    renamed, with the text_modified flag true. The text_modified
-    applies either to the the content of the file or the target of the
-    symbolic link, depending of the kind of file.
+    renamed, with the text_modified flag true.
 
     Files are only considered renamed if their name has changed or
     their parent directory has changed.  Renaming a directory
@@ -90,17 +87,12 @@
 
     def show(self, to_file, show_ids=False, show_unchanged=False):
         def show_list(files):
-            for item in files:
-                path, fid, kind = item[:3]
-
+            for path, fid, kind in files:
                 if kind == 'directory':
                     path += '/'
                 elif kind == 'symlink':
                     path += '@'
-
-                if len(item) == 5 and item[4]:
-                    path += '*'
-
+                    
                 if show_ids:
                     print >>to_file, '  %-30s %s' % (path, fid)
                 else:
@@ -116,10 +108,7 @@
 
         if self.renamed:
             print >>to_file, 'renamed:'
-            for (oldpath, newpath, fid, kind,
-                 text_modified, meta_modified) in self.renamed:
-                if meta_modified:
-                    newpath += '*'
+            for oldpath, newpath, fid, kind, text_modified in self.renamed:
                 if show_ids:
                     print >>to_file, '  %s => %s %s' % (oldpath, newpath, fid)
                 else:
@@ -172,7 +161,7 @@
             kind = old_ie.kind
             assert kind == new_ie.kind
             
-            assert kind in InventoryEntry.known_kinds, \
+            assert kind in ('file', 'directory', 'symlink', 'root_directory'), \
                    'invalid file kind %r' % kind
 
             if kind == 'root_directory':
@@ -183,13 +172,13 @@
                     and not is_inside_any(specific_files, new_inv.id2path(file_id))):
                     continue
 
-            # temporary hack until all entries are populated before clients 
-            # get them
-            old_path = old_inv.id2path(file_id)
-            new_path = new_inv.id2path(file_id)
-            old_ie._read_tree_state(old_path, old_tree)
-            new_ie._read_tree_state(new_path, new_tree)
-            text_modified, meta_modified = new_ie.detect_changes(old_ie)
+            if kind == 'file':
+                old_sha1 = old_tree.get_file_sha1(file_id)
+                new_sha1 = new_tree.get_file_sha1(file_id)
+                text_modified = (old_sha1 != new_sha1)
+            else:
+                ## mutter("no text to check for %r %r" % (file_id, kind))
+                text_modified = False
 
             # TODO: Can possibly avoid calculating path strings if the
             # two files are unchanged and their names and parents are
@@ -198,15 +187,14 @@
             
             if (old_ie.name != new_ie.name
                 or old_ie.parent_id != new_ie.parent_id):
-                delta.renamed.append((old_path,
-                                      new_path,
+                delta.renamed.append((old_inv.id2path(file_id),
+                                      new_inv.id2path(file_id),
                                       file_id, kind,
-                                      text_modified, meta_modified))
-            elif text_modified or meta_modified:
-                delta.modified.append((new_path, file_id, kind,
-                                       text_modified, meta_modified))
+                                      text_modified))
+            elif text_modified:
+                delta.modified.append((new_inv.id2path(file_id), file_id, kind))
             elif want_unchanged:
-                delta.unchanged.append((new_path, file_id, kind))
+                delta.unchanged.append((new_inv.id2path(file_id), file_id, kind))
         else:
             kind = old_inv.get_file_kind(file_id)
             if kind == 'root_directory':

=== modified file 'bzrlib/diff.py'
--- bzrlib/diff.py	2005-10-03 05:16:47 +0000
+++ bzrlib/diff.py	2005-09-16 12:53:47 +0000
@@ -62,6 +62,8 @@
     print >>to_file
 
 
+
+
 def external_diff(old_label, oldlines, new_label, newlines, to_file,
                   diff_opts):
     """Display a diff by calling out to the external diff program."""
@@ -139,6 +141,8 @@
     finally:
         oldtmpf.close()                 # and delete
         newtmpf.close()
+    
+
 
 def show_diff(b, revision, specific_files, external_diff_options=None,
               revision2=None, output=None):
@@ -209,43 +213,41 @@
 
     for path, file_id, kind in delta.removed:
         print >>to_file, '=== removed %s %r' % (kind, path)
-        old_tree.inventory[file_id].diff(diff_file, old_label + path, old_tree,
-                                         DEVNULL, None, None, to_file)
+        if kind == 'file':
+            diff_file(old_label + path,
+                      old_tree.get_file(file_id).readlines(),
+                      DEVNULL, 
+                      [],
+                      to_file)
+
     for path, file_id, kind in delta.added:
         print >>to_file, '=== added %s %r' % (kind, path)
-        new_tree.inventory[file_id].diff(diff_file, new_label + path, new_tree,
-                                         DEVNULL, None, None, to_file, 
-                                         reverse=True)
-    for (old_path, new_path, file_id, kind,
-         text_modified, meta_modified) in delta.renamed:
-        prop_str = get_prop_change(meta_modified)
-        print >>to_file, '=== renamed %s %r => %r%s' % (
-                          kind, old_path, new_path, prop_str)
-        _maybe_diff_file_or_symlink(old_label, old_path, old_tree, file_id,
-                                    new_label, new_path, new_tree,
-                                    text_modified, kind, to_file, diff_file)
-    for path, file_id, kind, text_modified, meta_modified in delta.modified:
-        prop_str = get_prop_change(meta_modified)
-        print >>to_file, '=== modified %s %r%s' % (kind, path, prop_str)
+        if kind == 'file':
+            diff_file(DEVNULL,
+                      [],
+                      new_label + path,
+                      new_tree.get_file(file_id).readlines(),
+                      to_file)
+
+    for old_path, new_path, file_id, kind, text_modified in delta.renamed:
+        print >>to_file, '=== renamed %s %r => %r' % (kind, old_path, new_path)
         if text_modified:
-            _maybe_diff_file_or_symlink(old_label, path, old_tree, file_id,
-                                        new_label, path, new_tree,
-                                        True, kind, to_file, diff_file)
-    
-
-def get_prop_change(meta_modified):
-    if meta_modified:
-        return " (properties changed)"
-    else:
-        return  ""
-
-
-def _maybe_diff_file_or_symlink(old_label, old_path, old_tree, file_id,
-                                new_label, new_path, new_tree, text_modified,
-                                kind, to_file, diff_file):
-    if text_modified:
-        new_entry = new_tree.inventory[file_id]
-        old_tree.inventory[file_id].diff(diff_file,
-                                         old_label + old_path, old_tree,
-                                         new_label + new_path, new_entry, 
-                                         new_tree, to_file)
+            diff_file(old_label + old_path,
+                      old_tree.get_file(file_id).readlines(),
+                      new_label + new_path,
+                      new_tree.get_file(file_id).readlines(),
+                      to_file)
+
+    for path, file_id, kind in delta.modified:
+        print >>to_file, '=== modified %s %r' % (kind, path)
+        if kind == 'file':
+            diff_file(old_label + path,
+                      old_tree.get_file(file_id).readlines(),
+                      new_label + path,
+                      new_tree.get_file(file_id).readlines(),
+                      to_file)
+
+
+
+
+

=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2005-10-06 13:08:14 +0000
+++ bzrlib/errors.py	2005-09-29 00:24:44 +0000
@@ -23,21 +23,13 @@
 # exceptions 
 class BzrError(StandardError):
     def __str__(self):
-        # XXX: Should we show the exception class in 
-        # exceptions that don't provide their own message?  
-        # maybe it should be done at a higher level
-        ## n = self.__class__.__name__ + ': '
-        n = ''
         if len(self.args) == 1:
-            return n + self.args[0]
+            return self.args[0]
         elif len(self.args) == 2:
             # further explanation or suggestions
-            try:
-                return n + '\n  '.join([self.args[0]] + self.args[1])
-            except TypeError:
-                return n + "%r" % self
+            return '\n  '.join([self.args[0]] + self.args[1])
         else:
-            return n + `self.args`
+            return `self.args`
 
 
 class BzrCheckError(BzrError):
@@ -55,14 +47,12 @@
 
 class BzrCommandError(BzrError):
     # Error from malformed user command
-    def __str__(self):
-        return self.args[0]
+    pass
 
 
 class NotBranchError(BzrError):
     """Specified path is not in a branch"""
-    def __str__(self):
-        return 'not a branch: %s' % self.args[0]
+    pass
 
 
 class NotVersionedError(BzrError):
@@ -148,15 +138,6 @@
         self.not_ancestor_id = not_ancestor_id
 
 
-class NotAncestor(BzrError):
-    def __init__(self, rev_id, not_ancestor_id):
-        self.rev_id = rev_id
-        self.not_ancestor_id = not_ancestor_id
-        msg = "Revision %s is not an ancestor of %s" % (not_ancestor_id, 
-                                                        rev_id)
-        BzrError.__init__(self, msg)
-
-
 class InstallFailed(BzrError):
     def __init__(self, revisions):
         msg = "Could not install revisions:\n%s" % " ,".join(revisions)
@@ -186,64 +167,3 @@
 
 
 from bzrlib.weave import WeaveError
-
-class TransportError(BzrError):
-    """All errors thrown by Transport implementations should derive
-    from this class.
-    """
-    def __init__(self, msg=None, orig_error=None):
-        if msg is None and orig_error is not None:
-            msg = str(orig_error)
-        BzrError.__init__(self, msg)
-        self.msg = msg
-        self.orig_error = orig_error
-
-# A set of semi-meaningful errors which can be thrown
-class TransportNotPossible(TransportError):
-    """This is for transports where a specific function is explicitly not
-    possible. Such as pushing files to an HTTP server.
-    """
-    pass
-
-class NonRelativePath(TransportError):
-    """An absolute path was supplied, that could not be decoded into
-    a relative path.
-    """
-    pass
-
-class NoSuchFile(TransportError, IOError):
-    """A get() was issued for a file that doesn't exist."""
-
-    # XXX: Is multiple inheritance for exceptions really needed?
-
-    def __str__(self):
-        return 'no such file: ' + self.msg
-
-    def __init__(self, msg=None, orig_error=None):
-        import errno
-        TransportError.__init__(self, msg=msg, orig_error=orig_error)
-        IOError.__init__(self, errno.ENOENT, self.msg)
-
-class FileExists(TransportError, OSError):
-    """An operation was attempted, which would overwrite an entry,
-    but overwritting is not supported.
-
-    mkdir() can throw this, but put() just overwites existing files.
-    """
-    # XXX: Is multiple inheritance for exceptions really needed?
-    def __init__(self, msg=None, orig_error=None):
-        import errno
-        TransportError.__init__(self, msg=msg, orig_error=orig_error)
-        OSError.__init__(self, errno.EEXIST, self.msg)
-
-class PermissionDenied(TransportError):
-    """An operation cannot succeed because of a lack of permissions."""
-    pass
-
-class ConnectionReset(TransportError):
-    """The connection has been closed."""
-    pass
-
-class ConflictsInTree(BzrError):
-    def __init__(self):
-        BzrError.__init__(self, "Working tree has conflicts.")

=== modified file 'bzrlib/fetch.py'
--- bzrlib/fetch.py	2005-10-06 06:31:33 +0000
+++ bzrlib/fetch.py	2005-09-29 02:01:49 +0000
@@ -82,11 +82,9 @@
 
     count_copied -- number of revisions copied
 
-    count_weaves -- number of file weaves copied
+    count_texts -- number of file texts copied
     """
     def __init__(self, to_branch, from_branch, last_revision=None, pb=None):
-        if to_branch == from_branch:
-            raise Exception("can't fetch from a branch to itself")
         self.to_branch = to_branch
         self.to_weaves = to_branch.weave_store
         self.to_control = to_branch.control_weaves
@@ -96,8 +94,7 @@
         self.failed_revisions = []
         self.count_copied = 0
         self.count_total = 0
-        self.count_weaves = 0
-        self.copied_file_ids = set()
+        self.count_texts = 0
         if pb is None:
             self.pb = bzrlib.ui.ui_factory.progress_bar()
         else:
@@ -185,45 +182,51 @@
                rev.committer,
                len(rev.parent_ids))
         self._copy_new_texts(rev_id, inv)
-        parents = rev.parent_ids
-        for parent in parents:
-            if not self.to_branch.has_revision(parent):
-                parents.pop(parents.index(parent))
-        self._copy_inventory(rev_id, inv_xml, parents)
+        self._copy_inventory(rev_id, inv_xml, rev.parent_ids)
+        self._copy_ancestry(rev_id, rev.parent_ids)
         self.to_branch.revision_store.add(StringIO(rev_xml), rev_id)
-        mutter('copied revision %s', rev_id)
 
 
     def _copy_inventory(self, rev_id, inv_xml, parent_ids):
         self.to_control.add_text('inventory', rev_id,
                                 split_lines(inv_xml), parent_ids)
 
+
+    def _copy_ancestry(self, rev_id, parent_ids):
+        ancestry_lines = self.from_control.get_lines('ancestry', rev_id)
+        self.to_control.add_text('ancestry', rev_id, ancestry_lines,
+                                 parent_ids)
+
+        
     def _copy_new_texts(self, rev_id, inv):
         """Copy any new texts occuring in this revision."""
         # TODO: Rather than writing out weaves every time, hold them
         # in memory until everything's done?  But this way is nicer
         # if it's interrupted.
         for path, ie in inv.iter_entries():
-            if ie.revision != rev_id:
+            if ie.kind != 'file':
+                continue
+            if ie.text_version != rev_id:
                 continue
             mutter('%s {%s} is changed in this revision',
                    path, ie.file_id)
-            self._copy_one_weave(rev_id, ie.file_id)
-
-
-    def _copy_one_weave(self, rev_id, file_id):
-        """Copy one file weave."""
-        mutter('copy file {%s} modified in {%s}', file_id, rev_id)
-        if file_id in self.copied_file_ids:
-            mutter('file {%s} already copied', file_id)
-            return
+            self._copy_one_text(rev_id, ie.file_id)
+
+
+    def _copy_one_text(self, rev_id, file_id):
+        """Copy one file text."""
+        mutter('copy text version {%s} of file {%s}',
+               rev_id, file_id)
         from_weave = self.from_weaves.get_weave(file_id)
+        from_idx = from_weave.lookup(rev_id)
+        from_parents = map(from_weave.idx_to_name, from_weave.parents(from_idx))
+        text_lines = from_weave.get(from_idx)
         to_weave = self.to_weaves.get_weave_or_empty(file_id)
-        to_weave.join(from_weave)
+        to_parents = map(to_weave.lookup, from_parents)
+        # it's ok to add even if the text is already there
+        to_weave.add(rev_id, to_parents, text_lines)
         self.to_weaves.put_weave(file_id, to_weave)
-        self.count_weaves += 1
-        self.copied_file_ids.add(file_id)
-        mutter('copied file {%s}', file_id)
+        self.count_texts += 1
 
 
 fetch = Fetcher

=== modified file 'bzrlib/hashcache.py'
--- bzrlib/hashcache.py	2005-09-30 02:54:51 +0000
+++ bzrlib/hashcache.py	2005-09-27 07:24:40 +0000
@@ -30,14 +30,13 @@
 CACHE_HEADER = "### bzr hashcache v5\n"
 
 import os, stat, time
-import sha
 
 from bzrlib.osutils import sha_file
 from bzrlib.trace import mutter, warning
 from bzrlib.atomicfile import AtomicFile
 
 
-FP_MODE_COLUMN = 5
+
 
 def _fingerprint(abspath):
     try:
@@ -52,7 +51,7 @@
     # we discard any high precision because it's not reliable; perhaps we
     # could do better on some systems?
     return (fs.st_size, long(fs.st_mtime),
-            long(fs.st_ctime), fs.st_ino, fs.st_dev, fs.st_mode)
+            long(fs.st_ctime), fs.st_ino, fs.st_dev)
 
 
 class HashCache(object):
@@ -165,16 +164,7 @@
             return cache_sha1
         
         self.miss_count += 1
-
-
-        mode = file_fp[FP_MODE_COLUMN]
-        if stat.S_ISREG(mode):
-            digest = sha_file(file(abspath, 'rb', buffering=65000))
-        elif stat.S_ISLNK(mode):
-            link_target = os.readlink(abspath)
-            digest = sha.new(os.readlink(abspath)).hexdigest()
-        else:
-            raise BzrError("file %r: unknown file stat mode: %o"%(abspath,mode))
+        digest = sha_file(file(abspath, 'rb', buffering=65000))
 
         now = int(time.time())
         if file_fp[1] >= now or file_fp[2] >= now:
@@ -190,8 +180,12 @@
             self.update_count += 1
             self.needs_write = True
             self._cache[path] = (digest, file_fp)
+        
         return digest
         
+
+
+
     def write(self):
         """Write contents of cache to file."""
         outf = AtomicFile(self.cache_file_name(), 'wb')
@@ -250,7 +244,7 @@
 
             pos += 3
             fields = l[pos:].split(' ')
-            if len(fields) != 7:
+            if len(fields) != 6:
                 warning("bad line in hashcache: %r" % l)
                 continue
 

=== modified file 'bzrlib/inventory.py'
--- bzrlib/inventory.py	2005-10-06 02:51:02 +0000
+++ bzrlib/inventory.py	2005-09-27 07:24:40 +0000
@@ -19,6 +19,10 @@
 # But those depend on its position within a particular inventory, and
 # it would be nice not to need to hold the backpointer here.
 
+# TODO: Perhaps split InventoryEntry into subclasses for files,
+# directories, etc etc.
+
+
 # This should really be an id randomly assigned when the tree is
 # created, but it's not for now.
 ROOT_ID = "TREE_ROOT"
@@ -27,14 +31,12 @@
 import os.path
 import re
 import sys
-import tarfile
 import types
 
 import bzrlib
 from bzrlib.errors import BzrError, BzrCheckError
 
-from bzrlib.osutils import (pumpfile, quotefn, splitpath, joinpath,
-                            appendpath, sha_strings)
+from bzrlib.osutils import quotefn, splitpath, joinpath, appendpath
 from bzrlib.trace import mutter
 from bzrlib.errors import NotVersionedError
 
@@ -50,16 +52,15 @@
     name
         (within the parent directory)
 
+    kind
+        'directory' or 'file'
+
     parent_id
         file_id of the parent directory, or ROOT_ID
 
-    revision
-        the revision_id in which this variation of this file was 
-        introduced.
-
-    executable
-        Indicates that this file should be executable on systems
-        that support it.
+    name_version
+        the revision_id in which the name or parent of this file was
+        last changed
 
     text_sha1
         sha-1 of the text of the file
@@ -67,36 +68,39 @@
     text_size
         size in bytes of the text of the file
         
+    text_version
+        the revision_id in which the text of this file was introduced
+
     (reading a version 4 tree created a text_id field.)
 
     >>> i = Inventory()
     >>> i.path2id('')
     'TREE_ROOT'
-    >>> i.add(InventoryDirectory('123', 'src', ROOT_ID))
-    InventoryDirectory('123', 'src', parent_id='TREE_ROOT')
-    >>> i.add(InventoryFile('2323', 'hello.c', parent_id='123'))
-    InventoryFile('2323', 'hello.c', parent_id='123')
+    >>> i.add(InventoryEntry('123', 'src', 'directory', ROOT_ID))
+    InventoryEntry('123', 'src', kind='directory', parent_id='TREE_ROOT')
+    >>> i.add(InventoryEntry('2323', 'hello.c', 'file', parent_id='123'))
+    InventoryEntry('2323', 'hello.c', kind='file', parent_id='123')
     >>> for j in i.iter_entries():
     ...   print j
     ... 
-    ('src', InventoryDirectory('123', 'src', parent_id='TREE_ROOT'))
-    ('src/hello.c', InventoryFile('2323', 'hello.c', parent_id='123'))
-    >>> i.add(InventoryFile('2323', 'bye.c', '123'))
+    ('src', InventoryEntry('123', 'src', kind='directory', parent_id='TREE_ROOT'))
+    ('src/hello.c', InventoryEntry('2323', 'hello.c', kind='file', parent_id='123'))
+    >>> i.add(InventoryEntry('2323', 'bye.c', 'file', '123'))
     Traceback (most recent call last):
     ...
     BzrError: inventory already contains entry with id {2323}
-    >>> i.add(InventoryFile('2324', 'bye.c', '123'))
-    InventoryFile('2324', 'bye.c', parent_id='123')
-    >>> i.add(InventoryDirectory('2325', 'wibble', '123'))
-    InventoryDirectory('2325', 'wibble', parent_id='123')
+    >>> i.add(InventoryEntry('2324', 'bye.c', 'file', '123'))
+    InventoryEntry('2324', 'bye.c', kind='file', parent_id='123')
+    >>> i.add(InventoryEntry('2325', 'wibble', 'directory', '123'))
+    InventoryEntry('2325', 'wibble', kind='directory', parent_id='123')
     >>> i.path2id('src/wibble')
     '2325'
     >>> '2325' in i
     True
-    >>> i.add(InventoryFile('2326', 'wibble.c', '2325'))
-    InventoryFile('2326', 'wibble.c', parent_id='2325')
+    >>> i.add(InventoryEntry('2326', 'wibble.c', 'file', '2325'))
+    InventoryEntry('2326', 'wibble.c', kind='file', parent_id='2325')
     >>> i['2326']
-    InventoryFile('2326', 'wibble.c', parent_id='2325')
+    InventoryEntry('2326', 'wibble.c', kind='file', parent_id='2325')
     >>> for path, entry in i.iter_entries():
     ...     print path.replace('\\\\', '/')     # for win32 os.sep
     ...     assert i.path2id(path)
@@ -111,114 +115,22 @@
     """
     
     __slots__ = ['text_sha1', 'text_size', 'file_id', 'name', 'kind',
-                 'text_id', 'parent_id', 'children', 'executable', 
-                 'revision']
-
-    def _add_text_to_weave(self, new_lines, parents, weave_store):
-        weave_store.add_text(self.file_id, self.revision, new_lines, parents)
-
-    def detect_changes(self, old_entry):
-        """Return a (text_modified, meta_modified) from this to old_entry.
-        
-        _read_tree_state must have been called on self and old_entry prior to 
-        calling detect_changes.
-        """
-        return False, False
-
-    def diff(self, text_diff, from_label, tree, to_label, to_entry, to_tree,
-             output_to, reverse=False):
-        """Perform a diff from this to to_entry.
-
-        text_diff will be used for textual difference calculation.
-        This is a template method, override _diff in child classes.
-        """
-        self._read_tree_state(tree.id2path(self.file_id), tree)
-        if to_entry:
-            # cannot diff from one kind to another - you must do a removal
-            # and an addif they do not match.
-            assert self.kind == to_entry.kind
-            to_entry._read_tree_state(to_tree.id2path(to_entry.file_id),
-                                      to_tree)
-        self._diff(text_diff, from_label, tree, to_label, to_entry, to_tree,
-                   output_to, reverse)
-
-    def _diff(self, text_diff, from_label, tree, to_label, to_entry, to_tree,
-             output_to, reverse=False):
-        """Perform a diff between two entries of the same kind."""
-
-    def find_previous_heads(self, previous_inventories, entry_weave):
-        """Return the revisions and entries that directly preceed this.
-
-        Returned as a map from revision to inventory entry.
-
-        This is a map containing the file revisions in all parents
-        for which the file exists, and its revision is not a parent of
-        any other. If the file is new, the set will be empty.
-        """
-        def get_ancestors(weave, entry):
-            return set(map(weave.idx_to_name,
-                           weave.inclusions([weave.lookup(entry.revision)])))
-        heads = {}
-        head_ancestors = {}
-        for inv in previous_inventories:
-            if self.file_id in inv:
-                ie = inv[self.file_id]
-                assert ie.file_id == self.file_id
-                if ie.revision in heads:
-                    assert heads[ie.revision] == ie
-                else:
-                    # may want to add it.
-                    # may already be covered:
-                    already_present = 0 != len(
-                        [head for head in heads 
-                         if ie.revision in head_ancestors[head]])
-                    if already_present:
-                        # an ancestor of a known head.
-                        continue
-                    # definately a head:
-                    ancestors = get_ancestors(entry_weave, ie)
-                    # may knock something else out:
-                    check_heads = list(heads.keys())
-                    for head in check_heads:
-                        if head in ancestors:
-                            # this head is not really a head
-                            heads.pop(head)
-                    head_ancestors[ie.revision] = ancestors
-                    heads[ie.revision] = ie
-        return heads
-
-    def get_tar_item(self, root, dp, now, tree):
-        """Get a tarfile item and a file stream for its content."""
-        item = tarfile.TarInfo(os.path.join(root, dp))
-        # TODO: would be cool to actually set it to the timestamp of the
-        # revision it was last changed
-        item.mtime = now
-        fileobj = self._put_in_tar(item, tree)
-        return item, fileobj
-
-    def has_text(self):
-        """Return true if the object this entry represents has textual data.
-
-        Note that textual data includes binary content.
-
-        Also note that all entries get weave files created for them.
-        This attribute is primarily used when upgrading from old trees that
-        did not have the weave index for all inventory entries.
-        """
-        return False
-
-    def __init__(self, file_id, name, parent_id, text_id=None):
+                 'text_id', 'parent_id', 'children',
+                 'text_version', 'name_version', ]
+
+
+    def __init__(self, file_id, name, kind, parent_id, text_id=None):
         """Create an InventoryEntry
         
         The filename must be a single component, relative to the
         parent directory; it cannot be a whole path or relative name.
 
-        >>> e = InventoryFile('123', 'hello.c', ROOT_ID)
+        >>> e = InventoryEntry('123', 'hello.c', 'file', ROOT_ID)
         >>> e.name
         'hello.c'
         >>> e.file_id
         '123'
-        >>> e = InventoryFile('123', 'src/hello.c', ROOT_ID)
+        >>> e = InventoryEntry('123', 'src/hello.c', 'file', ROOT_ID)
         Traceback (most recent call last):
         BzrCheckError: InventoryEntry name 'src/hello.c' is invalid
         """
@@ -226,141 +138,66 @@
         if '/' in name or '\\' in name:
             raise BzrCheckError('InventoryEntry name %r is invalid' % name)
         
-        self.executable = False
-        self.revision = None
+        self.text_version = None
+        self.name_version = None
         self.text_sha1 = None
         self.text_size = None
         self.file_id = file_id
         self.name = name
+        self.kind = kind
         self.text_id = text_id
         self.parent_id = parent_id
-        self.symlink_target = None
-
-    def kind_character(self):
-        """Return a short kind indicator useful for appending to names."""
-        raise BzrError('unknown kind %r' % self.kind)
-
-    known_kinds = ('file', 'directory', 'symlink', 'root_directory')
-
-    def _put_in_tar(self, item, tree):
-        """populate item for stashing in a tar, and return the content stream.
-
-        If no content is available, return None.
-        """
-        raise BzrError("don't know how to export {%s} of kind %r" %
-                       (self.file_id, self.kind))
-
-    def put_on_disk(self, dest, dp, tree):
-        """Create a representation of self on disk in the prefix dest.
-        
-        This is a template method - implement _put_on_disk in subclasses.
-        """
-        fullpath = appendpath(dest, dp)
-        self._put_on_disk(fullpath, tree)
-        mutter("  export {%s} kind %s to %s" % (self.file_id, self.kind, fullpath))
-
-    def _put_on_disk(self, fullpath, tree):
-        """Put this entry onto disk at fullpath, from tree tree."""
-        raise BzrError("don't know how to export {%s} of kind %r" % (self.file_id, self.kind))
+        if kind == 'directory':
+            self.children = {}
+        elif kind == 'file':
+            pass
+        else:
+            raise BzrError("unhandled entry kind %r" % kind)
+
+
 
     def sorted_children(self):
         l = self.children.items()
         l.sort()
         return l
 
-    @staticmethod
-    def versionable_kind(kind):
-        return kind in ('file', 'directory', 'symlink')
-
-    def check(self, checker, rev_id, inv, tree):
-        """Check this inventory entry is intact.
-
-        This is a template method, override _check for kind specific
-        tests.
-        """
-        if self.parent_id != None:
-            if not inv.has_id(self.parent_id):
-                raise BzrCheckError('missing parent {%s} in inventory for revision {%s}'
-                        % (self.parent_id, rev_id))
-        self._check(checker, rev_id, tree)
-
-    def _check(self, checker, rev_id, tree):
-        """Check this inventory entry for kind specific errors."""
-        raise BzrCheckError('unknown entry kind %r in revision {%s}' % 
-                            (self.kind, rev_id))
-
 
     def copy(self):
-        """Clone this inventory entry."""
-        raise NotImplementedError
+        other = InventoryEntry(self.file_id, self.name, self.kind,
+                               self.parent_id)
+        other.text_id = self.text_id
+        other.text_sha1 = self.text_sha1
+        other.text_size = self.text_size
+        other.text_version = self.text_version
+        other.name_version = self.name_version
+        # note that children are *not* copied; they're pulled across when
+        # others are added
+        return other
 
-    def _get_snapshot_change(self, previous_entries):
-        if len(previous_entries) > 1:
-            return 'merged'
-        elif len(previous_entries) == 0:
-            return 'added'
-        else:
-            return 'modified/renamed/reparented'
 
     def __repr__(self):
-        return ("%s(%r, %r, parent_id=%r)"
+        return ("%s(%r, %r, kind=%r, parent_id=%r)"
                 % (self.__class__.__name__,
                    self.file_id,
                    self.name,
+                   self.kind,
                    self.parent_id))
 
-    def snapshot(self, revision, path, previous_entries,
-                 work_tree, weave_store):
-        """Make a snapshot of this entry which may or may not have changed.
-        
-        This means that all its fields are populated, that it has its
-        text stored in the text store or weave.
-        """
-        mutter('new parents of %s are %r', path, previous_entries)
-        self._read_tree_state(path, work_tree)
-        if len(previous_entries) == 1:
-            # cannot be unchanged unless there is only one parent file rev.
-            parent_ie = previous_entries.values()[0]
-            if self._unchanged(parent_ie):
-                mutter("found unchanged entry")
-                self.revision = parent_ie.revision
-                return "unchanged"
-        return self.snapshot_revision(revision, previous_entries, 
-                                      work_tree, weave_store)
-
-    def snapshot_revision(self, revision, previous_entries, work_tree,
-                          weave_store):
-        """Record this revision unconditionally."""
-        mutter('new revision for {%s}', self.file_id)
-        self.revision = revision
-        change = self._get_snapshot_change(previous_entries)
-        self._snapshot_text(previous_entries, work_tree, weave_store)
-        return change
-
-    def _snapshot_text(self, file_parents, work_tree, weave_store): 
-        """Record the 'text' of this entry, whatever form that takes.
-        
-        This default implementation simply adds an empty text.
-        """
-        mutter('storing file {%s} in revision {%s}',
-               self.file_id, self.revision)
-        self._add_text_to_weave([], file_parents, weave_store)
-
+    
     def __eq__(self, other):
         if not isinstance(other, InventoryEntry):
             return NotImplemented
 
-        return ((self.file_id == other.file_id)
-                and (self.name == other.name)
-                and (other.symlink_target == self.symlink_target)
-                and (self.text_sha1 == other.text_sha1)
-                and (self.text_size == other.text_size)
-                and (self.text_id == other.text_id)
-                and (self.parent_id == other.parent_id)
-                and (self.kind == other.kind)
-                and (self.revision == other.revision)
-                and (self.executable == other.executable)
-                )
+        return (self.file_id == other.file_id) \
+               and (self.name == other.name) \
+               and (self.text_sha1 == other.text_sha1) \
+               and (self.text_size == other.text_size) \
+               and (self.text_id == other.text_id) \
+               and (self.parent_id == other.parent_id) \
+               and (self.kind == other.kind) \
+               and (self.text_version == other.text_version) \
+               and (self.name_version == other.name_version)
+
 
     def __ne__(self, other):
         return not (self == other)
@@ -368,33 +205,9 @@
     def __hash__(self):
         raise ValueError('not hashable')
 
-    def _unchanged(self, previous_ie):
-        """Has this entry changed relative to previous_ie.
-
-        This method should be overriden in child classes.
-        """
-        compatible = True
-        # different inv parent
-        if previous_ie.parent_id != self.parent_id:
-            compatible = False
-        # renamed
-        elif previous_ie.name != self.name:
-            compatible = False
-        return compatible
-
-    def _read_tree_state(self, path, work_tree):
-        """Populate fields in the inventory entry from the given tree.
-        
-        Note that this should be modified to be a noop on virtual trees
-        as all entries created there are prepopulated.
-        """
 
 
 class RootEntry(InventoryEntry):
-
-    def _check(self, checker, rev_id, tree):
-        """See InventoryEntry._check"""
-
     def __init__(self, file_id):
         self.file_id = file_id
         self.children = {}
@@ -410,248 +223,6 @@
                and (self.children == other.children)
 
 
-class InventoryDirectory(InventoryEntry):
-    """A directory in an inventory."""
-
-    def _check(self, checker, rev_id, tree):
-        """See InventoryEntry._check"""
-        if self.text_sha1 != None or self.text_size != None or self.text_id != None:
-            raise BzrCheckError('directory {%s} has text in revision {%s}'
-                                % (self.file_id, rev_id))
-
-    def copy(self):
-        other = InventoryDirectory(self.file_id, self.name, self.parent_id)
-        other.revision = self.revision
-        # note that children are *not* copied; they're pulled across when
-        # others are added
-        return other
-
-    def __init__(self, file_id, name, parent_id):
-        super(InventoryDirectory, self).__init__(file_id, name, parent_id)
-        self.children = {}
-        self.kind = 'directory'
-
-    def kind_character(self):
-        """See InventoryEntry.kind_character."""
-        return '/'
-
-    def _put_in_tar(self, item, tree):
-        """See InventoryEntry._put_in_tar."""
-        item.type = tarfile.DIRTYPE
-        fileobj = None
-        item.name += '/'
-        item.size = 0
-        item.mode = 0755
-        return fileobj
-
-    def _put_on_disk(self, fullpath, tree):
-        """See InventoryEntry._put_on_disk."""
-        os.mkdir(fullpath)
-
-
-class InventoryFile(InventoryEntry):
-    """A file in an inventory."""
-
-    def _check(self, checker, rev_id, tree):
-        """See InventoryEntry._check"""
-        revision = self.revision
-        t = (self.file_id, revision)
-        if t in checker.checked_texts:
-            prev_sha = checker.checked_texts[t] 
-            if prev_sha != self.text_sha1:
-                raise BzrCheckError('mismatched sha1 on {%s} in {%s}' %
-                                    (self.file_id, rev_id))
-            else:
-                checker.repeated_text_cnt += 1
-                return
-        mutter('check version {%s} of {%s}', rev_id, self.file_id)
-        file_lines = tree.get_file_lines(self.file_id)
-        checker.checked_text_cnt += 1 
-        if self.text_size != sum(map(len, file_lines)):
-            raise BzrCheckError('text {%s} wrong size' % self.text_id)
-        if self.text_sha1 != sha_strings(file_lines):
-            raise BzrCheckError('text {%s} wrong sha1' % self.text_id)
-        checker.checked_texts[t] = self.text_sha1
-
-    def copy(self):
-        other = InventoryFile(self.file_id, self.name, self.parent_id)
-        other.executable = self.executable
-        other.text_id = self.text_id
-        other.text_sha1 = self.text_sha1
-        other.text_size = self.text_size
-        other.revision = self.revision
-        return other
-
-    def detect_changes(self, old_entry):
-        """See InventoryEntry.detect_changes."""
-        assert self.text_sha1 != None
-        assert old_entry.text_sha1 != None
-        text_modified = (self.text_sha1 != old_entry.text_sha1)
-        meta_modified = (self.executable != old_entry.executable)
-        return text_modified, meta_modified
-
-    def _diff(self, text_diff, from_label, tree, to_label, to_entry, to_tree,
-             output_to, reverse=False):
-        """See InventoryEntry._diff."""
-        from_text = tree.get_file(self.file_id).readlines()
-        if to_entry:
-            to_text = to_tree.get_file(to_entry.file_id).readlines()
-        else:
-            to_text = []
-        if not reverse:
-            text_diff(from_label, from_text,
-                      to_label, to_text, output_to)
-        else:
-            text_diff(to_label, to_text,
-                      from_label, from_text, output_to)
-
-    def has_text(self):
-        """See InventoryEntry.has_text."""
-        return True
-
-    def __init__(self, file_id, name, parent_id):
-        super(InventoryFile, self).__init__(file_id, name, parent_id)
-        self.kind = 'file'
-
-    def kind_character(self):
-        """See InventoryEntry.kind_character."""
-        return ''
-
-    def _put_in_tar(self, item, tree):
-        """See InventoryEntry._put_in_tar."""
-        item.type = tarfile.REGTYPE
-        fileobj = tree.get_file(self.file_id)
-        item.size = self.text_size
-        if tree.is_executable(self.file_id):
-            item.mode = 0755
-        else:
-            item.mode = 0644
-        return fileobj
-
-    def _put_on_disk(self, fullpath, tree):
-        """See InventoryEntry._put_on_disk."""
-        pumpfile(tree.get_file(self.file_id), file(fullpath, 'wb'))
-        if tree.is_executable(self.file_id):
-            os.chmod(fullpath, 0755)
-
-    def _read_tree_state(self, path, work_tree):
-        """See InventoryEntry._read_tree_state."""
-        self.text_sha1 = work_tree.get_file_sha1(self.file_id)
-        self.executable = work_tree.is_executable(self.file_id)
-
-    def _snapshot_text(self, file_parents, work_tree, weave_store): 
-        """See InventoryEntry._snapshot_text."""
-        mutter('storing file {%s} in revision {%s}',
-               self.file_id, self.revision)
-        # special case to avoid diffing on renames or 
-        # reparenting
-        if (len(file_parents) == 1
-            and self.text_sha1 == file_parents.values()[0].text_sha1
-            and self.text_size == file_parents.values()[0].text_size):
-            previous_ie = file_parents.values()[0]
-            weave_store.add_identical_text(
-                self.file_id, previous_ie.revision, 
-                self.revision, file_parents)
-        else:
-            new_lines = work_tree.get_file(self.file_id).readlines()
-            self._add_text_to_weave(new_lines, file_parents, weave_store)
-            self.text_sha1 = sha_strings(new_lines)
-            self.text_size = sum(map(len, new_lines))
-
-
-    def _unchanged(self, previous_ie):
-        """See InventoryEntry._unchanged."""
-        compatible = super(InventoryFile, self)._unchanged(previous_ie)
-        if self.text_sha1 != previous_ie.text_sha1:
-            compatible = False
-        else:
-            # FIXME: 20050930 probe for the text size when getting sha1
-            # in _read_tree_state
-            self.text_size = previous_ie.text_size
-        return compatible
-
-
-class InventoryLink(InventoryEntry):
-    """A file in an inventory."""
-
-    __slots__ = ['symlink_target']
-
-    def _check(self, checker, rev_id, tree):
-        """See InventoryEntry._check"""
-        if self.text_sha1 != None or self.text_size != None or self.text_id != None:
-            raise BzrCheckError('symlink {%s} has text in revision {%s}'
-                    % (self.file_id, rev_id))
-        if self.symlink_target == None:
-            raise BzrCheckError('symlink {%s} has no target in revision {%s}'
-                    % (self.file_id, rev_id))
-
-    def copy(self):
-        other = InventoryLink(self.file_id, self.name, self.parent_id)
-        other.symlink_target = self.symlink_target
-        other.revision = self.revision
-        return other
-
-    def detect_changes(self, old_entry):
-        """See InventoryEntry.detect_changes."""
-        # FIXME: which _modified field should we use ? RBC 20051003
-        text_modified = (self.symlink_target != old_entry.symlink_target)
-        if text_modified:
-            mutter("    symlink target changed")
-        meta_modified = False
-        return text_modified, meta_modified
-
-    def _diff(self, text_diff, from_label, tree, to_label, to_entry, to_tree,
-             output_to, reverse=False):
-        """See InventoryEntry._diff."""
-        from_text = self.symlink_target
-        if to_entry is not None:
-            to_text = to_entry.symlink_target
-            if reverse:
-                temp = from_text
-                from_text = to_text
-                to_text = temp
-            print >>output_to, '=== target changed %r => %r' % (from_text, to_text)
-        else:
-            if not reverse:
-                print >>output_to, '=== target was %r' % self.symlink_target
-            else:
-                print >>output_to, '=== target is %r' % self.symlink_target
-
-    def __init__(self, file_id, name, parent_id):
-        super(InventoryLink, self).__init__(file_id, name, parent_id)
-        self.kind = 'symlink'
-
-    def kind_character(self):
-        """See InventoryEntry.kind_character."""
-        return ''
-
-    def _put_in_tar(self, item, tree):
-        """See InventoryEntry._put_in_tar."""
-        iterm.type = tarfile.SYMTYPE
-        fileobj = None
-        item.size = 0
-        item.mode = 0755
-        item.linkname = self.symlink_target
-        return fileobj
-
-    def _put_on_disk(self, fullpath, tree):
-        """See InventoryEntry._put_on_disk."""
-        try:
-            os.symlink(self.symlink_target, fullpath)
-        except OSError,e:
-            raise BzrError("Failed to create symlink %r -> %r, error: %s" % (fullpath, self.symlink_target, e))
-
-    def _read_tree_state(self, path, work_tree):
-        """See InventoryEntry._read_tree_state."""
-        self.symlink_target = work_tree.get_symlink_target(self.file_id)
-
-    def _unchanged(self, previous_ie):
-        """See InventoryEntry._unchanged."""
-        compatible = super(InventoryLink, self)._unchanged(previous_ie)
-        if self.symlink_target != previous_ie.symlink_target:
-            compatible = False
-        return compatible
-
 
 class Inventory(object):
     """Inventory of versioned files in a tree.
@@ -671,8 +242,8 @@
     inserted, other than through the Inventory API.
 
     >>> inv = Inventory()
-    >>> inv.add(InventoryFile('123-123', 'hello.c', ROOT_ID))
-    InventoryFile('123-123', 'hello.c', parent_id='TREE_ROOT')
+    >>> inv.add(InventoryEntry('123-123', 'hello.c', 'file', ROOT_ID))
+    InventoryEntry('123-123', 'hello.c', kind='file', parent_id='TREE_ROOT')
     >>> inv['123-123'].name
     'hello.c'
 
@@ -688,8 +259,8 @@
     >>> [x[0] for x in inv.iter_entries()]
     ['hello.c']
     >>> inv = Inventory('TREE_ROOT-12345678-12345678')
-    >>> inv.add(InventoryFile('123-123', 'hello.c', ROOT_ID))
-    InventoryFile('123-123', 'hello.c', parent_id='TREE_ROOT-12345678-12345678')
+    >>> inv.add(InventoryEntry('123-123', 'hello.c', 'file', ROOT_ID))
+    InventoryEntry('123-123', 'hello.c', kind='file', parent_id='TREE_ROOT-12345678-12345678')
     """
     def __init__(self, root_id=ROOT_ID):
         """Create or read an inventory.
@@ -787,8 +358,8 @@
         """True if this entry contains a file with given id.
 
         >>> inv = Inventory()
-        >>> inv.add(InventoryFile('123', 'foo.c', ROOT_ID))
-        InventoryFile('123', 'foo.c', parent_id='TREE_ROOT')
+        >>> inv.add(InventoryEntry('123', 'foo.c', 'file', ROOT_ID))
+        InventoryEntry('123', 'foo.c', kind='file', parent_id='TREE_ROOT')
         >>> '123' in inv
         True
         >>> '456' in inv
@@ -801,8 +372,8 @@
         """Return the entry for given file_id.
 
         >>> inv = Inventory()
-        >>> inv.add(InventoryFile('123123', 'hello.c', ROOT_ID))
-        InventoryFile('123123', 'hello.c', parent_id='TREE_ROOT')
+        >>> inv.add(InventoryEntry('123123', 'hello.c', 'file', ROOT_ID))
+        InventoryEntry('123123', 'hello.c', kind='file', parent_id='TREE_ROOT')
         >>> inv['123123'].name
         'hello.c'
         """
@@ -870,14 +441,8 @@
         if parent_id == None:
             raise NotVersionedError(parent_path)
 
-        if kind == 'directory':
-            ie = InventoryDirectory(file_id, parts[-1], parent_id)
-        elif kind == 'file':
-            ie = InventoryFile(file_id, parts[-1], parent_id)
-        elif kind == 'symlink':
-            ie = InventoryLink(file_id, parts[-1], parent_id)
-        else:
-            raise BzrError("unknown kind %r" % kind)
+        ie = InventoryEntry(file_id, parts[-1],
+                            kind=kind, parent_id=parent_id)
         return self.add(ie)
 
 
@@ -885,8 +450,8 @@
         """Remove entry by id.
 
         >>> inv = Inventory()
-        >>> inv.add(InventoryFile('123', 'foo.c', ROOT_ID))
-        InventoryFile('123', 'foo.c', parent_id='TREE_ROOT')
+        >>> inv.add(InventoryEntry('123', 'foo.c', 'file', ROOT_ID))
+        InventoryEntry('123', 'foo.c', kind='file', parent_id='TREE_ROOT')
         >>> '123' in inv
         True
         >>> del inv['123']
@@ -915,12 +480,12 @@
         >>> i2 = Inventory()
         >>> i1 == i2
         True
-        >>> i1.add(InventoryFile('123', 'foo', ROOT_ID))
-        InventoryFile('123', 'foo', parent_id='TREE_ROOT')
+        >>> i1.add(InventoryEntry('123', 'foo', 'file', ROOT_ID))
+        InventoryEntry('123', 'foo', kind='file', parent_id='TREE_ROOT')
         >>> i1 == i2
         False
-        >>> i2.add(InventoryFile('123', 'foo', ROOT_ID))
-        InventoryFile('123', 'foo', parent_id='TREE_ROOT')
+        >>> i2.add(InventoryEntry('123', 'foo', 'file', ROOT_ID))
+        InventoryEntry('123', 'foo', kind='file', parent_id='TREE_ROOT')
         >>> i1 == i2
         True
         """
@@ -962,14 +527,8 @@
 
 
     def id2path(self, file_id):
-        """Return as a list the path to file_id.
-        
-        >>> i = Inventory()
-        >>> e = i.add(InventoryDirectory('src-id', 'src', ROOT_ID))
-        >>> e = i.add(InventoryFile('foo-id', 'foo.c', parent_id='src-id'))
-        >>> print i.id2path('foo-id').replace(os.sep, '/')
-        src/foo.c
-        """
+        """Return as a list the path to file_id."""
+
         # get all names, skipping root
         p = [self._byid[fid].name for fid in self.get_idpath(file_id)[1:]]
         return os.sep.join(p)

=== modified file 'bzrlib/log.py'
--- bzrlib/log.py	2005-10-06 04:02:15 +0000
+++ bzrlib/log.py	2005-09-19 08:02:41 +0000
@@ -109,21 +109,6 @@
     return rh
 
 
-def _get_revision_delta(branch, revno):
-    """Return the delta for a mainline revision.
-    
-    This is used to show summaries in verbose logs, and also for finding 
-    revisions which touch a given file."""
-    # FIXME: The current version is very inefficient; it retrieves all revisions
-    # twice and reads the weave twice.  We ought to keep revisions in memory 
-    # in case they're used again, either in a general cache or perhaps 
-    # in this code.
-    # XXX: What are we supposed to do when showing a summary for something 
-    # other than a mainline revision.  The delta to it's first parent, or
-    # (more useful) the delta to a nominated other revision.
-    return branch.get_revision_delta(revno)
-
-
 def show_log(branch,
              lf,
              specific_fileid=None,
@@ -196,7 +181,7 @@
 
     for revno, rev_id in cut_revs:
         if verbose or specific_fileid:
-            delta = _get_revision_delta(branch, revno)
+            delta = branch.get_revision_delta(revno)
             
         if specific_fileid:
             if not delta.touches_file_id(specific_fileid):
@@ -308,8 +293,12 @@
 
     def show(self, revno, rev, delta):
         raise NotImplementedError('not implemented in abstract base')
-
-    
+        
+
+
+
+
+
 class LongLogFormatter(LogFormatter):
     def show(self, revno, rev, delta):
         from osutils import format_date
@@ -374,12 +363,8 @@
 
 
 def log_formatter(name, *args, **kwargs):
-    """Construct a formatter from arguments.
-
-    name -- Name of the formatter to construct; currently 'long' and
-        'short' are supported.
-    """
     from bzrlib.errors import BzrCommandError
+    
     try:
         return FORMATTERS[name](*args, **kwargs)
     except IndexError:

=== modified file 'bzrlib/merge.py'
--- bzrlib/merge.py	2005-10-04 04:32:32 +0000
+++ bzrlib/merge.py	2005-09-27 07:24:40 +0000
@@ -24,7 +24,7 @@
 import bzrlib.revision
 from bzrlib.merge_core import merge_flex, ApplyMerge3, BackupBeforeChange
 from bzrlib.changeset import generate_changeset, ExceptionConflictHandler
-from bzrlib.changeset import Inventory, Diff3Merge, ReplaceContents
+from bzrlib.changeset import Inventory, Diff3Merge
 from bzrlib.branch import Branch
 from bzrlib.errors import BzrCommandError, UnrelatedBranches, NoCommonAncestor
 from bzrlib.errors import NoCommits
@@ -36,9 +36,6 @@
 from bzrlib.revision import common_ancestor, MultipleRevisionSources
 from bzrlib.errors import NoSuchRevision
 
-# TODO: build_working_dir can be built on something simpler than merge()
-
-# FIXME: merge() parameters seem oriented towards the command line
 
 # comments from abentley on irc: merge happens in two stages, each
 # of which generates a changeset object
@@ -53,13 +50,10 @@
     conflict that are not explicitly handled cause an exception and
     terminate the merge.
     """
-    def __init__(self, this_tree, base_tree, other_tree, ignore_zero=False):
+    def __init__(self, ignore_zero=False):
         ExceptionConflictHandler.__init__(self)
         self.conflicts = 0
         self.ignore_zero = ignore_zero
-        self.this_tree = this_tree
-        self.base_tree = base_tree
-        self.other_tree = other_tree
 
     def copy(self, source, dest):
         """Copy the text and mode of a file
@@ -137,52 +131,6 @@
             % filename)
         return "skip"
 
-    def rem_contents_conflict(self, filename, this_contents, base_contents):
-        base_contents(filename+".BASE", self, False)
-        this_contents(filename+".THIS", self, False)
-        self.conflict("Other branch deleted locally modified file %s" %
-                      filename)
-        return ReplaceContents(this_contents, None)
-
-    def abs_this_path(self, file_id):
-        """Return the absolute path for a file_id in the this tree."""
-        relpath = self.this_tree.id2path(file_id)
-        return self.this_tree.tree.abspath(relpath)
-
-    def add_missing_parents(self, file_id, tree):
-        """If some of the parents for file_id are missing, add them."""
-        entry = tree.tree.inventory[file_id]
-        if entry.parent_id not in self.this_tree:
-            return self.create_all_missing(entry.parent_id, tree)
-        else:
-            return self.abs_this_path(entry.parent_id)
-
-    def create_all_missing(self, file_id, tree):
-        """Add contents for a file_id and all its parents to a tree."""
-        entry = tree.tree.inventory[file_id]
-        if entry.parent_id is not None and entry.parent_id not in self.this_tree:
-            abspath = self.create_all_missing(entry.parent_id, tree)
-        else:
-            abspath = self.abs_this_path(entry.parent_id)
-        entry_path = os.path.join(abspath, entry.name)
-        if not os.path.isdir(entry_path):
-            self.create(file_id, entry_path, tree)
-        return entry_path
-
-    def create(self, file_id, path, tree, reverse=False):
-        """Uses tree data to create a filesystem object for the file_id"""
-        from merge_core import get_id_contents
-        get_id_contents(file_id, tree)(path, self, reverse)
-
-    def missing_for_merge(self, file_id, other_path):
-        """The file_id doesn't exist in THIS, but does in OTHER and BASE"""
-        self.conflict("Other branch modified locally deleted file %s" %
-                      other_path)
-        parent_dir = self.add_missing_parents(file_id, self.other_tree)
-        stem = os.path.join(parent_dir, os.path.basename(other_path))
-        self.create(file_id, stem+".OTHER", self.other_tree)
-        self.create(file_id, stem+".BASE", self.base_tree)
-
     def finalize(self):
         if not self.ignore_zero:
             print "%d conflicts encountered.\n" % self.conflicts
@@ -227,7 +175,6 @@
         self.tree = tree
         self.tempdir = tempdir
         os.mkdir(os.path.join(self.tempdir, "texts"))
-        os.mkdir(os.path.join(self.tempdir, "symlinks"))
         self.cached = {}
 
     def __iter__(self):
@@ -242,9 +189,6 @@
     def get_file_sha1(self, id):
         return self.tree.get_file_sha1(id)
 
-    def is_executable(self, id):
-        return self.tree.is_executable(id)
-
     def id2path(self, file_id):
         return self.tree.id2path(file_id)
 
@@ -267,39 +211,17 @@
         if self.root is not None:
             return self.tree.abspath(self.tree.id2path(id))
         else:
-            kind = self.tree.inventory[id].kind
-            if kind in ("directory", "root_directory"):
+            if self.tree.inventory[id].kind in ("directory", "root_directory"):
                 return self.tempdir
             if not self.cached.has_key(id):
-                if kind == "file":
-                    path = os.path.join(self.tempdir, "texts", id)
-                    outfile = file(path, "wb")
-                    outfile.write(self.tree.get_file(id).read())
-                    assert(bzrlib.osutils.lexists(path))
-                    if self.tree.is_executable(id):
-                        os.chmod(path, 0755)
-                else:
-                    assert kind == "symlink"
-                    path = os.path.join(self.tempdir, "symlinks", id)
-                    target = self.tree.get_symlink_target(id)
-                    os.symlink(target, path)
+                path = os.path.join(self.tempdir, "texts", id)
+                outfile = file(path, "wb")
+                outfile.write(self.tree.get_file(id).read())
+                assert(os.path.exists(path))
                 self.cached[id] = path
             return self.cached[id]
 
 
-def build_working_dir(to_dir):
-    """Build a working directory in an empty directory.
-
-    to_dir is a directory containing branch metadata but no working files,
-    typically constructed by cloning an existing branch. 
-
-    This is split out as a special idiomatic case of merge.  It could
-    eventually be done by just building the tree directly calling into 
-    lower-level code (e.g. constructing a changeset).
-    """
-    merge((to_dir, -1), (to_dir, 0), this_dir=to_dir,
-          check_clean=False, ignore_zero=True)
-
 
 def merge(other_revision, base_revision,
           check_clean=True, ignore_zero=False,
@@ -316,9 +238,6 @@
     check_clean
         If true, this_dir must have no uncommitted changes before the
         merge begins.
-    ignore_zero - If true, suppress the "zero conflicts" message when 
-        there are no conflicts; should be set when doing something we expect
-        to complete perfectly.
 
     All available ancestors of other_revision and base_revision are
     automatically pulled into the branch.
@@ -432,8 +351,7 @@
 
     inv_changes = merge_flex(this_tree, base_tree, other_tree,
                              generate_cset_optimized, get_inventory,
-                             MergeConflictHandler(this_tree, base_tree,
-                             other_tree, ignore_zero=ignore_zero),
+                             MergeConflictHandler(ignore_zero=ignore_zero),
                              merge_factory=merge_factory, 
                              interesting_ids=interesting_ids)
 

=== modified file 'bzrlib/merge_core.py'
--- bzrlib/merge_core.py	2005-10-04 04:32:32 +0000
+++ bzrlib/merge_core.py	2005-09-23 09:25:16 +0000
@@ -1,10 +1,8 @@
-import os.path
-
 import changeset
 from changeset import Inventory, apply_changeset, invert_dict
-from bzrlib.osutils import backup_file, rename
-from bzrlib.merge3 import Merge3
-import bzrlib
+import os.path
+from osutils import backup_file, rename
+from merge3 import Merge3
 
 class ApplyMerge3:
     """Contents-change wrapper around merge3.Merge3"""
@@ -200,16 +198,11 @@
 
 
 def get_contents(entry, tree):
-    return get_id_contents(entry.id, tree)
-
-def get_id_contents(file_id, tree):
     """Get a contents change element suitable for use with ReplaceContents
     """
-    tree_entry = tree.tree.inventory[file_id]
+    tree_entry = tree.tree.inventory[entry.id]
     if tree_entry.kind == "file":
-        return changeset.FileCreate(tree.get_file(file_id).read())
-    elif tree_entry.kind == "symlink":
-        return changeset.SymlinkCreate(tree.get_symlink_target(file_id))
+        return changeset.FileCreate(tree.get_file(entry.id).read())
     else:
         assert tree_entry.kind in ("root_directory", "directory")
         return changeset.dir_create
@@ -231,16 +224,12 @@
         if contents.old_contents is None and contents.new_contents is None:
             return None
         if contents.new_contents is None:
-            this_contents = get_contents(entry, this)
-            if this_path is not None and bzrlib.osutils.lexists(this_path):
-                if this_contents != contents.old_contents:
-                    return conflict_handler.rem_contents_conflict(this_path, 
-                        this_contents, contents.old_contents)
+            if this_path is not None and os.path.exists(this_path):
                 return contents
             else:
                 return None
         elif contents.old_contents is None:
-            if this_path is None or not bzrlib.osutils.lexists(this_path):
+            if this_path is None or not os.path.exists(this_path):
                 return contents
             else:
                 this_contents = get_contents(entry, this)
@@ -257,18 +246,10 @@
             raise Exception("Unhandled merge scenario")
 
 def make_merged_metadata(entry, base, other):
-    metadata = entry.metadata_change
-    if metadata is None:
-        return None
-    if isinstance(metadata, changeset.ChangeUnixPermissions):
-        if metadata.new_mode is None:
-            return None
-        elif metadata.old_mode is None:
-            return metadata
-        else:
-            base_path = base.readonly_path(entry.id)
-            other_path = other.readonly_path(entry.id)    
-            return PermissionsMerge(base_path, other_path)
+    if entry.metadata_change is not None:
+        base_path = base.readonly_path(entry.id)
+        other_path = other.readonly_path(entry.id)    
+        return PermissionsMerge(base_path, other_path)
     
 
 class PermissionsMerge(object):

=== added file 'bzrlib/meta_store.py'
--- bzrlib/meta_store.py	1970-01-01 00:00:00 +0000
+++ bzrlib/meta_store.py	2005-09-26 08:56:15 +0000
@@ -0,0 +1,45 @@
+# Copyright (C) 2005 by Canonical Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+from bzrlib.trace import mutter
+from bzrlib.store import ImmutableStore
+
+
+class CachedStore:
+    """A store that caches data locally, to avoid repeated downloads.
+    The precacache method should be used to avoid server round-trips for
+    every piece of data.
+    """
+    def __init__(self, store, cache_dir):
+        self.source_store = store
+        self.cache_store = ImmutableStore(cache_dir)
+
+    def __getitem__(self, id):
+        mutter("Cache add %s" % id)
+        if id not in self.cache_store:
+            self.cache_store.add(self.source_store[id], id)
+        return self.cache_store[id]
+
+    def prefetch(self, ids):
+        """Copy a series of ids into the cache, before they are used.
+        For remote stores that support pipelining or async downloads, this can
+        increase speed considerably.
+
+        Failures while prefetching are ignored.
+        """
+        mutter("Prefetch of ids %s" % ",".join(ids))
+        self.cache_store.copy_multi(self.source_store, ids, 
+                                    permit_failure=True)

=== modified file 'bzrlib/missing.py'
--- bzrlib/missing.py	2005-09-29 12:49:59 +0000
+++ bzrlib/missing.py	2005-09-15 13:32:36 +0000
@@ -2,6 +2,14 @@
 A plugin for displaying what revisions are in 'other' but not in local.
 """
 
+import bzrlib
+
+try:
+    set
+except NameError:
+    from sets import Set as set
+
+
 def show_missing(br_local, br_remote, verbose=False, quiet=False):
     """Show the revisions which exist in br_remote, that 
     do not exist in br_local.

=== modified file 'bzrlib/msgeditor.py'
--- bzrlib/msgeditor.py	2005-10-02 13:14:12 +0000
+++ bzrlib/msgeditor.py	2005-09-19 06:16:22 +0000
@@ -114,7 +114,7 @@
             msg.append(line)
             
         if len(msg) == 0:
-            return ""
+            return None
         # delete empty lines at the end
         del msg[lastline:]
         # add a newline at the end, if needed

=== modified file 'bzrlib/osutils.py'
--- bzrlib/osutils.py	2005-10-03 05:16:47 +0000
+++ bzrlib/osutils.py	2005-09-28 09:35:50 +0000
@@ -95,30 +95,6 @@
     else:
         raise BzrError('invalid file kind %r' % kind)
 
-def lexists(f):
-    try:
-        if hasattr(os, 'lstat'):
-            os.lstat(f)
-        else:
-            os.stat(f)
-        return True
-    except OSError,e:
-        if e.errno == errno.ENOENT:
-            return False;
-        else:
-            raise BzrError("lstat/stat of (%r): %r" % (f, e))
-
-def normalizepath(f):
-    if hasattr(os.path, 'realpath'):
-        F = os.path.realpath
-    else:
-        F = os.path.abspath
-    [p,e] = os.path.split(f)
-    if e == "" or e == "." or e == "..":
-        return F(f)
-    else:
-        return os.path.join(F(p), e)
-    
 
 def backup_file(fn):
     """Copy a file to a backup.
@@ -165,12 +141,6 @@
     except OSError:
         return False
 
-def islink(f):
-    """True if f is a symlink."""
-    try:
-        return S_ISLNK(os.lstat(f)[ST_MODE])
-    except OSError:
-        return False
 
 def is_inside(dir, fname):
     """True if fname is inside dir.
@@ -543,10 +513,3 @@
         if e.errno != errno.EXDEV:
             raise
         copyfile(src, dest)
-
-
-def has_symlinks():
-    if hasattr(os, 'symlink'):
-        return True
-    else:
-        return False

=== removed file 'bzrlib/plugins/conflicts.py'
--- bzrlib/plugins/conflicts.py	2005-10-06 04:20:44 +0000
+++ bzrlib/plugins/conflicts.py	1970-01-01 00:00:00 +0000
@@ -1,68 +0,0 @@
-# Copyright (C) 2005 by Aaron Bentley
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-import bzrlib.status
-from bzrlib.branch import Branch
-from bzrlib.errors import BzrCommandError
-from bzrlib.commands import register_command
-from bzrlib.workingtree import CONFLICT_SUFFIXES
-import os
-import errno
-
-class cmd_conflicts(bzrlib.commands.Command):
-    """List files with conflicts.
-    (conflicts are determined by the presence of .BASE .TREE, and .OTHER 
-    files.)
-    """
-    def run(self):
-        for path in Branch.open_containing('.').working_tree().iter_conflicts():
-            print path
-
-register_command(cmd_conflicts)
-
-class cmd_resolve(bzrlib.commands.Command):
-    """Mark a conflict as resolved.
-    """
-    takes_args = ['file*']
-    takes_options = ['all']
-    def run(self, file_list=None, all=False):
-        if file_list is None:
-            if not all:
-                raise BzrCommandError(
-                    "command 'resolve' needs one or more FILE, or --all")
-            tree = Branch.open_containing('.').working_tree()
-            file_list = list(tree.abspath(f) for f in tree.iter_conflicts())
-        else:
-            if all:
-                raise BzrCommandError(
-                    "If --all is specified, no FILE may be provided")
-        for filename in file_list:
-            failures = 0
-            for suffix in CONFLICT_SUFFIXES:
-                try:
-                    os.unlink(filename+suffix)
-                except OSError, e:
-                    if e.errno != errno.ENOENT:
-                        raise
-                    else:
-                        failures += 1
-            if failures == len(CONFLICT_SUFFIXES):
-                if not os.path.exists(filename):
-                    print "%s does not exist" % filename
-                else:
-                    print "%s is not conflicted" % filename
-                        
-register_command(cmd_resolve)

=== added file 'bzrlib/remotebranch.py'
--- bzrlib/remotebranch.py	1970-01-01 00:00:00 +0000
+++ bzrlib/remotebranch.py	2005-09-29 02:01:49 +0000
@@ -0,0 +1,217 @@
+# Copyright (C) 2005 Canonical Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+
+"""Proxy object for access to remote branches.
+
+At the moment remote branches are only for HTTP and only for read
+access.
+"""
+
+
+import gzip
+from cStringIO import StringIO
+import os
+import urllib2
+import urlparse
+
+from bzrlib.errors import BzrError, BzrCheckError
+from bzrlib.branch import Branch, LocalBranch, BZR_BRANCH_FORMAT_5
+from bzrlib.trace import mutter
+from bzrlib.weavestore import WeaveStore
+from bzrlib.xml5 import serializer_v5
+
+
+# velocitynet.com.au transparently proxies connections and thereby
+# breaks keep-alive -- sucks!
+
+
+ENABLE_URLGRABBER = False
+
+from bzrlib.errors import BzrError, NoSuchRevision
+
+class GetFailed(BzrError):
+    def __init__(self, url, status):
+        BzrError.__init__(self, "Get %s failed with status %s" % (url, status))
+        self.url = url
+        self.status = status
+
+if ENABLE_URLGRABBER:
+    import util.urlgrabber
+    import util.urlgrabber.keepalive
+    util.urlgrabber.keepalive.DEBUG = 0
+    def get_url(path, compressed=False):
+        try:
+            url = path
+            if compressed:
+                url += '.gz'
+            mutter("grab url %s" % url)
+            url_f = util.urlgrabber.urlopen(url, keepalive=1, close_connection=0)
+            if url_f.status != 200:
+                raise GetFailed(url, url_f.status)
+            if not compressed:
+                return url_f
+            else:
+                return gzip.GzipFile(fileobj=StringIO(url_f.read()))
+        except urllib2.URLError, e:
+            raise BzrError("remote fetch failed: %r: %s" % (url, e))
+else:
+    def get_url(url, compressed=False):
+        import urllib2
+        if compressed:
+            url += '.gz'
+        mutter("get_url %s" % url)
+        url_f = urllib2.urlopen(url)
+        if compressed:
+            return gzip.GzipFile(fileobj=StringIO(url_f.read()))
+        else:
+            return url_f
+
+
+
+def _find_remote_root(url):
+    """Return the prefix URL that corresponds to the branch root."""
+    orig_url = url
+    while True:
+        try:
+            fmt_url = url + '/.bzr/branch-format'
+            ff = get_url(fmt_url)
+            fmt = ff.read()
+            ff.close()
+
+            if fmt != BZR_BRANCH_FORMAT_5:
+                raise BzrError("sorry, branch format %r not supported at url %s"
+                               % (fmt, url))
+            
+            return url
+        except urllib2.URLError:
+            pass
+
+        scheme, host, path = list(urlparse.urlparse(url))[:3]
+        # discard params, query, fragment
+        
+        # strip off one component of the path component
+        idx = path.rfind('/')
+        if idx == -1 or path == '/':
+            raise BzrError('no branch root found for URL %s'
+                           ' or enclosing directories'
+                           % orig_url)
+        path = path[:idx]
+        url = urlparse.urlunparse((scheme, host, path, '', '', ''))
+        
+
+
+class RemoteBranch(LocalBranch):
+    def __init__(self, baseurl, find_root=True):
+        """Create new proxy for a remote branch."""
+        if find_root:
+            self.base = _find_remote_root(baseurl)
+        else:
+            self.base = baseurl
+        self._check_format(False)
+        # is guaranteed to be a v5 store
+
+        cfn = self.controlfilename
+        assert self._branch_format == 5
+        self.control_weaves = WeaveStore(cfn([]), get_url)
+        self.weave_store = WeaveStore(cfn('weaves'), get_url)
+        self.revision_store = RemoteStore(cfn('revision-store'))
+
+    def __str__(self):
+        b = getattr(self, 'baseurl', 'undefined')
+        return '%s(%r)' % (self.__class__.__name__, b)
+
+    __repr__ = __str__
+
+    def setup_caching(self, cache_root):
+        """Set up cached stores located under cache_root"""
+        from bzrlib.meta_store import CachedStore
+        for store_name in ('inventory_store', 'text_store', 'revision_store'):
+            if not isinstance(getattr(self, store_name), CachedStore):
+                cache_path = os.path.join(cache_root, store_name)
+                os.mkdir(cache_path)
+                new_store = CachedStore(getattr(self, store_name), cache_path)
+                setattr(self, store_name, new_store)
+
+    def controlfile(self, filename, mode):
+        if mode not in ('rb', 'rt', 'r'):
+            raise BzrError("file mode %r not supported for remote branches" % mode)
+        return get_url(self.base + '/.bzr/' + filename, False)
+
+
+    def lock_read(self):
+        # no locking for remote branches yet
+        pass
+
+    def lock_write(self):
+        from errors import LockError
+        raise LockError("write lock not supported for remote branch %s"
+                        % self.base)
+
+    def unlock(self):
+        pass
+    
+
+    def relpath(self, path):
+        if not path.startswith(self.base):
+            raise BzrError('path %r is not under base URL %r'
+                           % (path, self.base))
+        pl = len(self.base)
+        return path[pl:].lstrip('/')
+
+
+    def get_revision(self, revision_id):
+        try:
+            revf = self.revision_store[revision_id]
+        except KeyError:
+            raise NoSuchRevision(self, revision_id)
+        r = serializer_v5.read_revision(revf)
+        if r.revision_id != revision_id:
+            raise BzrCheckError('revision stored as {%s} actually contains {%s}'
+                                % (revision_id, r.revision_id))
+        return r
+
+
+class RemoteStore(object):
+    def __init__(self, baseurl):
+        self._baseurl = baseurl
+        
+
+    def _path(self, name):
+        if '/' in name:
+            raise ValueError('invalid store id', name)
+        return self._baseurl + '/' + name
+
+    def __contains__(self, fileid):
+        try:
+            self[fileid]
+            return True
+        except KeyError:
+            return False
+        
+    def __getitem__(self, fileid):
+        p = self._path(fileid)
+        try:
+            return get_url(p, compressed=True)
+        except urllib2.URLError:
+            pass
+        try:
+            return get_url(p, compressed=False)
+        except urllib2.URLError:
+            raise KeyError(fileid)
+    
+
+    

=== modified file 'bzrlib/revision.py'
--- bzrlib/revision.py	2005-10-02 22:47:02 +0000
+++ bzrlib/revision.py	2005-09-27 07:24:40 +0000
@@ -32,22 +32,28 @@
     parent_ids
         List of parent revision_ids
     """
+    inventory_id = None
+    inventory_sha1 = None
+    revision_id = None
+    timestamp = None
+    message = None
+    timezone = None
+    committer = None
     
-    def __init__(self, revision_id, **args):
-        self.revision_id = revision_id
+    def __init__(self, **args):
         self.__dict__.update(args)
         self.parent_ids = []
         self.parent_sha1s = []
 
+
     def __repr__(self):
         return "<Revision id %s>" % self.revision_id
 
     def __eq__(self, other):
         if not isinstance(other, Revision):
             return False
-        # FIXME: rbc 20050930 parent_ids are not being compared
-        return (
-                self.inventory_sha1 == other.inventory_sha1
+        return (self.inventory_id == other.inventory_id
+                and self.inventory_sha1 == other.inventory_sha1
                 and self.revision_id == other.revision_id
                 and self.timestamp == other.timestamp
                 and self.message == other.message
@@ -58,6 +64,7 @@
         return not self.__eq__(other)
 
         
+
 REVISION_ID_RE = None
 
 def validate_revision_id(rid):
@@ -65,7 +72,7 @@
     global REVISION_ID_RE
     if not REVISION_ID_RE:
         import re
-        REVISION_ID_RE = re.compile('[\w:.-]+@[\w%.-]+--?[\w]+--?[0-9a-f]+\Z')
+        REVISION_ID_RE = re.compile('[\w.-]+@[\w.-]+--?\d+--?[0-9a-f]+\Z')
 
     if not REVISION_ID_RE.match(rid):
         raise ValueError("malformed revision-id %r" % rid)
@@ -204,7 +211,6 @@
     assert root not in ancestors[root]
     return root, ancestors, descendants
 
-
 def combined_graph(revision_a, revision_b, revision_source):
     """Produce a combined ancestry graph.
     Return graph root, ancestors map, descendants map, set of common nodes"""
@@ -226,7 +232,6 @@
         descendants[node].update(node_dec)
     return root, ancestors, descendants, common
 
-
 def common_ancestor(revision_a, revision_b, revision_source):
     try:
         root, ancestors, descendants, common = \
@@ -240,7 +245,6 @@
         raise bzrlib.errors.NoCommonAncestor(revision_a, revision_b)
     return farthest
 
-
 class MultipleRevisionSources(object):
     """Proxy that looks in multiple branches for revisions."""
     def __init__(self, *args):

=== modified file 'bzrlib/selftest/__init__.py'
--- bzrlib/selftest/__init__.py	2005-10-06 22:15:52 +0000
+++ bzrlib/selftest/__init__.py	2005-09-27 07:24:40 +0000
@@ -24,13 +24,11 @@
 import errno
 import subprocess
 import shutil
-import re
 
+import testsweet
 import bzrlib.commands
 import bzrlib.trace
 import bzrlib.fetch
-from bzrlib.selftest import TestUtil
-from bzrlib.selftest.TestUtil import TestLoader, TestSuite
 
 
 MODULES_TO_TEST = []
@@ -38,99 +36,6 @@
 
 from logging import debug, warning, error
 
-
-
-class EarlyStoppingTestResultAdapter(object):
-    """An adapter for TestResult to stop at the first first failure or error"""
-
-    def __init__(self, result):
-        self._result = result
-
-    def addError(self, test, err):
-        self._result.addError(test, err)
-        self._result.stop()
-
-    def addFailure(self, test, err):
-        self._result.addFailure(test, err)
-        self._result.stop()
-
-    def __getattr__(self, name):
-        return getattr(self._result, name)
-
-    def __setattr__(self, name, value):
-        if name == '_result':
-            object.__setattr__(self, name, value)
-        return setattr(self._result, name, value)
-
-
-class _MyResult(unittest._TextTestResult):
-    """
-    Custom TestResult.
-
-    No special behaviour for now.
-    """
-
-    def startTest(self, test):
-        unittest.TestResult.startTest(self, test)
-        # TODO: Maybe show test.shortDescription somewhere?
-        what = test.shortDescription() or test.id()        
-        if self.showAll:
-            self.stream.write('%-70.70s' % what)
-        self.stream.flush()
-
-    def addError(self, test, err):
-        super(_MyResult, self).addError(test, err)
-        self.stream.flush()
-
-    def addFailure(self, test, err):
-        super(_MyResult, self).addFailure(test, err)
-        self.stream.flush()
-
-    def addSuccess(self, test):
-        if self.showAll:
-            self.stream.writeln('OK')
-        elif self.dots:
-            self.stream.write('~')
-        self.stream.flush()
-        unittest.TestResult.addSuccess(self, test)
-
-    def printErrorList(self, flavour, errors):
-        for test, err in errors:
-            self.stream.writeln(self.separator1)
-            self.stream.writeln("%s: %s" % (flavour,self.getDescription(test)))
-            if hasattr(test, '_get_log'):
-                self.stream.writeln()
-                self.stream.writeln('log from this test:')
-                print >>self.stream, test._get_log()
-            self.stream.writeln(self.separator2)
-            self.stream.writeln("%s" % err)
-
-
-class TextTestRunner(unittest.TextTestRunner):
-
-    def _makeResult(self):
-        result = _MyResult(self.stream, self.descriptions, self.verbosity)
-        return EarlyStoppingTestResultAdapter(result)
-
-
-def iter_suite_tests(suite):
-    """Return all tests in a suite, recursing through nested suites"""
-    for item in suite._tests:
-        if isinstance(item, unittest.TestCase):
-            yield item
-        elif isinstance(item, unittest.TestSuite):
-            for r in iter_suite_tests(item):
-                yield r
-        else:
-            raise Exception('unknown object %r inside test suite %r'
-                            % (item, suite))
-
-
-class TestSkipped(Exception):
-    """Indicates that a test was intentionally skipped, rather than failing."""
-    # XXX: Not used yet
-
-
 class CommandFailed(Exception):
     pass
 
@@ -150,6 +55,7 @@
     BZRPATH = 'bzr'
 
     def setUp(self):
+        # this replaces the default testsweet.TestCase; we don't want logging changed
         unittest.TestCase.setUp(self)
         bzrlib.trace.disable_default_logging()
         self._enable_file_logging()
@@ -380,10 +286,6 @@
                 print >>f, "contents of", name
                 f.close()
 
-    def failUnlessExists(self, path):
-        """Fail unless path, which may be abs or relative, exists."""
-        self.failUnless(os.path.exists(path))
-        
 
 class MetaTestLog(TestCase):
     def test_logging(self):
@@ -394,64 +296,16 @@
         ##assert 0
 
 
-def filter_suite_by_re(suite, pattern):
-    result = TestUtil.TestSuite()
-    filter_re = re.compile(pattern)
-    for test in iter_suite_tests(suite):
-        if filter_re.match(test.id()):
-            result.addTest(test)
-    return result
-
-
-def filter_suite_by_names(suite, wanted_names):
-    """Return a new suite containing only selected tests.
-    
-    Names are considered to match if any name is a substring of the 
-    fully-qualified test id (i.e. the class ."""
-    result = TestSuite()
-    for test in iter_suite_tests(suite):
-        this_id = test.id()
-        for p in wanted_names:
-            if this_id.find(p) != -1:
-                result.addTest(test)
-    return result
-
-
-def run_suite(suite, name='test', verbose=False, pattern=".*", testnames=None):
-    TestCaseInTempDir._TEST_NAME = name
-    if verbose:
-        verbosity = 2
-    else:
-        verbosity = 1
-    runner = TextTestRunner(stream=sys.stdout,
-                            descriptions=0,
-                            verbosity=verbosity)
-    if testnames:
-        suite = filter_suite_by_names(suite, testnames)
-    if pattern != '.*':
-        suite = filter_suite_by_re(suite, pattern)
-    result = runner.run(suite)
-    # This is still a little bogus, 
-    # but only a little. Folk not using our testrunner will
-    # have to delete their temp directories themselves.
-    if result.wasSuccessful():
-        if TestCaseInTempDir.TEST_ROOT is not None:
-            shutil.rmtree(TestCaseInTempDir.TEST_ROOT) 
-    else:
-        print "Failed tests working directories are in '%s'\n" % TestCaseInTempDir.TEST_ROOT
-    return result.wasSuccessful()
-
-
-def selftest(verbose=False, pattern=".*", testnames=None):
+def selftest(verbose=False, pattern=".*"):
     """Run the whole test suite under the enhanced runner"""
-    return run_suite(test_suite(), 'testbzr', verbose=verbose, pattern=pattern,
-                     testnames=testnames)
+    return testsweet.run_suite(test_suite(), 'testbzr', verbose=verbose, pattern=pattern)
 
 
 def test_suite():
     """Build and return TestSuite for the whole program."""
-    import bzrlib.store, bzrlib.inventory, bzrlib.branch
-    import bzrlib.osutils, bzrlib.merge3, bzrlib.plugin
+    from bzrlib.selftest.TestUtil import TestLoader, TestSuite
+    import bzrlib, bzrlib.store, bzrlib.inventory, bzrlib.branch
+    import bzrlib.osutils, bzrlib.commands, bzrlib.merge3, bzrlib.plugin
     from doctest import DocTestSuite
 
     global MODULES_TO_TEST, MODULES_TO_DOCTEST
@@ -470,6 +324,7 @@
                    'bzrlib.selftest.testlog',
                    'bzrlib.selftest.testrevisionnamespaces',
                    'bzrlib.selftest.testbranch',
+                   'bzrlib.selftest.testremotebranch',
                    'bzrlib.selftest.testrevision',
                    'bzrlib.selftest.test_revision_info',
                    'bzrlib.selftest.test_merge_core',
@@ -483,12 +338,7 @@
                    'bzrlib.selftest.whitebox',
                    'bzrlib.selftest.teststore',
                    'bzrlib.selftest.blackbox',
-                   'bzrlib.selftest.testsampler',
-                   'bzrlib.selftest.testtransport',
                    'bzrlib.selftest.testgraph',
-                   'bzrlib.selftest.testworkingtree',
-                   'bzrlib.selftest.test_upgrade',
-                   'bzrlib.selftest.test_conflicts',
                    ]
 
     for m in (bzrlib.store, bzrlib.inventory, bzrlib.branch,

=== modified file 'bzrlib/selftest/blackbox.py'
--- bzrlib/selftest/blackbox.py	2005-10-06 13:08:14 +0000
+++ bzrlib/selftest/blackbox.py	2005-09-29 02:01:49 +0000
@@ -19,22 +19,20 @@
 """Black-box tests for bzr.
 
 These check that it behaves properly when it's invoked through the regular
-command-line interface. This doesn't actually run a new interpreter but 
-rather starts again from the run_bzr function.
+command-line interface.
+
+This always reinvokes bzr through a new Python interpreter, which is a
+bit inefficient but arguably tests in a way more representative of how
+it's normally invoked.
 """
 
-
 from cStringIO import StringIO
 import os
 import shutil
 import sys
-import os
 
+from bzrlib.selftest import TestCaseInTempDir, BzrTestBase
 from bzrlib.branch import Branch
-from bzrlib.errors import BzrCommandError
-from bzrlib.osutils import has_symlinks
-from bzrlib.selftest import TestCaseInTempDir, BzrTestBase
-from bzrlib.selftest.HTTPTestUtil import TestCaseWithWebserver
 
 
 class ExternalBase(TestCaseInTempDir):
@@ -104,12 +102,6 @@
         self.runbzr("add hello.txt")
         self.runbzr("commit -m added")
 
-    def test_empty_commit_message(self):
-        self.runbzr("init")
-        file('foo.c', 'wt').write('int main() {}')
-        self.runbzr(['add', 'foo.c'])
-        self.runbzr(["commit", "-m", ""] , retcode=1) 
-
     def test_ignore_patterns(self):
         from bzrlib.branch import Branch
         
@@ -152,7 +144,7 @@
         file('goodbye', 'wt').write('baz')
         self.runbzr('add goodbye')
         self.runbzr('commit -m setup goodbye')
-
+        
         file('hello', 'wt').write('bar')
         file('goodbye', 'wt').write('qux')
         self.runbzr('revert hello')
@@ -167,12 +159,6 @@
         os.rmdir('revertdir')
         self.runbzr('revert')
 
-        os.symlink('/unlikely/to/exist', 'symlink')
-        self.runbzr('add symlink')
-        self.runbzr('commit -m f')
-        os.unlink('symlink')
-        self.runbzr('revert')
-        
         file('hello', 'wt').write('xyz')
         self.runbzr('commit -m xyz hello')
         self.runbzr('revert -r 1 hello')
@@ -196,6 +182,7 @@
         self.run_bzr_captured(['mv', 'a', 'c', 'subdir'])
         self.run_bzr_captured(['mv', 'subdir/a', 'subdir/newa'])
 
+
     def test_main_version(self):
         """Check output from version command and master option is reasonable"""
         # output is intentionally passed through to stdout so that we
@@ -220,42 +207,6 @@
         test.runbzr('add goodbye')
         test.runbzr('commit -m setup goodbye')
 
-    def test_export(self):
-        os.mkdir('branch')
-        os.chdir('branch')
-        self.example_branch()
-        self.runbzr('export ../latest')
-        self.assertEqual(file('../latest/goodbye', 'rt').read(), 'baz')
-        self.runbzr('export ../first -r 1')
-        assert not os.path.exists('../first/goodbye')
-        self.assertEqual(file('../first/hello', 'rt').read(), 'foo')
-        self.runbzr('export ../first.gz -r 1')
-        self.assertEqual(file('../first.gz/hello', 'rt').read(), 'foo')
-        self.runbzr('export ../first.bz2 -r 1')
-        self.assertEqual(file('../first.bz2/hello', 'rt').read(), 'foo')
-        self.runbzr('export ../first.tar -r 1')
-        assert os.path.isfile('../first.tar')
-        from tarfile import TarFile
-        tf = TarFile('../first.tar')
-        assert 'first/hello' in tf.getnames(), tf.getnames()
-        self.assertEqual(tf.extractfile('first/hello').read(), 'foo')
-        self.runbzr('export ../first.tar.gz -r 1')
-        assert os.path.isfile('../first.tar.gz')
-        self.runbzr('export ../first.tbz2 -r 1')
-        assert os.path.isfile('../first.tbz2')
-        self.runbzr('export ../first.tar.bz2 -r 1')
-        assert os.path.isfile('../first.tar.bz2')
-        self.runbzr('export ../first.tar.tbz2 -r 1')
-        assert os.path.isfile('../first.tar.tbz2')
-        from bz2 import BZ2File
-        tf = TarFile('../first.tar.tbz2', 
-                     fileobj=BZ2File('../first.tar.tbz2', 'r'))
-        assert 'first.tar/hello' in tf.getnames(), tf.getnames()
-        self.assertEqual(tf.extractfile('first.tar/hello').read(), 'foo')
-        self.runbzr('export ../first2.tar -r 1 --root pizza')
-        tf = TarFile('../first2.tar')
-        assert 'pizza/hello' in tf.getnames(), tf.getnames()
-
     def test_diff(self):
         self.example_branch()
         file('hello', 'wt').write('hello world!')
@@ -308,75 +259,7 @@
         a.get_revision_xml(b.last_revision())
         self.log('pending merges: %s', a.pending_merges())
         #        assert a.pending_merges() == [b.last_revision()], "Assertion %s %s" \
-        #        % (a.pending_merges(), b.last_patch())
-
-    def test_merge_with_missing_file(self):
-        """Merge handles missing file conflicts"""
-        os.mkdir('a')
-        os.chdir('a')
-        os.mkdir('sub')
-        print >> file('sub/a.txt', 'wb'), "hello"
-        print >> file('b.txt', 'wb'), "hello"
-        print >> file('sub/c.txt', 'wb'), "hello"
-        self.runbzr('init')
-        self.runbzr('add')
-        self.runbzr(('commit', '-m', 'added a'))
-        self.runbzr('branch . ../b')
-        print >> file('sub/a.txt', 'ab'), "there"
-        print >> file('b.txt', 'ab'), "there"
-        print >> file('sub/c.txt', 'ab'), "there"
-        self.runbzr(('commit', '-m', 'Added there'))
-        os.unlink('sub/a.txt')
-        os.unlink('sub/c.txt')
-        os.rmdir('sub')
-        os.unlink('b.txt')
-        self.runbzr(('commit', '-m', 'Removed a.txt'))
-        os.chdir('../b')
-        print >> file('sub/a.txt', 'ab'), "something"
-        print >> file('b.txt', 'ab'), "something"
-        print >> file('sub/c.txt', 'ab'), "something"
-        self.runbzr(('commit', '-m', 'Modified a.txt'))
-        self.runbzr('merge ../a/')
-        assert os.path.exists('sub/a.txt.THIS')
-        assert os.path.exists('sub/a.txt.BASE')
-        os.chdir('../a')
-        self.runbzr('merge ../b/')
-        assert os.path.exists('sub/a.txt.OTHER')
-        assert os.path.exists('sub/a.txt.BASE')
-
-    def test_merge_with_missing_file(self):
-        """Merge handles missing file conflicts"""
-        os.mkdir('a')
-        os.chdir('a')
-        os.mkdir('sub')
-        print >> file('sub/a.txt', 'wb'), "hello"
-        print >> file('b.txt', 'wb'), "hello"
-        print >> file('sub/c.txt', 'wb'), "hello"
-        self.runbzr('init')
-        self.runbzr('add')
-        self.runbzr(('commit', '-m', 'added a'))
-        self.runbzr('branch . ../b')
-        print >> file('sub/a.txt', 'ab'), "there"
-        print >> file('b.txt', 'ab'), "there"
-        print >> file('sub/c.txt', 'ab'), "there"
-        self.runbzr(('commit', '-m', 'Added there'))
-        os.unlink('sub/a.txt')
-        os.unlink('sub/c.txt')
-        os.rmdir('sub')
-        os.unlink('b.txt')
-        self.runbzr(('commit', '-m', 'Removed a.txt'))
-        os.chdir('../b')
-        print >> file('sub/a.txt', 'ab'), "something"
-        print >> file('b.txt', 'ab'), "something"
-        print >> file('sub/c.txt', 'ab'), "something"
-        self.runbzr(('commit', '-m', 'Modified a.txt'))
-        self.runbzr('merge ../a/')
-        assert os.path.exists('sub/a.txt.THIS')
-        assert os.path.exists('sub/a.txt.BASE')
-        os.chdir('../a')
-        self.runbzr('merge ../b/')
-        assert os.path.exists('sub/a.txt.OTHER')
-        assert os.path.exists('sub/a.txt.BASE')
+        #        % (a.pending_merges(), b.last_revision())
 
     def test_pull(self):
         """Pull changes from one branch to another."""
@@ -427,34 +310,6 @@
         self.runbzr('commit -m blah8 --unchanged')
         self.runbzr('pull ../b')
         self.runbzr('pull ../b')
-
-    def test_locations(self):
-        """Using and remembering different locations"""
-        os.mkdir('a')
-        os.chdir('a')
-        self.runbzr('init')
-        self.runbzr('commit -m unchanged --unchanged')
-        self.runbzr('pull', retcode=1)
-        self.runbzr('merge', retcode=1)
-        self.runbzr('branch . ../b')
-        os.chdir('../b')
-        self.runbzr('pull')
-        self.runbzr('branch . ../c')
-        self.runbzr('pull ../c')
-        self.runbzr('merge')
-        os.chdir('../a')
-        self.runbzr('pull ../b')
-        self.runbzr('pull')
-        self.runbzr('pull ../c')
-        self.runbzr('branch ../c ../d')
-        shutil.rmtree('../c')
-        self.runbzr('pull')
-        os.chdir('../b')
-        self.runbzr('pull')
-        os.chdir('../d')
-        self.runbzr('pull', retcode=1)
-        self.runbzr('pull ../a --remember')
-        self.runbzr('pull')
         
     def test_add_reports(self):
         """add command prints the names of added files."""
@@ -474,46 +329,7 @@
                                          retcode=1)
         self.assertEquals(out, '')
         err.index('unknown command')
-
-    def test_conflicts(self):
-        """Handling of merge conflicts"""
-        os.mkdir('base')
-        os.chdir('base')
-        file('hello', 'wb').write("hi world")
-        file('answer', 'wb').write("42")
-        self.runbzr('init')
-        self.runbzr('add')
-        self.runbzr('commit -m base')
-        self.runbzr('branch . ../other')
-        self.runbzr('branch . ../this')
-        os.chdir('../other')
-        file('hello', 'wb').write("Hello.")
-        file('answer', 'wb').write("Is anyone there?")
-        self.runbzr('commit -m other')
-        os.chdir('../this')
-        file('hello', 'wb').write("Hello, world")
-        self.runbzr('mv answer question')
-        file('question', 'wb').write("What do you get when you multiply six"
-                                   "times nine?")
-        self.runbzr('commit -m this')
-        self.runbzr('merge ../other')
-        result = self.runbzr('conflicts', backtick=1)
-        self.assertEquals(result, "hello\nquestion\n")
-        result = self.runbzr('status', backtick=1)
-        assert "conflicts:\n  hello\n  question\n" in result, result
-        self.runbzr('resolve hello')
-        result = self.runbzr('conflicts', backtick=1)
-        self.assertEquals(result, "question\n")
-        self.runbzr('commit -m conflicts', retcode=1)
-        self.runbzr('resolve --all')
-        result = self.runbzr('conflicts', backtick=1)
-        self.runbzr('commit -m conflicts')
-        self.assertEquals(result, "")
-
-def listdir_sorted(dir):
-    L = os.listdir(dir)
-    L.sort()
-    return L
+        
 
 
 class OldTests(ExternalBase):
@@ -686,110 +502,3 @@
 
         runbzr('info')
 
-        if has_symlinks():
-            progress("symlinks")
-            mkdir('symlinks')
-            chdir('symlinks')
-            runbzr('init')
-            os.symlink("NOWHERE1", "link1")
-            runbzr('add link1')
-            assert self.capture('unknowns') == ''
-            runbzr(['commit', '-m', '1: added symlink link1'])
-    
-            mkdir('d1')
-            runbzr('add d1')
-            assert self.capture('unknowns') == ''
-            os.symlink("NOWHERE2", "d1/link2")
-            assert self.capture('unknowns') == 'd1/link2\n'
-            # is d1/link2 found when adding d1
-            runbzr('add d1')
-            assert self.capture('unknowns') == ''
-            os.symlink("NOWHERE3", "d1/link3")
-            assert self.capture('unknowns') == 'd1/link3\n'
-            runbzr(['commit', '-m', '2: added dir, symlink'])
-    
-            runbzr('rename d1 d2')
-            runbzr('move d2/link2 .')
-            runbzr('move link1 d2')
-            assert os.readlink("./link2") == "NOWHERE2"
-            assert os.readlink("d2/link1") == "NOWHERE1"
-            runbzr('add d2/link3')
-            runbzr('diff')
-            runbzr(['commit', '-m', '3: rename of dir, move symlinks, add link3'])
-    
-            os.unlink("link2")
-            os.symlink("TARGET 2", "link2")
-            os.unlink("d2/link1")
-            os.symlink("TARGET 1", "d2/link1")
-            runbzr('diff')
-            assert self.capture("relpath d2/link1") == "d2/link1\n"
-            runbzr(['commit', '-m', '4: retarget of two links'])
-    
-            runbzr('remove d2/link1')
-            assert self.capture('unknowns') == 'd2/link1\n'
-            runbzr(['commit', '-m', '5: remove d2/link1'])
-    
-            os.mkdir("d1")
-            runbzr('add d1')
-            runbzr('rename d2/link3 d1/link3new')
-            assert self.capture('unknowns') == 'd2/link1\n'
-            runbzr(['commit', '-m', '6: remove d2/link1, move/rename link3'])
-            
-            runbzr(['check'])
-            
-            runbzr(['export', '-r', '1', 'exp1.tmp'])
-            chdir("exp1.tmp")
-            assert listdir_sorted(".") == [ "link1" ]
-            assert os.readlink("link1") == "NOWHERE1"
-            chdir("..")
-            
-            runbzr(['export', '-r', '2', 'exp2.tmp'])
-            chdir("exp2.tmp")
-            assert listdir_sorted(".") == [ "d1", "link1" ]
-            chdir("..")
-            
-            runbzr(['export', '-r', '3', 'exp3.tmp'])
-            chdir("exp3.tmp")
-            assert listdir_sorted(".") == [ "d2", "link2" ]
-            assert listdir_sorted("d2") == [ "link1", "link3" ]
-            assert os.readlink("d2/link1") == "NOWHERE1"
-            assert os.readlink("link2")    == "NOWHERE2"
-            chdir("..")
-            
-            runbzr(['export', '-r', '4', 'exp4.tmp'])
-            chdir("exp4.tmp")
-            assert listdir_sorted(".") == [ "d2", "link2" ]
-            assert os.readlink("d2/link1") == "TARGET 1"
-            assert os.readlink("link2")    == "TARGET 2"
-            assert listdir_sorted("d2") == [ "link1", "link3" ]
-            chdir("..")
-            
-            runbzr(['export', '-r', '5', 'exp5.tmp'])
-            chdir("exp5.tmp")
-            assert listdir_sorted(".") == [ "d2", "link2" ]
-            assert os.path.islink("link2")
-            assert listdir_sorted("d2")== [ "link3" ]
-            chdir("..")
-            
-            runbzr(['export', '-r', '6', 'exp6.tmp'])
-            chdir("exp6.tmp")
-            assert listdir_sorted(".") == [ "d1", "d2", "link2" ]
-            assert listdir_sorted("d1") == [ "link3new" ]
-            assert listdir_sorted("d2") == []
-            assert os.readlink("d1/link3new") == "NOWHERE3"
-            chdir("..")
-        else:
-            progress("skipping symlink tests")
-
-
-class HttpTests(TestCaseWithWebserver):
-    """Test bzr ui commands against remote branches."""
-
-    def test_branch(self):
-        os.mkdir('from')
-        branch = Branch.initialize('from')
-        branch.commit('empty commit for nonsense', allow_pointless=True)
-        url = self.get_remote_url('from')
-        self.run_bzr('branch', url, 'to')
-        branch = Branch.open('to')
-        self.assertEqual(1, len(branch.revision_history()))

=== modified file 'bzrlib/selftest/test_ancestry.py'
--- bzrlib/selftest/test_ancestry.py	2005-10-06 06:31:33 +0000
+++ bzrlib/selftest/test_ancestry.py	2005-09-27 07:24:40 +0000
@@ -39,9 +39,6 @@
                  rev_id='tester@foo--2')
 
         ancs = b.get_ancestry('tester@foo--2')
-        self.assertEqual([None, 'tester@foo--1', 'tester@foo--2'], ancs)
-        self.assertEqual([None, 'tester@foo--1'], 
-                         b.get_ancestry('tester@foo--1'))
 
     def test_none_is_always_an_ancestor(self):
         b = Branch.initialize('.')

=== modified file 'bzrlib/selftest/test_commit.py'
--- bzrlib/selftest/test_commit.py	2005-10-06 07:03:33 +0000
+++ bzrlib/selftest/test_commit.py	2005-09-27 07:24:40 +0000
@@ -145,14 +145,14 @@
         self.assertFalse(tree1.has_filename('fruity'))
         self.check_inventory_shape(tree1.inventory, ['hello'])
         ie = tree1.inventory['hello-id']
-        eq(ie.revision, 'test@rev-1')
+        eq(ie.name_version, 'test@rev-1')
 
         tree2 = b.revision_tree('test@rev-2')
         eq(tree2.id2path('hello-id'), 'fruity')
         eq(tree2.get_file_text('hello-id'), 'contents of hello\n')
         self.check_inventory_shape(tree2.inventory, ['fruity'])
         ie = tree2.inventory['hello-id']
-        eq(ie.revision, 'test@rev-2')
+        eq(ie.name_version, 'test@rev-2')
 
 
     def test_reused_rev_id(self):
@@ -198,9 +198,9 @@
                                    ['a', 'a/b/hello', 'a/b'])
 
         inv = b.get_revision_inventory(r4)
-        eq(inv['hello-id'].revision, r4)
-        eq(inv['a-id'].revision, r1)
-        eq(inv['b-id'].revision, r3)
+        eq(inv['hello-id'].name_version, r4)
+        eq(inv['a-id'].name_version, r1)
+        eq(inv['b-id'].name_version, r3)
 
         
     def test_removed_commit(self):
@@ -234,15 +234,3 @@
         for i in range(4):
             anc = b.get_ancestry(rev_ids[i])
             eq(anc, [None] + rev_ids[:i+1])
-
-    def test_commit_new_subdir_child_selective(self):
-        b = Branch.initialize('.')
-        self.build_tree(['dir/', 'dir/file1', 'dir/file2'])
-        b.add(['dir', 'dir/file1', 'dir/file2'],
-              ['dirid', 'file1id', 'file2id'])
-        b.commit('dir/file1', specific_files=['dir/file1'], rev_id='1')
-        inv = b.get_inventory('1')
-        self.assertEqual('1', inv['dirid'].revision)
-        self.assertEqual('1', inv['file1id'].revision)
-        # FIXME: This should raise a KeyError I think, rbc20051006
-        self.assertRaises(BzrError, inv.__getitem__, 'file2id')

=== modified file 'bzrlib/selftest/test_commit_merge.py'
--- bzrlib/selftest/test_commit_merge.py	2005-09-30 14:27:41 +0000
+++ bzrlib/selftest/test_commit_merge.py	2005-09-27 07:24:40 +0000
@@ -91,8 +91,8 @@
         commit(by, 'merge from x', rev_id='y@u-0-2', allow_pointless=False)
         tree = by.revision_tree('y@u-0-2')
         inv = tree.inventory
-        self.assertEquals(inv['ecks-id'].revision, 'x@u-0-1')
-        self.assertEquals(inv['why-id'].revision, 'y@u-0-1')
+        self.assertEquals(inv['ecks-id'].text_version, 'x@u-0-1')
+        self.assertEquals(inv['why-id'].text_version, 'y@u-0-1')
 
         check(bx)
         check(by)

=== removed file 'bzrlib/selftest/test_conflicts.py'
--- bzrlib/selftest/test_conflicts.py	2005-10-06 03:15:08 +0000
+++ bzrlib/selftest/test_conflicts.py	1970-01-01 00:00:00 +0000
@@ -1,44 +0,0 @@
-# Copyright (C) 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-import os
-
-from bzrlib.selftest import TestCaseInTempDir
-from bzrlib.branch import Branch
-from bzrlib.commit import Commit
-
-
-# TODO: Test commit with some added, and added-but-missing files
-
-class TestConflicts(TestCaseInTempDir):
-
-    def test_conflicts(self):
-        """Conflicts are detected properly"""
-        b = Branch.initialize('.')
-        file('hello', 'w').write('hello world')
-        file('hello.BASE', 'w').write('hello world')
-        file('hello.sploo.BASE', 'w').write('yellow world')
-        tree = b.working_tree()
-        self.assertEqual(len(list(tree.list_files())), 3)
-        conflicts = list(tree.iter_conflicts())
-        self.assertEqual(len(conflicts), 2)
-        assert 'hello' in conflicts
-        assert 'hello.sploo' in conflicts
-        os.unlink('hello.BASE')
-        os.unlink('hello.sploo.BASE')
-        self.assertEqual(len(list(tree.iter_conflicts())), 0)
-

=== modified file 'bzrlib/selftest/test_merge_core.py'
--- bzrlib/selftest/test_merge_core.py	2005-10-03 15:19:25 +0000
+++ bzrlib/selftest/test_merge_core.py	2005-09-26 08:56:15 +0000
@@ -6,8 +6,7 @@
 from bzrlib.selftest import TestCaseInTempDir, TestCase
 from bzrlib.branch import ScratchBranch, Branch
 from bzrlib.errors import NotBranchError, NotVersionedError
-from bzrlib.inventory import RootEntry
-import bzrlib.inventory as inventory
+from bzrlib.inventory import InventoryEntry, RootEntry
 from bzrlib.osutils import file_kind, rename
 from bzrlib import changeset
 from bzrlib.merge_core import (ApplyMerge3, make_merge_changeset,
@@ -39,14 +38,7 @@
                 break
         if path != dir:
             raise Exception("Can't find parent for %s" % name)
-        if kind not in ('directory', 'file', 'symlink'):
-            raise ValueError('unknown kind %r' % kind)
-        if kind == 'directory':
-            return inventory.InventoryDirectory(file_id, name, parent_id)
-        elif kind == 'file':
-            return inventory.InventoryFile(file_id, name, parent_id)
-        else:
-            return inventory.InventoryLink(file_id, name, parent_id)
+        return InventoryEntry(file_id, name, kind, parent_id)
 
 
 class MergeTree(object):
@@ -478,7 +470,7 @@
     def test_trivial_star_merge(self):
         """Test that merges in a star shape Just Work.""" 
         from bzrlib.add import smart_add_branch, add_reporter_null
-        from bzrlib.clone import copy_branch
+        from bzrlib.branch import copy_branch
         from bzrlib.merge import merge
         # John starts a branch
         self.build_tree(("original/", "original/file1", "original/file2"))

=== modified file 'bzrlib/selftest/test_parent.py'
--- bzrlib/selftest/test_parent.py	2005-09-29 20:34:25 +0000
+++ bzrlib/selftest/test_parent.py	2005-09-27 07:24:40 +0000
@@ -17,8 +17,7 @@
 
 import os
 from bzrlib.selftest import TestCaseInTempDir
-from bzrlib.branch import Branch
-from bzrlib.clone import copy_branch
+from bzrlib.branch import Branch, copy_branch
 
 
 """Tests for Branch parent URL"""

=== modified file 'bzrlib/selftest/test_smart_add.py'
--- bzrlib/selftest/test_smart_add.py	2005-10-03 15:19:25 +0000
+++ bzrlib/selftest/test_smart_add.py	2005-09-09 11:37:44 +0000
@@ -4,7 +4,6 @@
 from bzrlib.selftest import TestCaseInTempDir, TestCase
 from bzrlib.branch import Branch
 from bzrlib.errors import NotBranchError, NotVersionedError
-from bzrlib.inventory import InventoryFile
 
 class TestSmartAdd(TestCaseInTempDir):
 
@@ -144,8 +143,9 @@
 class TestAddCallbacks(TestCaseInTempDir):
 
     def setUp(self):
+        from bzrlib.inventory import InventoryEntry
         super(TestAddCallbacks, self).setUp()
-        self.entry = InventoryFile("id", "name", None)
+        self.entry = InventoryEntry("id", "name", "file", None)
 
     def test_null_callback(self):
         from bzrlib.add import add_reporter_null

=== removed file 'bzrlib/selftest/test_upgrade.py'
--- bzrlib/selftest/test_upgrade.py	2005-10-06 11:26:51 +0000
+++ bzrlib/selftest/test_upgrade.py	1970-01-01 00:00:00 +0000
@@ -1,240 +0,0 @@
-# Copyright (C) 2005 by Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Tests for upgrade of old trees.
-
-This file contains canned versions of some old trees, which are instantiated 
-and then upgraded to the new format."""
-
-import base64
-import os
-import sys
-
-from bzrlib.selftest import TestCase, TestCaseInTempDir
-from bzrlib.branch import Branch
-from bzrlib.revision import is_ancestor
-from bzrlib.upgrade import upgrade
-from bzrlib.selftest.treeshape import build_tree_contents
-
-
-class TestUpgrade(TestCaseInTempDir):
-    
-    def test_build_tree(self):
-        """Test tree-building test helper"""
-        build_tree_contents(_upgrade1_template)
-        self.failUnlessExists('foo')
-        self.failUnlessExists('.bzr/README')
-
-    def test_upgrade_simple(self):
-        """Upgrade simple v0.0.4 format to v5"""
-        eq = self.assertEquals
-        build_tree_contents(_upgrade1_template)
-        upgrade('.')
-        b = Branch.open('.')
-        eq(b._branch_format, 5)
-        rh = b.revision_history()
-        eq(rh,
-           ['mbp@sourcefrog.net-20051004035611-176b16534b086b3c',
-            'mbp@sourcefrog.net-20051004035756-235f2b7dcdddd8dd'])
-        t = b.revision_tree(rh[0])
-        foo_id = 'foo-20051004035605-91e788d1875603ae'
-        eq(t.get_file_text(foo_id), 'initial contents\n')
-        t = b.revision_tree(rh[1])
-        eq(t.get_file_text(foo_id), 'new contents\n')
-
-    def test_upgrade_with_ghosts(self):
-        """Upgrade v0.0.4 tree containing ghost references.
-
-        That is, some of the parents of revisions mentioned in the branch
-        aren't present in the branches storage. 
-
-        This shouldn't normally happen in branches created entirely in 
-        bzr but can happen in imports from baz and arch, or from other  
-        systems, where the importer knows about a revision but not 
-        its contents."""
-        eq = self.assertEquals
-        build_tree_contents(_ghost_template)
-        upgrade('.')
-        b = Branch.open('.')
-        revision_id = b.revision_history()[1]
-        rev = b.get_revision(revision_id)
-        eq(len(rev.parent_ids), 2)
-        eq(rev.parent_ids[1], 'wibble@wobble-2')
-
-    def test_upgrade_makes_dir_weaves(self):
-        build_tree_contents(_upgrade_dir_template)
-        upgrade('.')
-        self.failUnlessExists(
-            '.bzr/weaves/dir-20051005095101-da1441ea3fa6917a.weave')
-
-
-_upgrade1_template = \
-     [
-     ('foo', 'new contents\n'),
-     ('.bzr/',),
-     ('.bzr/README',
-      'This is a Bazaar-NG control directory.\nDo not change any files in this directory.\n'),
-     ('.bzr/branch-format', 'Bazaar-NG branch, format 0.0.4\n'),
-     ('.bzr/revision-history',
-      'mbp@sourcefrog.net-20051004035611-176b16534b086b3c\n'
-      'mbp@sourcefrog.net-20051004035756-235f2b7dcdddd8dd\n'),
-     ('.bzr/merged-patches', ''),
-     ('.bzr/pending-merged-patches', ''),
-     ('.bzr/branch-name', ''),
-     ('.bzr/branch-lock', ''),
-     ('.bzr/pending-merges', ''),
-     ('.bzr/inventory',
-      '<inventory>\n'
-      '<entry file_id="foo-20051004035605-91e788d1875603ae" kind="file" name="foo" />\n'
-      '</inventory>\n'),
-     ('.bzr/stat-cache',
-      '### bzr hashcache v5\n'
-      'foo// be9f309239729f69a6309e970ef24941d31e042c 13 1128398176 1128398176 303464 770\n'),
-     ('.bzr/text-store/',),
-     ('.bzr/text-store/foo-20051004035611-1591048e9dc7c2d4.gz',
-      '\x1f\x8b\x08\x00[\xfdAC\x02\xff\xcb\xcc\xcb,\xc9L\xccQH\xce\xcf+I\xcd+)\xe6\x02\x00\xdd\xcc\xf90\x11\x00\x00\x00'),
-     ('.bzr/text-store/foo-20051004035756-4081373d897c3453.gz',
-      '\x1f\x8b\x08\x00\xc4\xfdAC\x02\xff\xcbK-WH\xce\xcf+I\xcd+)\xe6\x02\x00g\xc3\xdf\xc9\r\x00\x00\x00'),
-     ('.bzr/inventory-store/',),
-     ('.bzr/inventory-store/mbp@sourcefrog.net-20051004035611-176b16534b086b3c.gz',
-      '\x1f\x8b\x08\x00[\xfdAC\x02\xffm\x8f\xcd\n\xc20\x10\x84\xef>E\xc8\xbdt7?M\x02\xad\xaf"\xa1\x99`P[\xa8E\xacOo\x14\x05\x0f\xdef\xe1\xfbv\x98\xbeL7L\xeb\xbcl\xfb]_\xc3\xb2\x89\\\xce8\x944\xc8<\xcf\x8d"\xb2LdH\xdb\x8el\x13\x18\xce\xfb\xc4\xde\xd5SGHq*\xd3\x0b\xad\x8e\x14S\xbc\xe0\xadI\xb1\xe2\xbe\xfe}\xc2\xdc\xb0\rL\xc6#\xa4\xd1\x8d*\x99\x0f}=F\x1e$8G\x9d\xa0\x02\xa1rP9\x01c`FV\xda1qg\x98"\x02}\xa5\xf2\xa8\x95\xec\xa4h\xeb\x80\xf6g\xcd\x13\xb3\x01\xcc\x98\xda\x00\x00\x00'),
-     ('.bzr/inventory-store/mbp@sourcefrog.net-20051004035756-235f2b7dcdddd8dd.gz',
-      '\x1f\x8b\x08\x00\xc4\xfdAC\x02\xffm\x8f\xc1\n\xc20\x10D\xef~E\xc8\xbd\xb8\x9bM\x9a,\xb4\xfe\x8a\xc4f\x83Am\xa1\x16\xb1~\xbdQ\x14<x\x9b\x81y3LW\xc6\x9b\x8c\xcb4\xaf\xbbMW\xc5\xbc\xaa\\\xce\xb2/\xa9\xd7y\x9a\x1a\x03\xe0\x10\xc0\x02\xb9\x16\\\xc3(>\x84\x84\xc1WKQ\xb4:\x95\xf1\x15\xad\x8cVc\xbc\xc8\x1b\xd3j\x91\xfb\xf2\xaf\xa4r\x8d\x85\x80\xe4)\x05\xf6\x03YG\x9f\xf4\xf5\x18\xb1\xd7\x07\xe1L\xc0\x86\xd8\x1b\xce-\xc7\xb6:a\x0f\x92\x8de\x8b\x89P\xc0\x9a\xe1\x0b\x95G\x9d\xc4\xda\xb1\xad\x07\xb6?o\x9e\xb5\xff\xf0\xf9\xda\x00\x00\x00'),
-     ('.bzr/revision-store/',),
-     ('.bzr/revision-store/mbp@sourcefrog.net-20051004035611-176b16534b086b3c.gz',
-      '\x1f\x8b\x08\x00[\xfdAC\x02\xff\x9d\x8eKj\xc30\x14E\xe7^\x85\xd0 \xb3$\xefI\xd1\x8f\xd8\xa6\x1b(t\x07E?\xbb\x82H\n\xb2\x1ahW\xdfB1\x14:\xeb\xf4r\xee\xbdgl\xf1\x91\xb6T\x0b\xf15\xe7\xd4{l\x13}\xb6\xad\xa7B^j\xbd\x91\xc3\xad_\xb3\xbb?m\xf5\xbd\xf9\xb8\xb4\xba\x9eJ\xec\x87\xb5_)I\xe5\x11K\xaf\xed\xe35\x85\x89\xfe\xa5\x8e\x0c@ \xc0\x05\xb8\x90\x88GT\xd2\xa1\x14\xfc\xe2@K\xc7\xfd\xef\x85\xed\xcd\xe2D\x95\x8d\x1a\xa47<\x02c2\xb0 \xbc\xd0\x8ay\xa3\xbcp\x8a\x83\x12A3\xb7XJv\xef\x7f_\xf7\x94\xe3\xd6m\xbeO\x14\x91in4*<\x812\x88\xc60\xfc\x01>k\x89\x13\xe5\x12\x00\xe8<\x8c\xdf\x8d\xcd\xaeq\xb6!\x90\xa5\xd6\xf1\xbc\x07\xc3x\xde\x85\xe6\xe1\x0b\xc8\x8a\x98\x03T\x01\x00\x00'),
-     ('.bzr/revision-store/mbp@sourcefrog.net-20051004035756-235f2b7dcdddd8dd.gz',
-      '\x1f\x8b\x08\x00\xc4\xfdAC\x02\xff\x9d\x90Kj\x031\x0c\x86\xf79\xc5\xe0Ev\xe9\xc8o\x9b\xcc\x84^\xa0\xd0\x1b\x14\xbf&5d\xec`\xbb\x81\xf6\xf45\x84\xa4\x81\xaeZ\xa1\x85\x84^\xdf\xaf\xa9\x84K\xac1\xa7\xc1\xe5u\x8d\xad\x852\xa3\x17SZL\xc3k\xce\xa7a{j\xfb\xd5\x9e\x9fk\xfe(.,%\x1f\x9fRh\xdbc\xdb\xa3!\xa6KH-\x97\xcf\xb7\xe8g\xf4\xbbkG\x008\x06`@\xb9\xe4bG(_\x88\x95\xde\xf9n\xca\xfb\xc7\r\xf5\xdd\xe0\x19\xa9\x85)\x81\xf5"\xbd\x04j\xb8\x02b\xa8W\\\x0b\xc9\x14\xf4\xbc\xbb\xd7\xd6H4\xdc\xb8\xff}\xba\xc55\xd4f\xd6\xf3\x8c0&\x8ajE\xa4x\xe2@\xa5\xa6\x9a\xf3k\xc3WNaFT\x00\x00:l\xa6>Q\xcd1\x1cjp9\xf9;\xc34\xde\n\x9b\xe9lJWT{t\',a\xf9\x0b\xae\xc0x\x87\xa5\xb0Xp\xca,(a\xa9{\xd0{}\xd4\x12\x04(\xc5\xbb$\xc5$V\xceaI\x19\x01\xa2\x1dh\xed\x82d\x8c.\xccr@\xc3\xd8Q\xc6\x1f\xaa\xf1\xb6\xe8\xb0\xf9\x06QR\r\xf9\xfc\x01\x00\x00')]
-
-
-_ghost_template = [
-    ( './foo',
-        'hello\n'
-    ),
-    ( './.bzr/', ),
-    ( './.bzr/README',
-        'This is a Bazaar-NG control directory.\n'
-        'Do not change any files in this directory.\n'
-    ),
-    ( './.bzr/branch-format',
-        'Bazaar-NG branch, format 0.0.4\n'
-    ),
-    ( './.bzr/branch-lock',
-        ''
-    ),
-    ( './.bzr/branch-name',
-        ''
-    ),
-    ( './.bzr/inventory',
-        '<inventory>\n'
-        '<entry file_id="foo-20051004104918-0379cb7c76354cde" kind="file" name="foo" />\n'
-        '</inventory>\n'
-    ),
-    ( './.bzr/merged-patches',
-        ''
-    ),
-    ( './.bzr/pending-merged-patches',
-        ''
-    ),
-    ( './.bzr/pending-merges',
-        ''
-    ),
-    ( './.bzr/revision-history',
-        'mbp@sourcefrog.net-20051004104921-a98be2278dd30b7b\n'
-        'mbp@sourcefrog.net-20051004104937-c9b7a7bfcc0bb22d\n'
-    ),
-    ( './.bzr/stat-cache',
-        '### bzr hashcache v5\n'
-        'foo// f572d396fae9206628714fb2ce00f72e94f2258f 6 1128422956 1128422956 306900 770\n'
-    ),
-    ( './.bzr/text-store/', ),
-    ( './.bzr/text-store/foo-20051004104921-8de8118a71be45ba.gz',
-        '\x1f\x8b\x08\x081^BC\x00\x03foo-20051004104921-8de8118a71be45ba\x00\xcbH\xcd\xc9\xc9\xe7\x02\x00 0:6\x06\x00\x00\x00'
-    ),
-    ( './.bzr/inventory-store/', ),
-    ( './.bzr/inventory-store/mbp@sourcefrog.net-20051004104921-a98be2278dd30b7b.gz',
-        '\x1f\x8b\x08\x081^BC\x00\x03mbp@sourcefrog.net-20051004104921-a98be2278dd30b7b\x00m\x8f\xcb\n'
-        '\xc20\x10E\xf7~E\xc8\xbe83\xcd\x13\xaa\xbf"yL0\xa8-\xd4"\xd6\xaf7\x8a\x82\x0bw\xb38\xe7\xde;C\x1do<.\xd3\xbc\xee7C;\xe6U\x94z\xe6C\xcd;Y\xa6\xa9#\x00\x8d\x00\n'
-        'Ayt\x1d\xf4\xd6\xa7h\x935\xbdV)\xb3\x14\xa7:\xbe\xd0\xe6H1\x86\x0b\xbf5)\x16\xbe/\x7fC\x08;\x97\xd9!\xba`1\xb2\xd21|\xe8\xeb1`\xe3\xb5\xa5\xdc{S\x02{\x02c\xc8YT%Rb\x80b\x89\xbd*D\xda\x95\xafT\x1f\xad\xd2H\xb1m\xfb\xb7?\xcf<\x01W}\xb5\x8b\xd9\x00\x00\x00'
-    ),
-    ( './.bzr/inventory-store/mbp@sourcefrog.net-20051004104937-c9b7a7bfcc0bb22d.gz',
-        '\x1f\x8b\x08\x08A^BC\x00\x03mbp@sourcefrog.net-20051004104937-c9b7a7bfcc0bb22d\x00m\x8f\xcb\n'
-        '\xc20\x10E\xf7~E\xc8\xbe83\xcd\x13\xaa\xbf"yL0\xa8-\xd4"\xd6\xaf7\x8a\x82\x0bw\xb38\xe7\xde;C\x1do<.\xd3\xbc\xee7C;\xe6U\x94z\xe6C\xcd;Y\xa6\xa9#\x00\x8d\x00\n'
-        'Ayt\x1d\xf4\xd6\xa7h\x935\xbdV)\xb3\x14\xa7:\xbe\xd0\xe6H1\x86\x0b\xbf5)\x16\xbe/\x7fC\x08;\x97\xd9!\xba`1\xb2\xd21|\xe8\xeb1`\xe3\xb5\xa5\xdc{S\x02{\x02c\xc8YT%Rb\x80b\x89\xbd*D\xda\x95\xafT\x1f\xad\xd2H\xb1m\xfb\xb7?\xcf<\x01W}\xb5\x8b\xd9\x00\x00\x00'
-    ),
-    ( './.bzr/revision-store/', ),
-    ( './.bzr/revision-store/mbp@sourcefrog.net-20051004104921-a98be2278dd30b7b.gz',
-        '\x1f\x8b\x08\x081^BC\x00\x03mbp@sourcefrog.net-20051004104921-a98be2278dd30b7b\x00\x9d\x8eMj\xc30\x14\x84\xf7>\x85\xd0"\xbb$\xef\xc9\xb6,\x11\xdb\xf4\x02\x85\xde\xa0\xe8\xe7\xd9\x11\xc4R\x90\xd4@{\xfa\x06\x8a\xa1\xd0]\x97\x03\xdf\xcc|c\xa6G(!E\xe6\xd2\xb6\x85Z)O\xfc\xd5\xe4\x1a"{K\xe9\xc6\x0e\xb7z\xd9\xec\xfd\xa5\xa4\x8f\xech\xc9i=E\xaa\x87\xb5^8\x0b\xf1A\xb1\xa6\xfc\xf9\x1e\xfc\xc4\xffRG\x01\xd0#@\x87\xd0i\x81G\xa3\x95%!\x06\xe5}\x0bv\xb0\xbf\x17\xca\xd5\xe0\xc4-\xa0\xb1\x8b\xb6`\xc0I\xa4\xc5\xf4\x9el\xef\x95v [\x94\xcf\x8e\xd5\xcay\xe4l\xf7\xfe\xf7u\r'
-        '\x1b\x95j\xb6\xfb\xc4\x11\x85\xea\x84\xd0\x12O\x03t\x83D\xad\xc4\x0f\xf0\x95"M\xbc\x95\x00\xc0\xe7f|6\x8aYi^B.u<\xef\xb1\x19\xcf\xbb\xce\xdc|\x038=\xc7\xe6R\x01\x00\x00'
-    ),
-    ( './.bzr/revision-store/mbp@sourcefrog.net-20051004104937-c9b7a7bfcc0bb22d.gz',
-        '\x1f\x8b\x08\x08A^BC\x00\x03mbp@sourcefrog.net-20051004104937-c9b7a7bfcc0bb22d\x00\x9d\x90\xc1j\xc30\x0c\x86\xef}\n'
-        "\xe3Coie'\xb1c\x9a\x94\xbe\xc0`o0,[N\x03M\\\x1c\xafe{\xfae\x94n\x85\xc1`;Y\x88O\xd2\xff\xb9Mt\x19\xe6!N\xcc\xc5q\x1cr\xa6\xd4\xf1'\x9b\xf20\xb1\xe7\x18Ol}\xca\xbb\x11\xcf\x879\xbe&G!\xc5~3Q^\xf7y\xc7\xd90]h\xca1\xbd\xbd\x0c\xbe\xe3?\xa9B\x02\xd4\x02\xa0\x12P\x99R\x17\xce\xa0\xb6\x1a\x83s\x80(\xa5\x7f\xdc0\x1f\xad\xe88\x82\xb0\x18\x0c\x82\x05\xa7\x04\x05[{\xc2\xda7\xc6\x81*\x85B\x8dh\x1a\xe7\x05g\xf7\xdc\xff>\x9d\x87\x91\xe6l\xc7s\xc7\x85\x90M%\xa5\xd1z#\x85\xa8\x9b\x1a\xaa\xfa\x06\xbc\xc7\x89:^*\x00\xe0\xfbU\xbbL\xcc\xb6\xa7\xfdH\xa9'\x16\x03\xeb\x8fq\xce\xed\xf6\xde_\xb5g\x9b\x16\xa1y\xa9\xbe\x02&\n"
-        '\x7fJ+EaM\x83$\xa5n\xbc/a\x91~\xd0\xbd\xfd\x135\n'
-        '\xd0\x9a`\x0c*W\x1aR\xc1\x94du\x08(\t\xb0\x91\xdeZ\xa3\x9cU\x9cm\x7f\x8dr\x1d\x10Ot\xb8\xc6\xcf\xa7\x907|\xfb-\xb1\xbd\xd3\xfb\xd5\x07\xeeD\xee\x08*\x02\x00\x00'
-    ),
-]
-
-_upgrade_dir_template = [
-    ( './.bzr/', ),
-    ( './.bzr/README',
-        'This is a Bazaar-NG control directory.\n'
-        'Do not change any files in this directory.\n'
-    ),
-    ( './.bzr/branch-format',
-        'Bazaar-NG branch, format 0.0.4\n'
-    ),
-    ( './.bzr/branch-lock',
-        ''
-    ),
-    ( './.bzr/branch-name',
-        ''
-    ),
-    ( './.bzr/inventory',
-        '<inventory>\n'
-        '<entry file_id="dir-20051005095101-da1441ea3fa6917a" kind="directory" name="dir" />\n'
-        '</inventory>\n'
-    ),
-    ( './.bzr/merged-patches',
-        ''
-    ),
-    ( './.bzr/pending-merged-patches',
-        ''
-    ),
-    ( './.bzr/pending-merges',
-        ''
-    ),
-    ( './.bzr/revision-history',
-        'robertc@robertcollins.net-20051005095108-6065fbd8e7d8617e\n'
-    ),
-    ( './.bzr/stat-cache',
-        '### bzr hashcache v5\n'
-    ),
-    ( './.bzr/text-store/', ),
-    ( './.bzr/inventory-store/', ),
-    ( './.bzr/inventory-store/robertc@robertcollins.net-20051005095108-6065fbd8e7d8617e.gz',
-        '\x1f\x8b\x08\x00\x0c\xa2CC\x02\xff\xb3\xc9\xcc+K\xcd+\xc9/\xaa\xb4\xe3\xb2\x012\x8a*\x15\xd22sR\xe33Sl\x95R2\x8bt\x8d\x0c\x0cL\r'
-        "\x81\xd8\xc0\x12H\x19\xea\xa6$\x1a\x9a\x98\x18\xa6&\x1a\xa7%\x9aY\x1a\x9a'*)dg\xe6A\x94\xa6&\x83LQR\xc8K\xccM\x05\x0b()\xe8\x03\xcd\xd4G\xb2\x00\x00\xc2<\x94\xb1m\x00\x00\x00"
-    ),
-    ( './.bzr/revision-store/', ),
-    ( './.bzr/revision-store/robertc@robertcollins.net-20051005095108-6065fbd8e7d8617e.gz',
-        '\x1f\x8b\x08\x00\x0c\xa2CC\x02\xff\xa5OKj\xc30\x14\xdc\xfb\x14B\x8b\xec\x92<I\xd6\xc7\xc42\x85\xde\xa0\x17(\xb6\xf4\x9c\n'
-        'l\xa9H"\x90\x9c\xbe\xa6\xa9\xa1\x9b\xae\xbax\x0c\xcc\xe71\xd3g\xbc\x85\x12R$.\xadk\xa8\x15\xb3\xa5oi\xc2\\\xc9kZ\x96\x10\x0b9,\xf5\x92\xbf)\xf7\xf2\x83O\xe5\x14\xb1\x1e\xae\xf5BI\x887\x8c5\xe5\xfb{\xf0\x96\xfei>r\x00\xc9\xb6\x83n\x03sT\xa0\xe4<y\x83\xda\x1b\xc54\xfe~T>Ff\xe9\xcc:\xdd\x8e\xa6E\xc7@\xa2\x82I\xaaNL\xbas\\313)\x00\xb9\xe6\xe0(\xd9\x87\xfc\xb7A\r'
-        "+\x96:\xae\x9f\x962\xc6\x8d\x04i\x949\x01\x97R\xb7\x1d\x17O\xc3#E\xb4T(\x00\xa0C\xd3o\x892^q\x18\xbd'>\xe4\xfe\xbc\x13M\x7f\xde{\r"
-        '\xcd\x17\x85\xea\xba\x03l\x01\x00\x00'
-    ),
-    ( './dir/', ),
-]

=== modified file 'bzrlib/selftest/test_weave.py'
--- bzrlib/selftest/test_weave.py	2005-10-06 10:53:12 +0000
+++ bzrlib/selftest/test_weave.py	2005-09-19 10:22:06 +0000
@@ -25,11 +25,22 @@
 
 from pprint import pformat
 
+import testsweet
 from bzrlib.weave import Weave, WeaveFormatError, WeaveError
 from bzrlib.weavefile import write_weave, read_weave
 from bzrlib.selftest import TestCase
 from bzrlib.osutils import sha_string
 
+try:
+    set
+    frozenset
+except NameError:
+    from sets import Set, ImmutableSet
+    set = Set
+    frozenset = ImmutableSet
+    del Set, ImmutableSet
+
+
 
 # texts for use in testing
 TEXT_0 = ["Hello world"]
@@ -791,106 +802,7 @@
                      ['aaa', 'ddd', 'ccc'],
                      ['aaa', 'ccc'],
                      ['<<<<', 'aaa', '====', '>>>>', 'ccc'])
-
-
-class JoinWeavesTests(TestBase):
-    def setUp(self):
-        super(JoinWeavesTests, self).setUp()
-        self.weave1 = Weave()
-        self.lines1 = ['hello\n']
-        self.lines3 = ['hello\n', 'cruel\n', 'world\n']
-        self.weave1.add('v1', [], self.lines1)
-        self.weave1.add('v2', [0], ['hello\n', 'world\n'])
-        self.weave1.add('v3', [1], self.lines3)
-        
-    def test_join_empty(self):
-        """Join two empty weaves."""
-        eq = self.assertEqual
-        w1 = Weave()
-        w2 = Weave()
-        w1.join(w2)
-        eq(w1.numversions(), 0)
-        
-    def test_join_empty_to_nonempty(self):
-        """Join empty weave onto nonempty."""
-        self.weave1.join(Weave())
-        self.assertEqual(len(self.weave1), 3)
-
-    def test_join_unrelated(self):
-        """Join two weaves with no history in common."""
-        wb = Weave()
-        wb.add('b1', [], ['line from b\n'])
-        w1 = self.weave1
-        w1.join(wb)
-        eq = self.assertEqual
-        eq(len(w1), 4)
-        eq(sorted(list(w1.iter_names())),
-           ['b1', 'v1', 'v2', 'v3'])
-
-    def test_join_related(self):
-        wa = self.weave1.copy()
-        wb = self.weave1.copy()
-        wa.add('a1', ['v3'], ['hello\n', 'sweet\n', 'world\n'])
-        wb.add('b1', ['v3'], ['hello\n', 'pale blue\n', 'world\n'])
-        eq = self.assertEquals
-        eq(len(wa), 4)
-        eq(len(wb), 4)
-        wa.join(wb)
-        eq(len(wa), 5)
-        eq(wa.get_lines('b1'),
-           ['hello\n', 'pale blue\n', 'world\n'])
-
-    def test_join_parent_disagreement(self):
-        """Cannot join weaves with different parents for a version."""
-        wa = Weave()
-        wb = Weave()
-        wa.add('v1', [], ['hello\n'])
-        wb.add('v0', [], [])
-        wb.add('v1', ['v0'], ['hello\n'])
-        self.assertRaises(WeaveError,
-                          wa.join, wb)
-
-    def test_join_text_disagreement(self):
-        """Cannot join weaves with different texts for a version."""
-        wa = Weave()
-        wb = Weave()
-        wa.add('v1', [], ['hello\n'])
-        wb.add('v1', [], ['not\n', 'hello\n'])
-        self.assertRaises(WeaveError,
-                          wa.join, wb)
-
-    def test_join_unordered(self):
-        """Join weaves where indexes differ.
-        
-        The source weave contains a different version at index 0."""
-        wa = self.weave1.copy()
-        wb = Weave()
-        wb.add('x1', [], ['line from x1\n'])
-        wb.add('v1', [], ['hello\n'])
-        wb.add('v2', ['v1'], ['hello\n', 'world\n'])
-        wa.join(wb)
-        eq = self.assertEquals
-        eq(sorted(wa.iter_names()), ['v1', 'v2', 'v3', 'x1',])
-        eq(wa.get_text('x1'), 'line from x1\n')
-
-    def test_join_with_ghosts(self):
-        """Join that inserts parents of an existing revision.
-
-        This can happen when merging from another branch who
-        knows about revisions the destination does not.  In 
-        this test the second weave knows of an additional parent of 
-        v2.  Any revisions which are in common still have to have the 
-        same text."""
-        return ###############################
-        wa = self.weave1.copy()
-        wb = Weave()
-        wb.add('x1', [], ['line from x1\n'])
-        wb.add('v1', [], ['hello\n'])
-        wb.add('v2', ['v1', 'x1'], ['hello\n', 'world\n'])
-        wa.join(wb)
-        eq = self.assertEquals
-        eq(sorted(wa.iter_names()), ['v1', 'v2', 'v3', 'x1',])
-        eq(wa.get_text('x1'), 'line from x1\n')
+    
 
 
 if __name__ == '__main__':

=== modified file 'bzrlib/selftest/test_xml.py'
--- bzrlib/selftest/test_xml.py	2005-09-30 14:27:41 +0000
+++ bzrlib/selftest/test_xml.py	2005-09-19 08:02:41 +0000
@@ -60,14 +60,16 @@
 _committed_inv_v5 = """<inventory>
 <file file_id="bar-20050901064931-73b4b1138abc9cd2" 
       name="bar" parent_id="TREE_ROOT" 
-      revision="mbp@foo-123123"/>
+      text_version="mbp@foo-123123" name_version="mbp@foo-123123"
+      />
 <directory name="subdir"
            file_id="foo-20050801201819-4139aa4a272f4250"
            parent_id="TREE_ROOT" 
-           revision="mbp@foo-00"/>
+           name_version="mbp@foo-00"/>
 <file file_id="bar-20050824000535-6bc48cfad47ed134" 
       name="bar" parent_id="foo-20050801201819-4139aa4a272f4250" 
-      revision="mbp@foo-00"/>
+      name_version="mbp@foo-00"
+      text_version="mbp@foo-123123"/>
 </inventory>
 """
 
@@ -113,7 +115,8 @@
         eq(len(inv), 4)
         ie = inv['bar-20050824000535-6bc48cfad47ed134']
         eq(ie.kind, 'file')
-        eq(ie.revision, 'mbp@foo-00')
+        eq(ie.text_version, 'mbp@foo-123123')
+        eq(ie.name_version, 'mbp@foo-00')
         eq(ie.name, 'bar')
         eq(inv[ie.parent_id].kind, 'directory')
 

=== modified file 'bzrlib/selftest/testbranch.py'
--- bzrlib/selftest/testbranch.py	2005-10-02 23:48:11 +0000
+++ bzrlib/selftest/testbranch.py	2005-09-28 09:35:50 +0000
@@ -15,14 +15,12 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 import os
-from bzrlib.branch import Branch
-from bzrlib.clone import copy_branch
+from bzrlib.branch import Branch, copy_branch
 from bzrlib.commit import commit
 from bzrlib.errors import NoSuchRevision, UnlistableBranch
 from bzrlib.selftest import TestCaseInTempDir
 from bzrlib.trace import mutter
 
-
 class TestBranch(TestCaseInTempDir):
 
     def test_append_revisions(self):
@@ -33,6 +31,9 @@
         br.append_revision("rev2", "rev3")
         self.assertEquals(br.revision_history(), ["rev1", "rev2", "rev3"])
 
+
+class TestFetch(TestCaseInTempDir):
+
     def test_fetch_revisions(self):
         """Test fetch-revision operation."""
         from bzrlib.fetch import Fetcher
@@ -81,65 +82,8 @@
         os.mkdir('c')
         br_c = copy_branch(br_a, 'c', basis_branch=br_b)
         self.assertEqual(br_a.revision_history(), br_c.revision_history())
-        ## # basis branches currently disabled for weave format
-        ## self.assertFalse(br_b.last_revision() in br_c.revision_history())
-        ## br_c.get_revision(br_b.last_revision())
-
-    def test_copy_partial(self):
-        """Copy only part of the history of a branch."""
-        self.build_tree(['a/', 'a/one'])
-        br_a = Branch.initialize('a')
-        br_a.add(['one'])
-        br_a.commit('commit one', rev_id='u@d-1')
-        self.build_tree(['a/two'])
-        br_a.add(['two'])
-        br_a.commit('commit two', rev_id='u@d-2')
-        br_b = copy_branch(br_a, 'b', revision='u@d-1')
-        self.assertEqual(br_b.last_revision(), 'u@d-1')
-        self.assertTrue(os.path.exists('b/one'))
-        self.assertFalse(os.path.exists('b/two'))
-        
-
-    def test_record_initial_ghost_merge(self):
-        """A pending merge with no revision present is still a merge."""
-        branch = Branch.initialize('.')
-        branch.add_pending_merge('non:existent@rev--ision--0--2')
-        branch.commit('pretend to merge nonexistent-revision', rev_id='first')
-        rev = branch.get_revision(branch.last_revision())
-        self.assertEqual(len(rev.parent_ids), 1)
-        # parent_sha1s is not populated now, WTF. rbc 20051003
-        self.assertEqual(len(rev.parent_sha1s), 0)
-        self.assertEqual(rev.parent_ids[0], 'non:existent@rev--ision--0--2')
-
-# TODO 20051003 RBC:
-# compare the gpg-to-sign info for a commit with a ghost and 
-#     an identical tree without a ghost
-# fetch missing should rewrite the TOC of weaves to list newly available parents.
-        
-    def test_pending_merges(self):
-        """Tracking pending-merged revisions."""
-        b = Branch.initialize('.')
-
-        self.assertEquals(b.pending_merges(), [])
-        b.add_pending_merge('foo@azkhazan-123123-abcabc')
-        self.assertEquals(b.pending_merges(), ['foo@azkhazan-123123-abcabc'])
-        b.add_pending_merge('foo@azkhazan-123123-abcabc')
-        self.assertEquals(b.pending_merges(), ['foo@azkhazan-123123-abcabc'])
-        b.add_pending_merge('wibble@fofof--20050401--1928390812')
-        self.assertEquals(b.pending_merges(),
-                          ['foo@azkhazan-123123-abcabc',
-                           'wibble@fofof--20050401--1928390812'])
-        b.commit("commit from base with two merges")
-        rev = b.get_revision(b.revision_history()[0])
-        self.assertEquals(len(rev.parent_ids), 2)
-        self.assertEquals(rev.parent_ids[0],
-                          'foo@azkhazan-123123-abcabc')
-        self.assertEquals(rev.parent_ids[1],
-                           'wibble@fofof--20050401--1928390812')
-        # list should be cleared when we do a commit
-        self.assertEquals(b.pending_merges(), [])
- 
-
+        assert br_b.last_revision() not in br_c.revision_history()
+        br_c.get_revision(br_b.last_revision())
 # TODO: rewrite this as a regular unittest, without relying on the displayed output        
 #         >>> from bzrlib.commit import commit
 #         >>> bzrlib.trace.silent = True

=== modified file 'bzrlib/selftest/testfetch.py'
--- bzrlib/selftest/testfetch.py	2005-10-06 06:31:33 +0000
+++ bzrlib/selftest/testfetch.py	2005-09-29 02:01:49 +0000
@@ -24,7 +24,6 @@
 from bzrlib.fetch import greedy_fetch
 
 from bzrlib.selftest import TestCaseInTempDir
-from bzrlib.selftest.HTTPTestUtil import TestCaseWithWebserver
 
 
 def has_revision(branch, revision_id):
@@ -55,12 +54,15 @@
     assert not has_revision(br_a, br_b.revision_history()[6])
     assert has_revision(br_a, br_b.revision_history()[5])
 
-    # When a non-branch ancestor is missing, it should be unlisted...
-    # as its not reference from the inventory weave.
-    br_b4 = new_branch('br_4')
-    count, failures = greedy_fetch(br_b4, br_b)
-    self.assertEqual(count, 7)
-    self.assertEqual(failures, [])
+    # When a non-branch ancestor is missing, it should be a failure, not
+    # exception
+    print ("CANNOT TEST MISSING NON REVISION_HISTORY ANCESTORS WITHOUT"
+           " GHOSTS")
+#    br_a4 = new_branch('br_a4')
+#    count, failures = greedy_fetch(br_a4, br_a)
+#    self.assertEqual(count, 6)
+#    self.assertEqual(failures, set((br_b.revision_history()[4],
+#                                    br_b.revision_history()[5]))) 
 
     self.assertEqual(greedy_fetch(writable_a, br_b)[0], 1)
     assert has_revision(br_a, br_b.revision_history()[3])
@@ -99,40 +101,7 @@
 class TestFetch(TestCaseInTempDir):
 
     def test_fetch(self):
+        
         #highest indices a: 5, b: 7
         br_a, br_b = make_branches()
         fetch_steps(self, br_a, br_b, br_a)
-
-
-class TestHttpFetch(TestCaseWithWebserver):
-
-    def setUp(self):
-        super(TestHttpFetch, self).setUp()
-        self.weblogs = []
-
-    def test_fetch(self):
-        #highest indices a: 5, b: 7
-        br_a, br_b = make_branches()
-        br_rem_a = Branch.open(self.get_remote_url(br_a._transport.base))
-        fetch_steps(self, br_rem_a, br_b, br_a)
-
-    def log(self, *args):
-        """Capture web server log messages for introspection."""
-        super(TestHttpFetch, self).log(*args)
-        if args[0].startswith("webserver"):
-            self.weblogs.append(args[0])
-
-    def test_weaves_are_retrieved_once(self):
-        self.build_tree(("source/", "source/file", "target/"))
-        branch = Branch.initialize("source")
-        branch.add(["file"], ["id"])
-        branch.commit("added file")
-        print >>open("source/file", 'w'), "blah"
-        branch.commit("changed file")
-        target = Branch.initialize("target/")
-        source = Branch.open(self.get_remote_url("source/"))
-        source.weave_store.enable_cache = False
-        self.assertEqual(greedy_fetch(target, source), (2, []))
-        weave_suffix = 'weaves/id.weave HTTP/1.1" 200 -'
-        self.assertEqual(1,
-            len([log for log in self.weblogs if log.endswith(weave_suffix)]))

=== modified file 'bzrlib/selftest/testinv.py'
--- bzrlib/selftest/testinv.py	2005-10-06 02:51:02 +0000
+++ bzrlib/selftest/testinv.py	2005-09-23 09:25:16 +0000
@@ -14,17 +14,10 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-from cStringIO import StringIO
 import os
+from bzrlib.selftest import TestCase
 
-from bzrlib.branch import Branch
-from bzrlib.clone import copy_branch
-import bzrlib.errors as errors
-from bzrlib.diff import internal_diff
-from bzrlib.inventory import Inventory, ROOT_ID
-import bzrlib.inventory as inventory
-from bzrlib.osutils import has_symlinks, rename
-from bzrlib.selftest import TestCase, TestCaseInTempDir
+from bzrlib.inventory import Inventory, InventoryEntry
 
 
 class TestInventory(TestCase):
@@ -66,293 +59,3 @@
         ie = inv.add_path('foo.txt', 'file')
         ## XXX
 
-
-class TestInventoryEntry(TestCase):
-
-    def test_file_kind_character(self):
-        file = inventory.InventoryFile('123', 'hello.c', ROOT_ID)
-        self.assertEqual(file.kind_character(), '')
-
-    def test_dir_kind_character(self):
-        dir = inventory.InventoryDirectory('123', 'hello.c', ROOT_ID)
-        self.assertEqual(dir.kind_character(), '/')
-
-    def test_link_kind_character(self):
-        dir = inventory.InventoryLink('123', 'hello.c', ROOT_ID)
-        self.assertEqual(dir.kind_character(), '')
-
-    def test_dir_detect_changes(self):
-        left = inventory.InventoryDirectory('123', 'hello.c', ROOT_ID)
-        left.text_sha1 = 123
-        left.executable = True
-        left.symlink_target='foo'
-        right = inventory.InventoryDirectory('123', 'hello.c', ROOT_ID)
-        right.text_sha1 = 321
-        right.symlink_target='bar'
-        self.assertEqual((False, False), left.detect_changes(right))
-        self.assertEqual((False, False), right.detect_changes(left))
-
-    def test_file_detect_changes(self):
-        left = inventory.InventoryFile('123', 'hello.c', ROOT_ID)
-        left.text_sha1 = 123
-        right = inventory.InventoryFile('123', 'hello.c', ROOT_ID)
-        right.text_sha1 = 123
-        self.assertEqual((False, False), left.detect_changes(right))
-        self.assertEqual((False, False), right.detect_changes(left))
-        left.executable = True
-        self.assertEqual((False, True), left.detect_changes(right))
-        self.assertEqual((False, True), right.detect_changes(left))
-        right.text_sha1 = 321
-        self.assertEqual((True, True), left.detect_changes(right))
-        self.assertEqual((True, True), right.detect_changes(left))
-
-    def test_symlink_detect_changes(self):
-        left = inventory.InventoryLink('123', 'hello.c', ROOT_ID)
-        left.text_sha1 = 123
-        left.executable = True
-        left.symlink_target='foo'
-        right = inventory.InventoryLink('123', 'hello.c', ROOT_ID)
-        right.text_sha1 = 321
-        right.symlink_target='foo'
-        self.assertEqual((False, False), left.detect_changes(right))
-        self.assertEqual((False, False), right.detect_changes(left))
-        left.symlink_target = 'different'
-        self.assertEqual((True, False), left.detect_changes(right))
-        self.assertEqual((True, False), right.detect_changes(left))
-
-    def test_file_has_text(self):
-        file = inventory.InventoryFile('123', 'hello.c', ROOT_ID)
-        self.failUnless(file.has_text())
-
-    def test_directory_has_text(self):
-        dir = inventory.InventoryDirectory('123', 'hello.c', ROOT_ID)
-        self.failIf(dir.has_text())
-
-    def test_link_has_text(self):
-        link = inventory.InventoryLink('123', 'hello.c', ROOT_ID)
-        self.failIf(link.has_text())
-
-
-class TestEntryDiffing(TestCaseInTempDir):
-
-    def setUp(self):
-        super(TestEntryDiffing, self).setUp()
-        self.branch = Branch.initialize('.')
-        print >> open('file', 'wb'), 'foo'
-        self.branch.add(['file'], ['fileid'])
-        if has_symlinks():
-            os.symlink('target1', 'symlink')
-            self.branch.add(['symlink'], ['linkid'])
-        self.branch.commit('message_1', rev_id = '1')
-        print >> open('file', 'wb'), 'bar'
-        if has_symlinks():
-            os.unlink('symlink')
-            os.symlink('target2', 'symlink')
-        self.tree_1 = self.branch.revision_tree('1')
-        self.inv_1 = self.branch.get_inventory('1')
-        self.file_1 = self.inv_1['fileid']
-        self.tree_2 = self.branch.working_tree()
-        self.inv_2 = self.branch.inventory
-        self.file_2 = self.inv_2['fileid']
-        if has_symlinks():
-            self.link_1 = self.inv_1['linkid']
-            self.link_2 = self.inv_2['linkid']
-
-    def test_file_diff_deleted(self):
-        output = StringIO()
-        self.file_1.diff(internal_diff, 
-                          "old_label", self.tree_1,
-                          "/dev/null", None, None,
-                          output)
-        self.assertEqual(output.getvalue(), "--- old_label\n"
-                                            "+++ /dev/null\n"
-                                            "@@ -1,1 +0,0 @@\n"
-                                            "-foo\n"
-                                            "\n")
-
-    def test_file_diff_added(self):
-        output = StringIO()
-        self.file_1.diff(internal_diff, 
-                          "new_label", self.tree_1,
-                          "/dev/null", None, None,
-                          output, reverse=True)
-        self.assertEqual(output.getvalue(), "--- /dev/null\n"
-                                            "+++ new_label\n"
-                                            "@@ -0,0 +1,1 @@\n"
-                                            "+foo\n"
-                                            "\n")
-
-    def test_file_diff_changed(self):
-        output = StringIO()
-        self.file_1.diff(internal_diff, 
-                          "/dev/null", self.tree_1, 
-                          "new_label", self.file_2, self.tree_2,
-                          output)
-        self.assertEqual(output.getvalue(), "--- /dev/null\n"
-                                            "+++ new_label\n"
-                                            "@@ -1,1 +1,1 @@\n"
-                                            "-foo\n"
-                                            "+bar\n"
-                                            "\n")
-        
-    def test_link_diff_deleted(self):
-        output = StringIO()
-        self.link_1.diff(internal_diff, 
-                          "old_label", self.tree_1,
-                          "/dev/null", None, None,
-                          output)
-        self.assertEqual(output.getvalue(),
-                         "=== target was 'target1'\n")
-
-    def test_link_diff_added(self):
-        output = StringIO()
-        self.link_1.diff(internal_diff, 
-                          "new_label", self.tree_1,
-                          "/dev/null", None, None,
-                          output, reverse=True)
-        self.assertEqual(output.getvalue(),
-                         "=== target is 'target1'\n")
-
-    def test_link_diff_changed(self):
-        output = StringIO()
-        self.link_1.diff(internal_diff, 
-                          "/dev/null", self.tree_1, 
-                          "new_label", self.link_2, self.tree_2,
-                          output)
-        self.assertEqual(output.getvalue(),
-                         "=== target changed 'target1' => 'target2'\n")
-
-
-class TestSnapshot(TestCaseInTempDir):
-
-    def setUp(self):
-        # for full testing we'll need a branch
-        # with a subdir to test parent changes.
-        # and a file, link and dir under that.
-        # but right now I only need one attribute
-        # to change, and then test merge patterns
-        # with fake parent entries.
-        super(TestSnapshot, self).setUp()
-        self.branch = Branch.initialize('.')
-        self.build_tree(['subdir/', 'subdir/file'])
-        self.branch.add(['subdir', 'subdir/file'], ['dirid', 'fileid'])
-        if has_symlinks():
-            pass
-        self.branch.commit('message_1', rev_id = '1')
-        self.tree_1 = self.branch.revision_tree('1')
-        self.inv_1 = self.branch.get_inventory('1')
-        self.file_1 = self.inv_1['fileid']
-        self.work_tree = self.branch.working_tree()
-        self.file_active = self.work_tree.inventory['fileid']
-
-    def test_snapshot_new_revision(self):
-        # This tests that a simple commit with no parents makes a new
-        # revision value in the inventory entry
-        self.file_active.snapshot('2', 'subdir/file', {}, self.work_tree, 
-                                  self.branch.weave_store)
-        # expected outcome - file_1 has a revision id of '2', and we can get
-        # its text of 'file contents' out of the weave.
-        self.assertEqual(self.file_1.revision, '1')
-        self.assertEqual(self.file_active.revision, '2')
-        # this should be a separate test probably, but lets check it once..
-        lines = self.branch.weave_store.get_lines('fileid','2')
-        self.assertEqual(lines, ['contents of subdir/file\n'])
-
-    def test_snapshot_unchanged(self):
-        #This tests that a simple commit does not make a new entry for
-        # an unchanged inventory entry
-        self.file_active.snapshot('2', 'subdir/file', {'1':self.file_1},
-                                  self.work_tree, self.branch.weave_store)
-        self.assertEqual(self.file_1.revision, '1')
-        self.assertEqual(self.file_active.revision, '1')
-        self.assertRaises(errors.WeaveError,
-                          self.branch.weave_store.get_lines, 'fileid', '2')
-
-    def test_snapshot_merge_identical_different_revid(self):
-        # This tests that a commit with two identical parents, one of which has
-        # a different revision id, results in a new revision id in the entry.
-        # 1->other, commit a merge of other against 1, results in 2.
-        other_ie = inventory.InventoryFile('fileid', 'newname', self.file_1.parent_id)
-        other_ie = inventory.InventoryFile('fileid', 'file', self.file_1.parent_id)
-        other_ie.revision = '1'
-        other_ie.text_sha1 = self.file_1.text_sha1
-        other_ie.text_size = self.file_1.text_size
-        self.assertEqual(self.file_1, other_ie)
-        other_ie.revision = 'other'
-        self.assertNotEqual(self.file_1, other_ie)
-        self.branch.weave_store.add_identical_text('fileid', '1', 'other', ['1'])
-        self.file_active.snapshot('2', 'subdir/file', 
-                                  {'1':self.file_1, 'other':other_ie},
-                                  self.work_tree, self.branch.weave_store)
-        self.assertEqual(self.file_active.revision, '2')
-
-    def test_snapshot_changed(self):
-        # This tests that a commit with one different parent results in a new
-        # revision id in the entry.
-        self.file_active.name='newname'
-        rename('subdir/file', 'subdir/newname')
-        self.file_active.snapshot('2', 'subdir/newname', {'1':self.file_1}, 
-                                  self.work_tree, 
-                                  self.branch.weave_store)
-        # expected outcome - file_1 has a revision id of '2'
-        self.assertEqual(self.file_active.revision, '2')
-
-
-class TestPreviousHeads(TestCaseInTempDir):
-
-    def setUp(self):
-        # we want several inventories, that respectively
-        # give use the following scenarios:
-        # A) fileid not in any inventory (A),
-        # B) fileid present in one inventory (B) and (A,B)
-        # C) fileid present in two inventories, and they
-        #   are not mutual descendents (B, C)
-        # D) fileid present in two inventories and one is
-        #   a descendent of the other. (B, D)
-        super(TestPreviousHeads, self).setUp()
-        self.build_tree(['file'])
-        self.branch = Branch.initialize('.')
-        self.branch.commit('new branch', allow_pointless=True, rev_id='A')
-        self.inv_A = self.branch.get_inventory('A')
-        self.branch.add(['file'], ['fileid'])
-        self.branch.commit('add file', rev_id='B')
-        self.inv_B = self.branch.get_inventory('B')
-        self.branch.put_controlfile('revision-history', 'A\n')
-        self.assertEqual(self.branch.revision_history(), ['A'])
-        self.branch.commit('another add of file', rev_id='C')
-        self.inv_C = self.branch.get_inventory('C')
-        self.branch.add_pending_merge('B')
-        self.branch.commit('merge in B', rev_id='D')
-        self.inv_D = self.branch.get_inventory('D')
-        self.file_active = self.branch.working_tree().inventory['fileid']
-        self.weave = self.branch.weave_store.get_weave('fileid')
-        
-    def get_previous_heads(self, inventories):
-        return self.file_active.find_previous_heads(inventories, self.weave)
-        
-    def test_fileid_in_no_inventory(self):
-        self.assertEqual({}, self.get_previous_heads([self.inv_A]))
-
-    def test_fileid_in_one_inventory(self):
-        self.assertEqual({'B':self.inv_B['fileid']},
-                         self.get_previous_heads([self.inv_B]))
-        self.assertEqual({'B':self.inv_B['fileid']},
-                         self.get_previous_heads([self.inv_A, self.inv_B]))
-        self.assertEqual({'B':self.inv_B['fileid']},
-                         self.get_previous_heads([self.inv_B, self.inv_A]))
-
-    def test_fileid_in_two_inventories_gives_both_entries(self):
-        self.assertEqual({'B':self.inv_B['fileid'],
-                          'C':self.inv_C['fileid']},
-                          self.get_previous_heads([self.inv_B, self.inv_C]))
-        self.assertEqual({'B':self.inv_B['fileid'],
-                          'C':self.inv_C['fileid']},
-                          self.get_previous_heads([self.inv_C, self.inv_B]))
-
-    def test_fileid_in_two_inventories_already_merged_gives_head(self):
-        self.assertEqual({'D':self.inv_D['fileid']},
-                         self.get_previous_heads([self.inv_B, self.inv_D]))
-        self.assertEqual({'D':self.inv_D['fileid']},
-                         self.get_previous_heads([self.inv_D, self.inv_B]))
-
-    # TODO: test two inventories with the same file revision 

=== modified file 'bzrlib/selftest/testlog.py'
--- bzrlib/selftest/testlog.py	2005-10-02 21:51:29 +0000
+++ bzrlib/selftest/testlog.py	2005-09-23 03:05:48 +0000
@@ -65,25 +65,6 @@
             self.assertEquals(expected, got)
 
     def test_cur_revno(self):
-        b = Branch('.', init=True)
-
-        lf = LogCatcher()
-        b.commit('empty commit')
-        show_log(b, lf, verbose=True, start_revision=1, end_revision=1)
-        self.assertRaises(InvalidRevisionNumber, show_log, b, lf,
-                          start_revision=2, end_revision=1) 
-        self.assertRaises(InvalidRevisionNumber, show_log, b, lf,
-                          start_revision=1, end_revision=2) 
-        self.assertRaises(InvalidRevisionNumber, show_log, b, lf,
-                          start_revision=0, end_revision=2) 
-        self.assertRaises(InvalidRevisionNumber, show_log, b, lf,
-                          start_revision=1, end_revision=0) 
-        self.assertRaises(InvalidRevisionNumber, show_log, b, lf,
-                          start_revision=-1, end_revision=1) 
-        self.assertRaises(InvalidRevisionNumber, show_log, b, lf,
-                          start_revision=1, end_revision=-1) 
-
-    def test_cur_revno(self):
         b = Branch.initialize('.')
 
         lf = LogCatcher()

=== added file 'bzrlib/selftest/testremotebranch.py'
--- bzrlib/selftest/testremotebranch.py	1970-01-01 00:00:00 +0000
+++ bzrlib/selftest/testremotebranch.py	2005-09-29 02:01:49 +0000
@@ -0,0 +1,55 @@
+# Copyright (C) 2005 by Canonical Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+import bzrlib.errors
+from bzrlib.selftest.testrevision import make_branches
+from bzrlib.trace import mutter
+from bzrlib.branch import Branch, find_branch
+import gzip
+import sys
+import os
+
+from bzrlib.selftest.HTTPTestUtil import TestCaseWithWebserver
+
+from bzrlib.selftest.testfetch import fetch_steps
+
+class TestFetch(TestCaseWithWebserver):
+    def runTest(self):
+        from bzrlib.fetch import greedy_fetch
+        from bzrlib.selftest.testfetch import has_revision
+
+        def new_branch(name):
+            os.mkdir(name)
+            return Branch.initialize(name)
+            
+        #highest indices a: 5, b: 7
+        br_a, br_b = make_branches()
+        # unpack one of br_a's revision files to test .gz fallbacks
+        to_unzip = br_a.revision_history()[-1]
+        to_unzip_source = gzip.open(os.path.join(br_a.base, '.bzr', 
+                                                  'revision-store',
+                                                  to_unzip + '.gz'))
+        content = to_unzip_source.read()
+        to_unzip_source.close()
+        os.unlink(os.path.join(br_a.base, '.bzr', 'revision-store',
+                               to_unzip + '.gz'))
+        to_unzip_output = open(os.path.join(br_a.base, '.bzr', 
+                                             'revision-store', to_unzip), 'wb')
+        to_unzip_output.write(content)
+        to_unzip_output.close()
+        
+        br_rem = Branch.open(self.get_remote_url(br_a.base))
+        fetch_steps(self, br_rem, br_b, br_a)
+

=== modified file 'bzrlib/selftest/testrevision.py'
--- bzrlib/selftest/testrevision.py	2005-10-02 23:17:00 +0000
+++ bzrlib/selftest/testrevision.py	2005-09-29 00:24:44 +0000
@@ -42,7 +42,7 @@
     b..3   a..3 merges b..4
     b..4   a..4
     b..5   a..5 merges b..5
-    b..6 merges a4
+    b..6
 
     so A is missing b6 at the start
     and B is missing a3, a4, a5
@@ -71,10 +71,14 @@
     fetch(from_branch=br2, to_branch=br1)
     br1.add_pending_merge(br2.revision_history()[5])
     commit(br1, "Commit nine", rev_id="a@u-0-5")
-    # DO NOT FETCH HERE - we WANT a GHOST.
+    # disabled - it makes testing fetch too hard,
+    # but can be easily reenabled (without the fetch
+    # when GHOSTS are supported. RBC 20050928
     #fetch(from_branch=br1, to_branch=br2)
-    br2.add_pending_merge(br1.revision_history()[4])
-    commit(br2, "Commit ten - ghost merge", rev_id="b@u-0-6")
+    #br2.add_pending_merge(br1.revision_history()[4])
+    commit(br2, "Commit ten - no merge", rev_id="b@u-0-6")
+
+    #fetch(from_branch=br2, to_branch=br1)
     
     return br1, br2
 
@@ -136,6 +140,7 @@
         ## assert not is_ancestor(revisions[3], revisions_2[3], br1)
 
 
+
 class TestIntermediateRevisions(TestCaseInTempDir):
 
     def setUp(self):
@@ -244,7 +249,7 @@
                           revisions_2[4])
         fetch(from_branch=br2, to_branch=br1)
         self.assertEqual(common_ancestor(revisions[5], revisions_2[6], sources),
-                          revisions[4]) # revisions_2[5] is equally valid
+                          revisions_2[5])
         self.assertEqual(common_ancestor(revisions_2[6], revisions[5], sources),
                           revisions_2[5])
 
@@ -255,6 +260,7 @@
         revisions = br1.revision_history()
         revisions_2 = br2.revision_history()
         sources = MultipleRevisionSources(br1, br2)
+
         expected_ancestors_list = {revisions[3]:(0, 0), 
                                    revisions[2]:(1, 1),
                                    revisions_2[4]:(2, 1), 
@@ -267,6 +273,7 @@
             self.assertEqual(ancestors_list[key], value, 
                               "key %r, %r != %r" % (key, ancestors_list[key],
                                                     value))
+
         self.assertEqual(common_ancestor(revisions[0], revisions[0], sources),
                           revisions[0])
         self.assertEqual(common_ancestor(revisions[1], revisions[2], sources),
@@ -280,9 +287,9 @@
         self.assertEqual(common_ancestor(revisions[4], revisions_2[5], sources),
                           revisions_2[4])
         self.assertEqual(common_ancestor(revisions[5], revisions_2[6], sources),
-                          revisions[4]) # revisions_2[5] is equally valid
+                          revisions_2[5])
         self.assertEqual(common_ancestor(revisions_2[6], revisions[5], sources),
-                          revisions[4]) # revisions_2[5] is equally valid
+                          revisions_2[5])
 
     def test_combined(self):
         """combined_graph

=== modified file 'bzrlib/selftest/testrevisionnamespaces.py'
--- bzrlib/selftest/testrevisionnamespaces.py	2005-09-29 20:34:25 +0000
+++ bzrlib/selftest/testrevisionnamespaces.py	2005-09-23 08:54:16 +0000
@@ -18,7 +18,7 @@
 import time
 from bzrlib.selftest import TestCaseInTempDir
 from bzrlib.errors import NoCommonAncestor, NoCommits
-from bzrlib.clone import copy_branch
+from bzrlib.branch import copy_branch
 from bzrlib.merge import merge
 
 class TestRevisionNamespaces(TestCaseInTempDir):

=== removed file 'bzrlib/selftest/testsampler.py'
--- bzrlib/selftest/testsampler.py	2005-10-06 11:40:12 +0000
+++ bzrlib/selftest/testsampler.py	1970-01-01 00:00:00 +0000
@@ -1,39 +0,0 @@
-# Copyright (C) 2005 by Canonical Ltd
-#   Authors: Robert Collins <robert.collins@canonical.com>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Document what this test file is expecting to test here.
-
-If you need more than one line, make the first line a good sentence on its
-own and add more explanation here, like this.
-
-Be sure to register your new test script in bzrlib/selftest/__init__.py -
-search for sampler in there.
-"""
-
-# import system imports here
-import os
-import sys
-
-#import bzrlib specific imports here
-from bzrlib.selftest import TestCaseInTempDir
-
-
-# Now we need a test script:
-class DemoTest(TestCaseInTempDir):
-
-    def test_nothing(self):
-        self.assertEqual(1,1)

=== modified file 'bzrlib/selftest/teststatus.py'
--- bzrlib/selftest/teststatus.py	2005-10-03 01:53:47 +0000
+++ bzrlib/selftest/teststatus.py	2005-09-23 02:58:03 +0000
@@ -27,7 +27,7 @@
 class BranchStatus(TestCaseInTempDir):
     
     def test_branch_status(self): 
-        """Test basic branch status"""
+        """Basic 'bzr mkdir' operation"""
         from cStringIO import StringIO
         from bzrlib.status import show_status
         from bzrlib.branch import Branch
@@ -93,48 +93,3 @@
                            '  bye.c\n',
                            '  hello.c\n'])
 
-    def test_branch_status_specific_files(self): 
-        """Tests branch status with given specific files"""
-        from cStringIO import StringIO
-        from bzrlib.status import show_status
-        from bzrlib.branch import Branch
-        
-        b = Branch.initialize('.')
-
-        self.build_tree(['directory/','directory/hello.c', 'bye.c','test.c','dir2/'])
-        b.add('directory')
-        b.add('test.c')
-        b.commit('testing')
-        
-        tof = StringIO()
-        show_status(b, to_file=tof)
-        tof.seek(0)
-        self.assertEquals(tof.readlines(),
-                          ['unknown:\n',
-                           '  bye.c\n',
-                           '  dir2\n',
-                           '  directory/hello.c\n'
-                           ])
-
-        tof = StringIO()
-        show_status(b, specific_files=['bye.c','test.c','absent.c'], to_file=tof)
-        tof.seek(0)
-        self.assertEquals(tof.readlines(),
-                          ['unknown:\n',
-                           '  bye.c\n'
-                           ])
-        
-        tof = StringIO()
-        show_status(b, specific_files=['directory'], to_file=tof)
-        tof.seek(0)
-        self.assertEquals(tof.readlines(),
-                          ['unknown:\n',
-                           '  directory/hello.c\n'
-                           ])
-        tof = StringIO()
-        show_status(b, specific_files=['dir2'], to_file=tof)
-        tof.seek(0)
-        self.assertEquals(tof.readlines(),
-                          ['unknown:\n',
-                           '  dir2\n'
-                           ])

=== modified file 'bzrlib/selftest/teststore.py'
--- bzrlib/selftest/teststore.py	2005-10-05 06:44:02 +0000
+++ bzrlib/selftest/teststore.py	2005-09-28 07:08:18 +0000
@@ -16,193 +16,32 @@
 
 """Test Store implementation
 """
-from cStringIO import StringIO
+
+from StringIO import StringIO
 import os
 
-from bzrlib.store import copy_all
-from bzrlib.transport.local import LocalTransport
-from bzrlib.transport import NoSuchFile
-from bzrlib.store.compressed_text import CompressedTextStore
-from bzrlib.store.text import TextStore
-from bzrlib.selftest import TestCase, TestCaseInTempDir
+from bzrlib.remotebranch import RemoteStore
+from bzrlib.store import ImmutableStore, copy_all
+from bzrlib.selftest import TestCaseInTempDir
 from bzrlib.errors import BzrError, UnlistableStore
-import bzrlib.store
-
-
-def fill_store(store):
-    store.add(StringIO('hello'), 'a')
-    store.add(StringIO('other'), 'b')
-    store.add(StringIO('something'), 'c')
-    store.add(StringIO('goodbye'), '123123')
-
-def check_equals(tester, store, files, values, permit_failure=False):
-    files = store.get(files, permit_failure=permit_failure)
-    count = 0
-    for f, v in zip(files, values):
-        count += 1
-        if v is None:
-            tester.assert_(f is None)
-        else:
-            tester.assertEquals(f.read(), v)
-    tester.assertEquals(count, len(values))
-    # We need to check to make sure there are no more
-    # files to be returned, I'm using a cheezy way
-    # Convert to a list, and there shouldn't be any left
-    tester.assertEquals(len(list(files)), 0)
-
-def test_multiple_add(tester, store):
-    fill_store(store)
-    tester.assertRaises(BzrError, store.add, StringIO('goodbye'), '123123')
-
-def test_get(tester, store):
-    fill_store(store)
-
-    check_equals(tester, store, ['a'], ['hello'])
-    check_equals(tester, store, ['b', 'c'], ['other', 'something'])
-
-    # Make sure that requesting a non-existing file fails
-    tester.assertRaises(NoSuchFile, check_equals, tester, store,
-            ['d'], [None])
-    tester.assertRaises(NoSuchFile, check_equals, tester, store,
-            ['a', 'd'], ['hello', None])
-    tester.assertRaises(NoSuchFile, check_equals, tester, store,
-            ['d', 'a'], [None, 'hello'])
-    tester.assertRaises(NoSuchFile, check_equals, tester, store,
-            ['d', 'd', 'd'], [None, None, None])
-    tester.assertRaises(NoSuchFile, check_equals, tester, store,
-            ['a', 'd', 'b'], ['hello', None, 'other'])
-
-def test_ignore_get(tester, store):
-    fill_store(store)
-
-    files = store.get(['d'], permit_failure=True)
-    files = list(files)
-    tester.assertEquals(len(files), 1)
-    tester.assert_(files[0] is None)
-
-    check_equals(tester, store, ['a', 'd'], ['hello', None],
-            permit_failure=True)
-    check_equals(tester, store, ['d', 'a'], [None, 'hello'],
-            permit_failure=True)
-    check_equals(tester, store, ['d', 'd'], [None, None],
-            permit_failure=True)
-    check_equals(tester, store, ['a', 'd', 'b'], ['hello', None, 'other'],
-            permit_failure=True)
-    check_equals(tester, store, ['a', 'd', 'b'], ['hello', None, 'other'],
-            permit_failure=True)
-    check_equals(tester, store, ['b', 'd', 'c'], ['other', None, 'something'],
-            permit_failure=True)
-
-
-def get_compressed_store(path='.'):
-    t = LocalTransport(path)
-    return CompressedTextStore(t)
-
-
-def get_text_store(path='.'):
-    t = LocalTransport(path)
-    return TextStore(t)
-
-
-class TestCompressedTextStore(TestCaseInTempDir):
-
-    def test_multiple_add(self):
-        """Multiple add with same ID should raise a BzrError"""
-        store = get_compressed_store()
-        test_multiple_add(self, store)
-
-    def test_get(self):
-        store = get_compressed_store()
-        test_get(self, store)
-
-    def test_ignore_get(self):
-        store = get_compressed_store()
-        test_ignore_get(self, store)
-
-    def test_total_size(self):
-        store = get_compressed_store('.')
-        store.add(StringIO('goodbye'), '123123')
-        store.add(StringIO('goodbye2'), '123123.dsc')
-        # these get gzipped - content should be stable
-        self.assertEqual(store.total_size(), (2, 55))
-        
-    def test_copy_all(self):
-        """Test copying"""
-        os.mkdir('a')
-        store_a = get_text_store('a')
-        store_a.add('foo', '1')
-        os.mkdir('b')
-        store_b = get_text_store('b')
-        copy_all(store_a, store_b)
-        self.assertEqual(store_a['1'].read(), 'foo')
-        self.assertEqual(store_b['1'].read(), 'foo')
-
-
-class TestMemoryStore(TestCase):
-    
-    def get_store(self):
-        return bzrlib.store.ImmutableMemoryStore()
-    
-    def test_imports(self):
-        from bzrlib.store import ImmutableMemoryStore
-
-    def test_add_and_retrieve(self):
-        store = self.get_store()
-        store.add(StringIO('hello'), 'aa')
-        self.assertNotEqual(store['aa'], None)
-        self.assertEqual(store['aa'].read(), 'hello')
-        store.add(StringIO('hello world'), 'bb')
-        self.assertNotEqual(store['bb'], None)
-        self.assertEqual(store['bb'].read(), 'hello world')
-
-    def test_missing_is_absent(self):
-        store = self.get_store()
-        self.failIf('aa' in store)
-
-    def test_adding_fails_when_present(self):
-        store = self.get_store()
-        store.add(StringIO('hello'), 'aa')
-        self.assertRaises(bzrlib.store.StoreError,
-                          store.add, StringIO('hello'), 'aa')
-
-    def test_total_size(self):
-        store = self.get_store()
-        store.add(StringIO('goodbye'), '123123')
-        store.add(StringIO('goodbye2'), '123123.dsc')
-        self.assertEqual(store.total_size(), (2, 15))
-        # TODO: Switch the exception form UnlistableStore to
-        #       or make Stores throw UnlistableStore if their
-        #       Transport doesn't support listing
-        # store_c = RemoteStore('http://example.com/')
-        # self.assertRaises(UnlistableStore, copy_all, store_c, store_b)
-
-
-class TestTextStore(TestCaseInTempDir):
-    def test_multiple_add(self):
-        """Multiple add with same ID should raise a BzrError"""
-        store = get_text_store()
-        test_multiple_add(self, store)
-
-    def test_get(self):
-        store = get_text_store()
-        test_get(self, store)
-
-    def test_ignore_get(self):
-        store = get_text_store()
-        test_ignore_get(self, store)
-
-    def test_copy_all(self):
-        """Test copying"""
-        os.mkdir('a')
-        store_a = get_text_store('a')
-        store_a.add('foo', '1')
-        os.mkdir('b')
-        store_b = get_text_store('b')
-        copy_all(store_a, store_b)
-        self.assertEqual(store_a['1'].read(), 'foo')
-        self.assertEqual(store_b['1'].read(), 'foo')
-        # TODO: Switch the exception form UnlistableStore to
-        #       or make Stores throw UnlistableStore if their
-        #       Transport doesn't support listing
-        # store_c = RemoteStore('http://example.com/')
-        # self.assertRaises(UnlistableStore, copy_all, store_c, store_b)
+
+
+class TestStore(TestCaseInTempDir):
+    def test_multiple_add(self):
+        """Multiple add with same ID should raise a BzrError"""
+        store = ImmutableStore('.')
+        store.add(StringIO('goodbye'), '123123')
+        self.assertRaises(BzrError, store.add, StringIO('goodbye'), '123123')
+
+    def test_copy_all(self):
+        """Test copying"""
+        os.mkdir('a')
+        store_a = ImmutableStore('a')
+        store_a.add('foo', '1')
+        os.mkdir('b')
+        store_b = ImmutableStore('b')
+        copy_all(store_a, store_b)
+        self.assertEqual(store_a['1'].read(), 'foo')
+        self.assertEqual(store_b['1'].read(), 'foo')
+        store_c = RemoteStore('http://example.com/')
+        self.assertRaises(UnlistableStore, copy_all, store_c, store_b)

=== removed file 'bzrlib/selftest/testtransport.py'
--- bzrlib/selftest/testtransport.py	2005-09-19 03:26:14 +0000
+++ bzrlib/selftest/testtransport.py	1970-01-01 00:00:00 +0000
@@ -1,515 +0,0 @@
-# Copyright (C) 2004, 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-import os
-from cStringIO import StringIO
-from bzrlib.selftest import TestCaseInTempDir
-from bzrlib.selftest.HTTPTestUtil import TestCaseWithWebserver
-from bzrlib.errors import NoSuchFile, FileExists, TransportNotPossible
-
-def _append(fn, txt):
-    """Append the given text (file-like object) to the supplied filename."""
-    f = open(fn, 'ab')
-    f.write(txt)
-    f.flush()
-    f.close()
-    del f
-
-class TestTransportMixIn(object):
-    """Subclass this, and it will provide a series of tests for a Transport.
-    It assumes that the Transport object is connected to the 
-    current working directory.  So that whatever is done 
-    through the transport, should show up in the working 
-    directory, and vice-versa.
-
-    This also tests to make sure that the functions work with both
-    generators and lists (assuming iter(list) is effectively a generator)
-    """
-    readonly = False
-    def get_transport(self):
-        """Children should override this to return the Transport object.
-        """
-        raise NotImplementedError
-
-    def test_has(self):
-        t = self.get_transport()
-
-        files = ['a', 'b', 'e', 'g']
-        self.build_tree(files)
-        self.assertEqual(t.has('a'), True)
-        self.assertEqual(t.has('c'), False)
-        self.assertEqual(list(t.has_multi(['a', 'b', 'c', 'd', 'e', 'f', 'g', 'h'])),
-                [True, True, False, False, True, False, True, False])
-        self.assertEqual(list(t.has_multi(iter(['a', 'b', 'c', 'd', 'e', 'f', 'g', 'h']))),
-                [True, True, False, False, True, False, True, False])
-
-    def test_get(self):
-        t = self.get_transport()
-
-        files = ['a', 'b', 'e', 'g']
-        self.build_tree(files)
-        self.assertEqual(t.get('a').read(), open('a').read())
-        content_f = t.get_multi(files)
-        for path,f in zip(files, content_f):
-            self.assertEqual(open(path).read(), f.read())
-
-        content_f = t.get_multi(iter(files))
-        for path,f in zip(files, content_f):
-            self.assertEqual(open(path).read(), f.read())
-
-        self.assertRaises(NoSuchFile, t.get, 'c')
-        try:
-            files = list(t.get_multi(['a', 'b', 'c']))
-        except NoSuchFile:
-            pass
-        else:
-            self.fail('Failed to raise NoSuchFile for missing file in get_multi')
-        try:
-            files = list(t.get_multi(iter(['a', 'b', 'c', 'e'])))
-        except NoSuchFile:
-            pass
-        else:
-            self.fail('Failed to raise NoSuchFile for missing file in get_multi')
-
-    def test_put(self):
-        t = self.get_transport()
-
-        if self.readonly:
-            self.assertRaises(TransportNotPossible,
-                    t.put, 'a', 'some text for a\n')
-            open('a', 'wb').write('some text for a\n')
-        else:
-            t.put('a', 'some text for a\n')
-        self.assert_(os.path.exists('a'))
-        self.check_file_contents('a', 'some text for a\n')
-        self.assertEqual(t.get('a').read(), 'some text for a\n')
-        # Make sure 'has' is updated
-        self.assertEqual(list(t.has_multi(['a', 'b', 'c', 'd', 'e'])),
-                [True, False, False, False, False])
-        if self.readonly:
-            self.assertRaises(TransportNotPossible,
-                    t.put_multi,
-                    [('a', 'new\ncontents for\na\n'),
-                        ('d', 'contents\nfor d\n')])
-            open('a', 'wb').write('new\ncontents for\na\n')
-            open('d', 'wb').write('contents\nfor d\n')
-        else:
-            # Put also replaces contents
-            self.assertEqual(t.put_multi([('a', 'new\ncontents for\na\n'),
-                                          ('d', 'contents\nfor d\n')]),
-                             2)
-        self.assertEqual(list(t.has_multi(['a', 'b', 'c', 'd', 'e'])),
-                [True, False, False, True, False])
-        self.check_file_contents('a', 'new\ncontents for\na\n')
-        self.check_file_contents('d', 'contents\nfor d\n')
-
-        if self.readonly:
-            self.assertRaises(TransportNotPossible,
-                t.put_multi, iter([('a', 'diff\ncontents for\na\n'),
-                                  ('d', 'another contents\nfor d\n')]))
-            open('a', 'wb').write('diff\ncontents for\na\n')
-            open('d', 'wb').write('another contents\nfor d\n')
-        else:
-            self.assertEqual(
-                t.put_multi(iter([('a', 'diff\ncontents for\na\n'),
-                                  ('d', 'another contents\nfor d\n')]))
-                             , 2)
-        self.check_file_contents('a', 'diff\ncontents for\na\n')
-        self.check_file_contents('d', 'another contents\nfor d\n')
-
-        if self.readonly:
-            self.assertRaises(TransportNotPossible,
-                    t.put, 'path/doesnt/exist/c', 'contents')
-        else:
-            self.assertRaises(NoSuchFile,
-                    t.put, 'path/doesnt/exist/c', 'contents')
-
-    def test_put_file(self):
-        t = self.get_transport()
-
-        # Test that StringIO can be used as a file-like object with put
-        f1 = StringIO('this is a string\nand some more stuff\n')
-        if self.readonly:
-            open('f1', 'wb').write(f1.read())
-        else:
-            t.put('f1', f1)
-
-        del f1
-
-        self.check_file_contents('f1', 
-                'this is a string\nand some more stuff\n')
-
-        f2 = StringIO('here is some text\nand a bit more\n')
-        f3 = StringIO('some text for the\nthird file created\n')
-
-        if self.readonly:
-            open('f2', 'wb').write(f2.read())
-            open('f3', 'wb').write(f3.read())
-        else:
-            t.put_multi([('f2', f2), ('f3', f3)])
-
-        del f2, f3
-
-        self.check_file_contents('f2', 'here is some text\nand a bit more\n')
-        self.check_file_contents('f3', 'some text for the\nthird file created\n')
-
-        # Test that an actual file object can be used with put
-        f4 = open('f1', 'rb')
-        if self.readonly:
-            open('f4', 'wb').write(f4.read())
-        else:
-            t.put('f4', f4)
-
-        del f4
-
-        self.check_file_contents('f4', 
-                'this is a string\nand some more stuff\n')
-
-        f5 = open('f2', 'rb')
-        f6 = open('f3', 'rb')
-        if self.readonly:
-            open('f5', 'wb').write(f5.read())
-            open('f6', 'wb').write(f6.read())
-        else:
-            t.put_multi([('f5', f5), ('f6', f6)])
-
-        del f5, f6
-
-        self.check_file_contents('f5', 'here is some text\nand a bit more\n')
-        self.check_file_contents('f6', 'some text for the\nthird file created\n')
-
-
-
-    def test_mkdir(self):
-        t = self.get_transport()
-
-        # Test mkdir
-        os.mkdir('dir_a')
-        self.assertEqual(t.has('dir_a'), True)
-        self.assertEqual(t.has('dir_b'), False)
-
-        if self.readonly:
-            self.assertRaises(TransportNotPossible,
-                    t.mkdir, 'dir_b')
-            os.mkdir('dir_b')
-        else:
-            t.mkdir('dir_b')
-        self.assertEqual(t.has('dir_b'), True)
-        self.assert_(os.path.isdir('dir_b'))
-
-        if self.readonly:
-            self.assertRaises(TransportNotPossible,
-                    t.mkdir_multi, ['dir_c', 'dir_d'])
-            os.mkdir('dir_c')
-            os.mkdir('dir_d')
-        else:
-            t.mkdir_multi(['dir_c', 'dir_d'])
-
-        if self.readonly:
-            self.assertRaises(TransportNotPossible,
-                    t.mkdir_multi, iter(['dir_e', 'dir_f']))
-            os.mkdir('dir_e')
-            os.mkdir('dir_f')
-        else:
-            t.mkdir_multi(iter(['dir_e', 'dir_f']))
-        self.assertEqual(list(t.has_multi(
-            ['dir_a', 'dir_b', 'dir_c', 'dir_q',
-             'dir_d', 'dir_e', 'dir_f', 'dir_b'])),
-            [True, True, True, False,
-             True, True, True, True])
-        for d in ['dir_a', 'dir_b', 'dir_c', 'dir_d', 'dir_e', 'dir_f']:
-            self.assert_(os.path.isdir(d))
-
-        if not self.readonly:
-            self.assertRaises(NoSuchFile, t.mkdir, 'path/doesnt/exist')
-            self.assertRaises(FileExists, t.mkdir, 'dir_a') # Creating a directory again should fail
-
-        # Make sure the transport recognizes when a
-        # directory is created by other means
-        # Caching Transports will fail, because dir_e was already seen not
-        # to exist. So instead, we will search for a new directory
-        #os.mkdir('dir_e')
-        #if not self.readonly:
-        #    self.assertRaises(FileExists, t.mkdir, 'dir_e')
-
-        os.mkdir('dir_g')
-        if not self.readonly:
-            self.assertRaises(FileExists, t.mkdir, 'dir_g')
-
-        # Test get/put in sub-directories
-        if self.readonly:
-            open('dir_a/a', 'wb').write('contents of dir_a/a')
-            open('dir_b/b', 'wb').write('contents of dir_b/b')
-        else:
-            self.assertEqual(
-                t.put_multi([('dir_a/a', 'contents of dir_a/a'),
-                             ('dir_b/b', 'contents of dir_b/b')])
-                          , 2)
-        for f in ('dir_a/a', 'dir_b/b'):
-            self.assertEqual(t.get(f).read(), open(f).read())
-
-    def test_copy_to(self):
-        import tempfile
-        from bzrlib.transport.local import LocalTransport
-
-        t = self.get_transport()
-
-        files = ['a', 'b', 'c', 'd']
-        self.build_tree(files)
-
-        dtmp = tempfile.mkdtemp(dir='.', prefix='test-transport-')
-        dtmp_base = os.path.basename(dtmp)
-        local_t = LocalTransport(dtmp)
-
-        t.copy_to(files, local_t)
-        for f in files:
-            self.assertEquals(open(f).read(),
-                    open(os.path.join(dtmp_base, f)).read())
-
-        del dtmp, dtmp_base, local_t
-
-        dtmp = tempfile.mkdtemp(dir='.', prefix='test-transport-')
-        dtmp_base = os.path.basename(dtmp)
-        local_t = LocalTransport(dtmp)
-
-        files = ['a', 'b', 'c', 'd']
-        t.copy_to(iter(files), local_t)
-        for f in files:
-            self.assertEquals(open(f).read(),
-                    open(os.path.join(dtmp_base, f)).read())
-
-        del dtmp, dtmp_base, local_t
-
-    def test_append(self):
-        t = self.get_transport()
-
-        if self.readonly:
-            open('a', 'wb').write('diff\ncontents for\na\n')
-            open('b', 'wb').write('contents\nfor b\n')
-        else:
-            t.put_multi([
-                    ('a', 'diff\ncontents for\na\n'),
-                    ('b', 'contents\nfor b\n')
-                    ])
-
-        if self.readonly:
-            self.assertRaises(TransportNotPossible,
-                    t.append, 'a', 'add\nsome\nmore\ncontents\n')
-            _append('a', 'add\nsome\nmore\ncontents\n')
-        else:
-            t.append('a', 'add\nsome\nmore\ncontents\n')
-
-        self.check_file_contents('a', 
-            'diff\ncontents for\na\nadd\nsome\nmore\ncontents\n')
-
-        if self.readonly:
-            self.assertRaises(TransportNotPossible,
-                    t.append_multi,
-                        [('a', 'and\nthen\nsome\nmore\n'),
-                         ('b', 'some\nmore\nfor\nb\n')])
-            _append('a', 'and\nthen\nsome\nmore\n')
-            _append('b', 'some\nmore\nfor\nb\n')
-        else:
-            t.append_multi([('a', 'and\nthen\nsome\nmore\n'),
-                    ('b', 'some\nmore\nfor\nb\n')])
-        self.check_file_contents('a', 
-            'diff\ncontents for\na\n'
-            'add\nsome\nmore\ncontents\n'
-            'and\nthen\nsome\nmore\n')
-        self.check_file_contents('b', 
-                'contents\nfor b\n'
-                'some\nmore\nfor\nb\n')
-
-        if self.readonly:
-            _append('a', 'a little bit more\n')
-            _append('b', 'from an iterator\n')
-        else:
-            t.append_multi(iter([('a', 'a little bit more\n'),
-                    ('b', 'from an iterator\n')]))
-        self.check_file_contents('a', 
-            'diff\ncontents for\na\n'
-            'add\nsome\nmore\ncontents\n'
-            'and\nthen\nsome\nmore\n'
-            'a little bit more\n')
-        self.check_file_contents('b', 
-                'contents\nfor b\n'
-                'some\nmore\nfor\nb\n'
-                'from an iterator\n')
-
-    def test_append_file(self):
-        t = self.get_transport()
-
-        contents = [
-            ('f1', 'this is a string\nand some more stuff\n'),
-            ('f2', 'here is some text\nand a bit more\n'),
-            ('f3', 'some text for the\nthird file created\n'),
-            ('f4', 'this is a string\nand some more stuff\n'),
-            ('f5', 'here is some text\nand a bit more\n'),
-            ('f6', 'some text for the\nthird file created\n')
-        ]
-        
-        if self.readonly:
-            for f, val in contents:
-                open(f, 'wb').write(val)
-        else:
-            t.put_multi(contents)
-
-        a1 = StringIO('appending to\none\n')
-        if self.readonly:
-            _append('f1', a1.read())
-        else:
-            t.append('f1', a1)
-
-        del a1
-
-        self.check_file_contents('f1', 
-                'this is a string\nand some more stuff\n'
-                'appending to\none\n')
-
-        a2 = StringIO('adding more\ntext to two\n')
-        a3 = StringIO('some garbage\nto put in three\n')
-
-        if self.readonly:
-            _append('f2', a2.read())
-            _append('f3', a3.read())
-        else:
-            t.append_multi([('f2', a2), ('f3', a3)])
-
-        del a2, a3
-
-        self.check_file_contents('f2',
-                'here is some text\nand a bit more\n'
-                'adding more\ntext to two\n')
-        self.check_file_contents('f3', 
-                'some text for the\nthird file created\n'
-                'some garbage\nto put in three\n')
-
-        # Test that an actual file object can be used with put
-        a4 = open('f1', 'rb')
-        if self.readonly:
-            _append('f4', a4.read())
-        else:
-            t.append('f4', a4)
-
-        del a4
-
-        self.check_file_contents('f4', 
-                'this is a string\nand some more stuff\n'
-                'this is a string\nand some more stuff\n'
-                'appending to\none\n')
-
-        a5 = open('f2', 'rb')
-        a6 = open('f3', 'rb')
-        if self.readonly:
-            _append('f5', a5.read())
-            _append('f6', a6.read())
-        else:
-            t.append_multi([('f5', a5), ('f6', a6)])
-
-        del a5, a6
-
-        self.check_file_contents('f5',
-                'here is some text\nand a bit more\n'
-                'here is some text\nand a bit more\n'
-                'adding more\ntext to two\n')
-        self.check_file_contents('f6',
-                'some text for the\nthird file created\n'
-                'some text for the\nthird file created\n'
-                'some garbage\nto put in three\n')
-
-    def test_get_partial(self):
-        t = self.get_transport()
-
-        contents = [
-            ('f1', 
-                'here is some text\nand a bit more\n'
-                'adding more\ntext to two\n'),
-            ('f2',
-                'this is a string\nand some more stuff\n'
-                'appending to\none\n'),
-            ('f3',
-                'some text for the\nthird file created\n'
-                'some garbage\nto put in three\n')
-        ]
-        if self.readonly:
-            for f, val in contents:
-                open(f, 'wb').write(val)
-        else:
-            t.put_multi(contents)
-
-        self.assertRaises(NoSuchFile,
-                t.get_partial, 'a-missing-file', 20)
-        self.assertRaises(NoSuchFile,
-                t.get_partial, 'another-missing-file', 20, 30)
-        f = t.get_partial('f1', 33)
-        self.assertEqual(f.read(), 
-                'adding more\ntext to two\n')
-        f = t.get_partial('f1', 33, 10)
-        self.assertEqual(f.read(10), 
-                'adding mor')
-
-        del f
-
-        offsets = [('f2', 37), ('f3', 20, 10), ('f1', 10, 20)]
-        values = ['appending to\none\n',
-                  'ird file c',
-                  'me text\nand a bit mo'
-                 ]
-        contents_f = t.get_partial_multi(offsets)
-        count = 0
-        for f, val in zip(contents_f, values):
-            count += 1
-            self.assertEqual(val, f.read(len(val)))
-        # Make sure we saw all values, and no extra
-        self.assertEqual(len(values), count)
-        self.assertEqual(list(contents_f), [])
-
-        # Do the same thing with an iterator
-        offsets = iter([('f2', 34), ('f3', 18, 10), ('f1', 15, 15)])
-        values = ['ff\nappending to\none\n',
-                  'third file',
-                  'xt\nand a bit mo'
-                 ]
-        contents_f = t.get_partial_multi(offsets)
-        count = 0
-        for f, val in zip(contents_f, values):
-            count += 1
-            self.assertEqual(val, f.read(len(val)))
-        self.assertEqual(len(values), count)
-        self.assertEqual(list(contents_f), [])
-
-
-    def test_delete(self):
-        # TODO: Test Transport.delete
-        pass
-
-    def test_move(self):
-        # TODO: Test Transport.move
-        pass
-
-class LocalTransportTest(TestCaseInTempDir, TestTransportMixIn):
-    def get_transport(self):
-        from bzrlib.transport.local import LocalTransport
-        return LocalTransport('.')
-
-class HttpTransportTest(TestCaseWithWebserver, TestTransportMixIn):
-    readonly = True
-    def get_transport(self):
-        from bzrlib.transport.http import HttpTransport
-        url = self.get_remote_url('.')
-        return HttpTransport(url)
-

=== removed file 'bzrlib/selftest/testworkingtree.py'
--- bzrlib/selftest/testworkingtree.py	2005-10-04 02:43:06 +0000
+++ bzrlib/selftest/testworkingtree.py	1970-01-01 00:00:00 +0000
@@ -1,59 +0,0 @@
-# (C) 2005 Canonical Ltd
-# Authors:  Robert Collins <robert.collins@canonical.com>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-import os
-from bzrlib.branch import Branch
-from bzrlib.selftest import TestCaseInTempDir
-from bzrlib.trace import mutter
-from bzrlib.workingtree import TreeEntry, TreeDirectory, TreeFile, TreeLink
-
-class TestTreeDirectory(TestCaseInTempDir):
-
-    def test_kind_character(self):
-        self.assertEqual(TreeDirectory().kind_character(), '/')
-
-
-class TestTreeEntry(TestCaseInTempDir):
-
-    def test_kind_character(self):
-        self.assertEqual(TreeEntry().kind_character(), '???')
-
-
-class TestTreeFile(TestCaseInTempDir):
-
-    def test_kind_character(self):
-        self.assertEqual(TreeFile().kind_character(), '')
-
-
-class TestTreeLink(TestCaseInTempDir):
-
-    def test_kind_character(self):
-        self.assertEqual(TreeLink().kind_character(), '')
-
-
-class TestWorkingTree(TestCaseInTempDir):
-
-    def test_listfiles(self):
-        branch = Branch.initialize('.')
-        os.mkdir('dir')
-        print >> open('file', 'w'), "content"
-        os.symlink('target', 'symlink')
-        tree = branch.working_tree()
-        files = list(tree.list_files())
-        self.assertEqual(files[0], ('dir', '?', 'directory', None, TreeDirectory()))
-        self.assertEqual(files[1], ('file', '?', 'file', None, TreeFile()))
-        self.assertEqual(files[2], ('symlink', '?', 'symlink', None, TreeLink()))

=== removed file 'bzrlib/selftest/treeshape.py'
--- bzrlib/selftest/treeshape.py	2005-10-04 10:10:48 +0000
+++ bzrlib/selftest/treeshape.py	1970-01-01 00:00:00 +0000
@@ -1,76 +0,0 @@
-# Copyright (C) 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-"""Test helper for constructing and testing directories.
-
-This module transforms filesystem directories to and from Python lists.  
-As a Python list the descriptions can be stored in test cases, compared,
-etc.
-"""
-
-# TODO: Script to write a description of a directory for testing
-# TODO: Helper that compares two structures and raises a helpful error
-# where they differ.  Option to ignore some files or directories in the 
-# comparison.
-
-import os
-import stat
-
-from bzrlib.trace import warning
-
-def build_tree_contents(template):
-    """Reconstitute some files from a text description.
-
-    Each element of template is a tuple.  The first element is a filename,
-    with an optional ending character indicating the type.
-
-    The template is built relative to the Python process's current
-    working directory.
-    """
-    for tt in template:
-        name = tt[0]
-        if name[-1] == '/':
-            os.mkdir(name)
-        elif name[-1] == '@':
-            raise NotImplementedError('symlinks not handled yet')
-        else:
-            f = file(name, 'wb')
-            try:
-                f.write(tt[1])
-            finally:
-                f.close()
-
-
-def capture_tree_contents(top):
-    """Make a Python datastructure description of a tree.
-    
-    If top is an absolute path the descriptions will be absolute."""
-    for dirpath, dirnames, filenames in os.walk(top):
-        yield (dirpath + '/', )
-        filenames.sort()
-        for fn in filenames:
-            fullpath = os.path.join(dirpath, fn)
-            assert fullpath[-1] not in '@/'
-            info = os.lstat(fullpath)
-            if stat.S_ISLNK(info.st_mode):
-                yield (fullpath + '@', os.readlink(fullpath))
-            elif stat.S_ISREG(info.st_mode):
-                yield (fullpath, file(fullpath, 'rb').read())
-            else:
-                warning("can't capture file %s with mode %#o",
-                        fullpath, info.st_mode)
-                pass

=== modified file 'bzrlib/selftest/whitebox.py'
--- bzrlib/selftest/whitebox.py	2005-10-02 23:23:56 +0000
+++ bzrlib/selftest/whitebox.py	2005-09-27 07:24:40 +0000
@@ -67,6 +67,35 @@
                           'Martin Pool <mbp@sourcefrog.net>-20050311061123-96a255005c7c9dbe')
 
 
+class PendingMerges(TestCaseInTempDir):
+
+    def test_pending_merges(self):
+        """Tracking pending-merged revisions."""
+        print "GHOST SUPPORT REMOVED"
+        return
+
+        b = Branch.initialize('.')
+
+        self.assertEquals(b.pending_merges(), [])
+        b.add_pending_merge('foo@azkhazan-123123-abcabc')
+        self.assertEquals(b.pending_merges(), ['foo@azkhazan-123123-abcabc'])
+        b.add_pending_merge('foo@azkhazan-123123-abcabc')
+        self.assertEquals(b.pending_merges(), ['foo@azkhazan-123123-abcabc'])
+        b.add_pending_merge('wibble@fofof--20050401--1928390812')
+        self.assertEquals(b.pending_merges(),
+                          ['foo@azkhazan-123123-abcabc',
+                           'wibble@fofof--20050401--1928390812'])
+        b.commit("commit from base with two merges")
+        rev = b.get_revision(b.revision_history()[0])
+        self.assertEquals(len(rev.parents), 2)
+        self.assertEquals(rev.parents[0].revision_id,
+                          'foo@azkhazan-123123-abcabc')
+        self.assertEquals(rev.parents[1].revision_id,
+                           'wibble@fofof--20050401--1928390812')
+        # list should be cleared when we do a commit
+        self.assertEquals(b.pending_merges(), [])
+ 
+
 class MoreTests(TestCaseInTempDir):
 
     def test_revert(self):

=== modified file 'bzrlib/status.py'
--- bzrlib/status.py	2005-10-06 13:08:14 +0000
+++ bzrlib/status.py	2005-09-23 02:58:03 +0000
@@ -1,22 +1,19 @@
 # (C) 2005 Canonical Ltd
-#
+
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation; either version 2 of the License, or
 # (at your option) any later version.
-#
+
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 # GNU General Public License for more details.
-#
+
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-import sys
-from bzrlib.osutils import is_inside_any
-from bzrlib.delta import compare_trees
 
 
 def show_status(branch, show_unchanged=False,
@@ -41,12 +38,14 @@
 
     show_pending
         If set, write pending merges.
-
     revision
         If None the compare latest revision with working tree
         If one revision show compared it with working tree.
         If two revisions show status between first and second.
     """
+    import sys
+    from bzrlib.delta import compare_trees
+
     if to_file == None:
         to_file = sys.stdout
     
@@ -81,10 +80,18 @@
                    show_unchanged=show_unchanged)
 
         if new_is_working_tree:
-            conflicts = new.iter_conflicts()
             unknowns = new.unknowns()
-            list_paths('unknown', unknowns, specific_files, to_file)
-            list_paths('conflicts', conflicts, specific_files, to_file)
+            done_header = False
+            for path in unknowns:
+                # FIXME: Should also match if the unknown file is within a
+                # specified directory.
+                if specific_files:
+                    if path not in specific_files:
+                        continue
+                if not done_header:
+                    print >>to_file, 'unknown:'
+                    done_header = True
+                print >>to_file, ' ', path
             if show_pending and len(branch.pending_merges()) > 0:
                 print >>to_file, 'pending merges:'
                 for merge in branch.pending_merges():
@@ -92,12 +99,3 @@
     finally:
         branch.unlock()
         
-def list_paths(header, paths, specific_files, to_file):
-    done_header = False
-    for path in paths:
-        if specific_files and not is_inside_any(specific_files, path):
-            continue
-        if not done_header:
-            print >>to_file, '%s:' % header
-            done_header = True
-        print >>to_file, ' ', path

=== removed directory 'bzrlib/store'
=== renamed file 'bzrlib/store/__init__.py' => 'bzrlib/store.py'
--- bzrlib/store/__init__.py	2005-10-04 04:37:29 +0000
+++ bzrlib/store.py	2005-09-28 09:35:50 +0000
@@ -24,12 +24,19 @@
 unique ID.
 """
 
-from cStringIO import StringIO
+import errno
+import gzip
+import os
+import tempfile
+import types
+from stat import ST_SIZE
+from StringIO import StringIO
 
-from bzrlib.errors import BzrError, UnlistableStore, TransportNotPossible
+from bzrlib.errors import BzrError, UnlistableStore
 from bzrlib.trace import mutter
-import bzrlib.transport
-from bzrlib.transport.local import LocalTransport
+import bzrlib.ui
+import bzrlib.osutils as osutils
+
 
 ######################################################################
 # stores
@@ -38,272 +45,229 @@
     pass
 
 
-class Store(object):
-    """This class represents the abstract storage layout for saving information.
-    
+class ImmutableStore(object):
+    """Store that holds files indexed by unique names.
+
     Files can be added, but not modified once they are in.  Typically
     the hash is used as the name, or something else known to be unique,
     such as a UUID.
+
+    >>> st = ImmutableScratchStore()
+
+    >>> st.add(StringIO('hello'), 'aa')
+    >>> 'aa' in st
+    True
+    >>> 'foo' in st
+    False
+
+    You are not allowed to add an id that is already present.
+
+    Entries can be retrieved as files, which may then be read.
+
+    >>> st.add(StringIO('goodbye'), '123123')
+    >>> st['123123'].read()
+    'goodbye'
+
+    TODO: Atomic add by writing to a temporary file and renaming.
+
+    In bzr 0.0.5 and earlier, files within the store were marked
+    readonly on disk.  This is no longer done but existing stores need
+    to be accomodated.
     """
 
-    def __len__(self):
-        raise NotImplementedError('Children should define their length')
-
-    def __getitem__(self, fileid):
-        """Returns a file reading from a particular entry."""
-        raise NotImplementedError
-
-    def __contains__(self, fileid):
-        """"""
-        raise NotImplementedError
-
-    def __iter__(self):
-        raise NotImplementedError
-
-    def add(self, f, fileid):
-        """Add a file object f to the store accessible from the given fileid"""
-        raise NotImplementedError('Children of Store must define their method of adding entries.')
-
-    def add_multi(self, entries):
-        """Add a series of file-like or string objects to the store with the given
-        identities.
-        
-        :param entries: A list of tuples of file,id pairs [(file1, id1), (file2, id2), ...]
-                        This could also be a generator yielding (file,id) pairs.
-        """
-        for f, fileid in entries:
-            self.add(f, fileid)
-
-    def has(self, fileids):
-        """Return True/False for each entry in fileids.
-
-        :param fileids: A List or generator yielding file ids.
-        :return: A generator or list returning True/False for each entry.
-        """
-        for fileid in fileids:
-            if fileid in self:
-                yield True
+    def __init__(self, basedir):
+        self._basedir = basedir
+
+    def _path(self, entry_id):
+        if not isinstance(entry_id, basestring):
+            raise TypeError(type(entry_id))
+        if '\\' in entry_id or '/' in entry_id:
+            raise ValueError("invalid store id %r" % entry_id)
+        return os.path.join(self._basedir, entry_id)
+
+    def __repr__(self):
+        return "%s(%r)" % (self.__class__.__name__, self._basedir)
+
+    def add(self, f, fileid, compressed=True):
+        """Add contents of a file into the store.
+
+        f -- An open file, or file-like object."""
+        # FIXME: Only works on files that will fit in memory
+        
+        from bzrlib.atomicfile import AtomicFile
+        
+        mutter("add store entry %r" % (fileid))
+        if isinstance(f, types.StringTypes):
+            content = f
+        else:
+            content = f.read()
+            
+        p = self._path(fileid)
+        if os.access(p, os.F_OK) or os.access(p + '.gz', os.F_OK):
+            raise BzrError("store %r already contains id %r" % (self._basedir, fileid))
+
+        fn = p
+        if compressed:
+            fn = fn + '.gz'
+            
+        af = AtomicFile(fn, 'wb')
+        try:
+            if compressed:
+                gf = gzip.GzipFile(mode='wb', fileobj=af)
+                gf.write(content)
+                gf.close()
             else:
-                yield False
-
-    def listable(self):
-        """Return True if this store is able to be listed."""
-        return hasattr(self, "__iter__")
-
-    def get(self, fileids, permit_failure=False, pb=None):
-        """Return a set of files, one for each requested entry.
-        
-        :param permit_failure: If true, return None for entries which do not 
-                               exist.
-        :return: A list or generator of file-like objects, one for each id.
-        """
-        for fileid in fileids:
-            try:
-                yield self[fileid]
-            except KeyError:
-                if permit_failure:
-                    yield None
-                else:
-                    raise
-
-    def copy_multi(self, other, ids, pb=None, permit_failure=False):
+                af.write(content)
+            af.commit()
+        finally:
+            af.close()
+
+
+    def copy_multi(self, other, ids, permit_failure=False):
         """Copy texts for ids from other into self.
 
-        If an id is present in self, it is skipped.  A count of copied
-        ids is returned, which may be less than len(ids).
+        If an id is present in self, it is skipped.
 
-        :param other: Another Store object
-        :param ids: A list of entry ids to be copied
-        :param pb: A ProgressBar object, if none is given, the default will be created.
-        :param permit_failure: Allow missing entries to be ignored
-        :return: (n_copied, [failed]) The number of entries copied successfully,
-            followed by a list of entries which could not be copied (because they
-            were missing)
+        Returns (count_copied, failed), where failed is a collection of ids
+        that could not be copied.
         """
-        if pb is None:
-            pb = bzrlib.ui.ui_factory.progress_bar()
-
-        # XXX: Is there any reason why we couldn't make this accept a generator
-        # and build a list as it finds things to copy?
-        ids = list(ids) # Make sure we don't have a generator, since we iterate 2 times
+        pb = bzrlib.ui.ui_factory.progress_bar()
+        
         pb.update('preparing to copy')
-        to_copy = []
-        for file_id, has in zip(ids, self.has(ids)):
-            if not has:
-                to_copy.append(file_id)
-        return self._do_copy(other, to_copy, pb, permit_failure=permit_failure)
-
-    def _do_copy(self, other, to_copy, pb, permit_failure=False):
-        """This is the standard copying mechanism, just get them one at
-        a time from remote, and store them locally.
-
-        :param other: Another Store object
-        :param to_copy: A list of entry ids to copy
-        :param pb: A ProgressBar object to display completion status.
-        :param permit_failure: Allow missing entries to be ignored
-        :return: (n_copied, [failed])
-            The number of entries copied, and a list of failed entries.
-        """
-        # This should be updated to use add_multi() rather than
-        # the current methods of buffering requests.
-        # One question, is it faster to queue up 1-10 and then copy 1-10
-        # then queue up 11-20, copy 11-20
-        # or to queue up 1-10, copy 1, queue 11, copy 2, etc?
-        # sort of pipeline versus batch.
-
-        # We can't use self._transport.copy_to because we don't know
-        # whether the local tree is in the same format as other
+        to_copy = [id for id in ids if id not in self]
+        if isinstance(other, ImmutableStore):
+            return self.copy_multi_immutable(other, to_copy, pb, 
+                                             permit_failure=permit_failure)
+        count = 0
         failed = set()
-        def buffer_requests():
-            count = 0
-            buffered_requests = []
-            for fileid in to_copy:
+        for id in to_copy:
+            count += 1
+            pb.update('copy', count, len(to_copy))
+            if not permit_failure:
+                self.add(other[id], id)
+            else:
                 try:
-                    f = other[fileid]
+                    entry = other[id]
                 except KeyError:
-                    if permit_failure:
-                        failed.add(fileid)
-                        continue
+                    failed.add(id)
+                    continue
+                self.add(entry, id)
+                
+        if not permit_failure:
+            assert count == len(to_copy)
+        pb.clear()
+        return count, failed
+
+    def copy_multi_immutable(self, other, to_copy, pb, permit_failure=False):
+        count = 0
+        failed = set()
+        for id in to_copy:
+            p = self._path(id)
+            other_p = other._path(id)
+            try:
+                osutils.link_or_copy(other_p, p)
+            except (IOError, OSError), e:
+                if e.errno == errno.ENOENT:
+                    if not permit_failure:
+                        osutils.link_or_copy(other_p+".gz", p+".gz")
                     else:
-                        raise
-
-                buffered_requests.append((f, fileid))
-                if len(buffered_requests) > self._max_buffered_requests:
-                    yield buffered_requests.pop(0)
-                    count += 1
-                    pb.update('copy', count, len(to_copy))
-
-            for req in buffered_requests:
-                yield req
-                count += 1
-                pb.update('copy', count, len(to_copy))
-
-            assert count == len(to_copy)
-
-        self.add_multi(buffer_requests())
-
+                        try:
+                            osutils.link_or_copy(other_p+".gz", p+".gz")
+                        except IOError, e:
+                            if e.errno == errno.ENOENT:
+                                failed.add(id)
+                            else:
+                                raise
+                else:
+                    raise
+            
+            count += 1
+            pb.update('copy', count, len(to_copy))
+        assert count == len(to_copy)
         pb.clear()
-        return len(to_copy), failed
-
-
-class TransportStore(Store):
-    """A TransportStore is a Store superclass for Stores that use Transports."""
-
-    _max_buffered_requests = 10
-
-    def __init__(self, transport):
-        assert isinstance(transport, bzrlib.transport.Transport)
-        super(TransportStore, self).__init__()
-        self._transport = transport
-
-    def __repr__(self):
-        if self._transport is None:
-            return "%s(None)" % (self.__class__.__name__)
-        else:
-            return "%s(%r)" % (self.__class__.__name__, self._transport.base)
-
-    __str__ = __repr__
-
-    def listable(self):
-        """Return True if this store is able to be listed."""
-        return self._transport.listable()
-
-
-class ImmutableMemoryStore(Store):
-    """A memory only store."""
+        return count, failed
+    
 
     def __contains__(self, fileid):
-        return self._contents.has_key(fileid)
-
+        """"""
+        p = self._path(fileid)
+        return (os.access(p, os.R_OK)
+                or os.access(p + '.gz', os.R_OK))
+
+    # TODO: Guard against the same thing being stored twice,
+    # compressed and uncompressed
+
+    def __iter__(self):
+        for f in os.listdir(self._basedir):
+            if f[-3:] == '.gz':
+                # TODO: case-insensitive?
+                yield f[:-3]
+            else:
+                yield f
+
+    def __len__(self):
+        return len(os.listdir(self._basedir))
+
+
+    def __getitem__(self, fileid):
+        """Returns a file reading from a particular entry."""
+        p = self._path(fileid)
+        try:
+            return gzip.GzipFile(p + '.gz', 'rb')
+        except IOError, e:
+            if e.errno != errno.ENOENT:
+                raise
+
+        try:
+            return file(p, 'rb')
+        except IOError, e:
+            if e.errno != errno.ENOENT:
+                raise
+
+        raise KeyError(fileid)
+
+
+    def total_size(self):
+        """Return (count, bytes)
+
+        This is the (compressed) size stored on disk, not the size of
+        the content."""
+        total = 0
+        count = 0
+        for fid in self:
+            count += 1
+            p = self._path(fid)
+            try:
+                total += os.stat(p)[ST_SIZE]
+            except OSError:
+                total += os.stat(p + '.gz')[ST_SIZE]
+                
+        return count, total
+
+
+
+
+class ImmutableScratchStore(ImmutableStore):
+    """Self-destructing test subclass of ImmutableStore.
+
+    The Store only exists for the lifetime of the Python object.
+ Obviously you should not put anything precious in it.
+    """
     def __init__(self):
-        super(ImmutableMemoryStore, self).__init__()
-        self._contents = {}
-
-    def add(self, stream, fileid, compressed=True):
-        if self._contents.has_key(fileid):
-            raise StoreError("fileid %s already in the store" % fileid)
-        self._contents[fileid] = stream.read()
-
-    def __getitem__(self, fileid):
-        """Returns a file reading from a particular entry."""
-        if not self._contents.has_key(fileid):
-            raise IndexError
-        return StringIO(self._contents[fileid])
-
-    def _item_size(self, fileid):
-        return len(self._contents[fileid])
-
-    def __iter__(self):
-        return iter(self._contents.keys())
-
-    def total_size(self):
-        result = 0
-        count = 0
-        for fileid in self:
-            count += 1
-            result += self._item_size(fileid)
-        return count, result
-        
-
-class CachedStore(Store):
-    """A store that caches data locally, to avoid repeated downloads.
-    The precacache method should be used to avoid server round-trips for
-    every piece of data.
-    """
-
-    def __init__(self, store, cache_dir):
-        super(CachedStore, self).__init__()
-        self.source_store = store
-        # This clones the source store type with a locally bound
-        # transport. FIXME: it assumes a constructor is == cloning.
-        # clonable store - it might be nicer to actually have a clone()
-        # or something. RBC 20051003
-        self.cache_store = store.__class__(LocalTransport(cache_dir))
-
-    def __getitem__(self, id):
-        mutter("Cache add %s" % id)
-        if id not in self.cache_store:
-            self.cache_store.add(self.source_store[id], id)
-        return self.cache_store[id]
-
-    def __contains__(self, fileid):
-        if fileid in self.cache_store:
-            return True
-        if fileid in self.source_store:
-            # We could copy at this time
-            return True
-        return False
-
-    def get(self, fileids, permit_failure=False, pb=None):
-        fileids = list(fileids)
-        hasids = self.cache_store.has(fileids)
-        needs = set()
-        for has, fileid in zip(hasids, fileids):
-            if not has:
-                needs.add(fileid)
-        if needs:
-            self.cache_store.copy_multi(self.source_store, needs,
-                    permit_failure=permit_failure)
-        return self.cache_store.get(fileids,
-                permit_failure=permit_failure, pb=pb)
-
-    def prefetch(self, ids):
-        """Copy a series of ids into the cache, before they are used.
-        For remote stores that support pipelining or async downloads, this can
-        increase speed considerably.
-
-        Failures while prefetching are ignored.
-        """
-        mutter("Prefetch of ids %s" % ",".join(ids))
-        self.cache_store.copy_multi(self.source_store, ids, 
-                                    permit_failure=True)
-
+        ImmutableStore.__init__(self, tempfile.mkdtemp())
+
+    def __del__(self):
+        for f in os.listdir(self._basedir):
+            fpath = os.path.join(self._basedir, f)
+            # needed on windows, and maybe some other filesystems
+            os.chmod(fpath, 0600)
+            os.remove(fpath)
+        os.rmdir(self._basedir)
+        mutter("%r destroyed" % self)
 
 def copy_all(store_from, store_to):
     """Copy all ids from one store to another."""
-    # TODO: Optional progress indicator
-    if not store_from.listable():
+    if not hasattr(store_from, "__iter__"):
         raise UnlistableStore(store_from)
     ids = [f for f in store_from]
     store_to.copy_multi(store_from, ids)
-

=== removed file 'bzrlib/store/compressed_text.py'
--- bzrlib/store/compressed_text.py	2005-10-02 21:51:29 +0000
+++ bzrlib/store/compressed_text.py	1970-01-01 00:00:00 +0000
@@ -1,261 +0,0 @@
-# Copyright (C) 2005 by Canonical Development Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""
-An implementation the primary storage type CompressedTextStore.
-
-This store keeps compressed versions of the full text. It does not
-do any sort of delta compression.
-"""
-
-import os, tempfile, gzip
-
-import bzrlib.store
-from bzrlib.trace import mutter
-from bzrlib.errors import BzrError
-
-from StringIO import StringIO
-from stat import ST_SIZE
-
-class CompressedTextStore(bzrlib.store.TransportStore):
-    """Store that holds files indexed by unique names.
-
-    Files can be added, but not modified once they are in.  Typically
-    the hash is used as the name, or something else known to be unique,
-    such as a UUID.
-
-    Files are stored gzip compressed, with no delta compression.
-
-    >>> st = ScratchCompressedTextStore()
-
-    >>> st.add(StringIO('hello'), 'aa')
-    >>> 'aa' in st
-    True
-    >>> 'foo' in st
-    False
-
-    You are not allowed to add an id that is already present.
-
-    Entries can be retrieved as files, which may then be read.
-
-    >>> st.add(StringIO('goodbye'), '123123')
-    >>> st['123123'].read()
-    'goodbye'
-    """
-
-    def __init__(self, transport):
-        super(CompressedTextStore, self).__init__(transport)
-
-    def _check_fileid(self, fileid):
-        if '\\' in fileid or '/' in fileid:
-            raise ValueError("invalid store id %r" % fileid)
-
-    def _relpath(self, fileid):
-        self._check_fileid(fileid)
-        return fileid + '.gz'
-
-    def add(self, f, fileid):
-        """Add contents of a file into the store.
-
-        f -- An open file, or file-like object."""
-        # TODO: implement an add_multi which can do some of it's
-        #       own piplelining, and possible take advantage of
-        #       transport.put_multi(). The problem is that
-        #       entries potentially need to be compressed as they
-        #       are received, which implies translation, which
-        #       means it isn't as straightforward as we would like.
-        from cStringIO import StringIO
-        from bzrlib.osutils import pumpfile
-        
-        mutter("add store entry %r" % (fileid))
-        if isinstance(f, basestring):
-            f = StringIO(f)
-            
-        fn = self._relpath(fileid)
-        if self._transport.has(fn):
-            raise BzrError("store %r already contains id %r" % (self._transport.base, fileid))
-
-
-        sio = StringIO()
-        gf = gzip.GzipFile(mode='wb', fileobj=sio)
-        # if pumpfile handles files that don't fit in ram,
-        # so will this function
-        if isinstance(f, basestring):
-            gf.write(f)
-        else:
-            pumpfile(f, gf)
-        gf.close()
-        sio.seek(0)
-        self._transport.put(fn, sio)
-
-    def _do_copy(self, other, to_copy, pb, permit_failure=False):
-        if isinstance(other, CompressedTextStore):
-            return self._copy_multi_text(other, to_copy, pb,
-                    permit_failure=permit_failure)
-        return super(CompressedTextStore, self)._do_copy(other, to_copy,
-                pb, permit_failure=permit_failure)
-
-    def _copy_multi_text(self, other, to_copy, pb,
-            permit_failure=False):
-        # Because of _transport, we can no longer assume
-        # that they are on the same filesystem, we can, however
-        # assume that we only need to copy the exact bytes,
-        # we don't need to process the files.
-
-        failed = set()
-        if permit_failure:
-            new_to_copy = set()
-            for fileid, has in zip(to_copy, other.has(to_copy)):
-                if has:
-                    new_to_copy.add(fileid)
-                else:
-                    failed.add(fileid)
-            to_copy = new_to_copy
-            #mutter('_copy_multi_text copying %s, failed %s' % (to_copy, failed))
-
-        paths = [self._relpath(fileid) for fileid in to_copy]
-        count = other._transport.copy_to(paths, self._transport, pb=pb)
-        assert count == len(to_copy)
-        return count, failed
-
-    def __contains__(self, fileid):
-        """"""
-        fn = self._relpath(fileid)
-        return self._transport.has(fn)
-
-    def has(self, fileids, pb=None):
-        """Return True/False for each entry in fileids.
-
-        :param fileids: A List or generator yielding file ids.
-        :return: A generator or list returning True/False for each entry.
-        """
-        relpaths = (self._relpath(fid) for fid in fileids)
-        return self._transport.has_multi(relpaths, pb=pb)
-
-    def get(self, fileids, permit_failure=False, pb=None):
-        """Return a set of files, one for each requested entry.
-        
-        TODO: Write some tests to make sure that permit_failure is
-              handled correctly.
-
-        TODO: What should the exception be for a missing file?
-              KeyError, or NoSuchFile?
-        """
-
-        # This next code gets a bit hairy because it can allow
-        # to not request a file which doesn't seem to exist.
-        # Also, the same fileid may be requested twice, so we
-        # can't just build up a map.
-        rel_paths = [self._relpath(fid) for fid in fileids]
-        is_requested = []
-
-        #mutter('CompressedTextStore.get(permit_failure=%s)' % permit_failure)
-        if permit_failure:
-            existing_paths = []
-            for path, has in zip(rel_paths,
-                    self._transport.has_multi(rel_paths)):
-                if has:
-                    existing_paths.append(path)
-                    is_requested.append(True)
-                else:
-                    is_requested.append(False)
-            #mutter('Retrieving %s out of %s' % (existing_paths, rel_paths))
-        else:
-            #mutter('Retrieving all %s' % (rel_paths, ))
-            existing_paths = rel_paths
-            is_requested = [True for x in rel_paths]
-
-        count = 0
-        for f in self._transport.get_multi(existing_paths, pb=pb):
-            assert count < len(is_requested)
-            while not is_requested[count]:
-                yield None
-                count += 1
-            if hasattr(f, 'tell'):
-                yield gzip.GzipFile(mode='rb', fileobj=f)
-            else:
-                from cStringIO import StringIO
-                sio = StringIO(f.read())
-                yield gzip.GzipFile(mode='rb', fileobj=sio)
-            count += 1
-
-        while count < len(is_requested):
-            yield None
-            count += 1
-
-    def __iter__(self):
-        # TODO: case-insensitive?
-        for f in self._transport.list_dir('.'):
-            if f[-3:] == '.gz':
-                yield f[:-3]
-            else:
-                yield f
-
-    def __len__(self):
-        return len([f for f in self._transport.list_dir('.')])
-
-
-    def __getitem__(self, fileid):
-        """Returns a file reading from a particular entry."""
-        fn = self._relpath(fileid)
-        # This will throw if the file doesn't exist.
-        try:
-            f = self._transport.get(fn)
-        except:
-            raise KeyError('This store (%s) does not contain %s' % (self, fileid))
-
-        # gzip.GzipFile.read() requires a tell() function
-        # but some transports return objects that cannot seek
-        # so buffer them in a StringIO instead
-        if hasattr(f, 'tell'):
-            return gzip.GzipFile(mode='rb', fileobj=f)
-        else:
-            from cStringIO import StringIO
-            sio = StringIO(f.read())
-            return gzip.GzipFile(mode='rb', fileobj=sio)
-            
-
-    def total_size(self):
-        """Return (count, bytes)
-
-        This is the (compressed) size stored on disk, not the size of
-        the content."""
-        total = 0
-        count = 0
-        relpaths = [self._relpath(fid) for fid in self]
-        for st in self._transport.stat_multi(relpaths):
-            count += 1
-            total += st[ST_SIZE]
-                
-        return count, total
-
-
-class ScratchCompressedTextStore(CompressedTextStore):
-    """Self-destructing test subclass of CompressedTextStore.
-
-    The Store only exists for the lifetime of the Python object.
-    Obviously you should not put anything precious in it.
-    """
-    def __init__(self):
-        from transport import transport
-        t = transport(tempfile.mkdtemp())
-        super(ScratchCompressedTextStore, self).__init__(t)
-
-    def __del__(self):
-        self._transport.delete_multi(self._transport.list_dir('.'))
-        os.rmdir(self._transport.base)
-        mutter("%r destroyed" % self)
-

=== removed file 'bzrlib/store/text.py'
--- bzrlib/store/text.py	2005-10-02 21:51:29 +0000
+++ bzrlib/store/text.py	1970-01-01 00:00:00 +0000
@@ -1,209 +0,0 @@
-# Copyright (C) 2005 by Canonical Development Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""
-A store that keeps the full text of every version.
-
-This store keeps uncompressed versions of the full text. It does not
-do any sort of delta compression.
-"""
-
-import os, tempfile
-
-import bzrlib.store
-from bzrlib.trace import mutter
-from bzrlib.errors import BzrError
-
-from cStringIO import StringIO
-from stat import ST_SIZE
-
-
-class TextStore(bzrlib.store.TransportStore):
-    """Store that holds files indexed by unique names.
-
-    Files can be added, but not modified once they are in.  Typically
-    the hash is used as the name, or something else known to be unique,
-    such as a UUID.
-
-    Files are stored uncompressed, with no delta compression.
-    """
-
-    def __init__(self, transport):
-        super(TextStore, self).__init__(transport)
-
-    def _check_fileid(self, fileid):
-        if not isinstance(fileid, basestring):
-            raise TypeError('Fileids should be a string type: %s %r' % (type(fileid), fileid))
-        if '\\' in fileid or '/' in fileid:
-            raise ValueError("invalid store id %r" % fileid)
-
-    def _relpath(self, fileid):
-        self._check_fileid(fileid)
-        return fileid
-
-    def add(self, f, fileid):
-        """Add contents of a file into the store.
-
-        f -- A file-like object, or string
-        """
-        mutter("add store entry %r" % (fileid))
-            
-        fn = self._relpath(fileid)
-        if self._transport.has(fn):
-            raise BzrError("store %r already contains id %r" % (self._transport.base, fileid))
-
-        self._transport.put(fn, f)
-
-    def _do_copy(self, other, to_copy, pb, permit_failure=False):
-        if isinstance(other, TextStore):
-            return self._copy_multi_text(other, to_copy, pb,
-                    permit_failure=permit_failure)
-        return super(TextStore, self)._do_copy(other, to_copy,
-                pb, permit_failure=permit_failure)
-
-    def _copy_multi_text(self, other, to_copy, pb,
-            permit_failure=False):
-        # Because of _transport, we can no longer assume
-        # that they are on the same filesystem, we can, however
-        # assume that we only need to copy the exact bytes,
-        # we don't need to process the files.
-
-        failed = set()
-        if permit_failure:
-            new_to_copy = set()
-            for fileid, has in zip(to_copy, other.has(to_copy)):
-                if has:
-                    new_to_copy.add(fileid)
-                else:
-                    failed.add(fileid)
-            to_copy = new_to_copy
-            #mutter('_copy_multi_text copying %s, failed %s' % (to_copy, failed))
-
-        paths = [self._relpath(fileid) for fileid in to_copy]
-        count = other._transport.copy_to(paths, self._transport, pb=pb)
-        assert count == len(to_copy)
-        return count, failed
-
-    def __contains__(self, fileid):
-        """"""
-        fn = self._relpath(fileid)
-        return self._transport.has(fn)
-
-    def has(self, fileids, pb=None):
-        """Return True/False for each entry in fileids.
-
-        :param fileids: A List or generator yielding file ids.
-        :return: A generator or list returning True/False for each entry.
-        """
-        relpaths = (self._relpath(fid) for fid in fileids)
-        return self._transport.has_multi(relpaths, pb=pb)
-
-    def get(self, fileids, permit_failure=False, pb=None):
-        """Return a set of files, one for each requested entry.
-        
-        TODO: Write some tests to make sure that permit_failure is
-              handled correctly.
-
-        TODO: What should the exception be for a missing file?
-              KeyError, or NoSuchFile?
-        """
-
-        # This next code gets a bit hairy because it can allow
-        # to not request a file which doesn't seem to exist.
-        # Also, the same fileid may be requested twice, so we
-        # can't just build up a map.
-        rel_paths = [self._relpath(fid) for fid in fileids]
-        is_requested = []
-
-        if permit_failure:
-            existing_paths = []
-            for path, has in zip(rel_paths,
-                    self._transport.has_multi(rel_paths)):
-                if has:
-                    existing_paths.append(path)
-                    is_requested.append(True)
-                else:
-                    is_requested.append(False)
-            #mutter('Retrieving %s out of %s' % (existing_paths, rel_paths))
-        else:
-            #mutter('Retrieving all %s' % (rel_paths, ))
-            existing_paths = rel_paths
-            is_requested = [True for x in rel_paths]
-
-        count = 0
-        for f in self._transport.get_multi(existing_paths, pb=pb):
-            assert count < len(is_requested)
-            while not is_requested[count]:
-                yield None
-                count += 1
-            yield f
-            count += 1
-
-        while count < len(is_requested):
-            yield None
-            count += 1
-
-    def __iter__(self):
-        # TODO: case-insensitive?
-        for f in self._transport.list_dir('.'):
-            yield f
-
-    def __len__(self):
-        return len([f for f in self._transport.list_dir('.')])
-
-
-    def __getitem__(self, fileid):
-        """Returns a file reading from a particular entry."""
-        fn = self._relpath(fileid)
-        # This will throw if the file doesn't exist.
-        try:
-            f = self._transport.get(fn)
-        except:
-            raise KeyError('This store (%s) does not contain %s' % (self, fileid))
-
-        return f
-            
-
-    def total_size(self):
-        """Return (count, bytes)
-
-        This is the (compressed) size stored on disk, not the size of
-        the content."""
-        total = 0
-        count = 0
-        relpaths = [self._relpath(fid) for fid in self]
-        for st in self._transport.stat_multi(relpaths):
-            count += 1
-            total += st[ST_SIZE]
-                
-        return count, total
-
-
-class ScratchTextStore(TextStore):
-    """Self-destructing test subclass of TextStore.
-
-    The Store only exists for the lifetime of the Python object.
-    Obviously you should not put anything precious in it.
-    """
-    def __init__(self):
-        from transport import transport
-        super(ScratchTextStore, self).__init__(transport(tempfile.mkdtemp()))
-
-    def __del__(self):
-        self._transport.delete_multi(self._transport.list_dir('.'))
-        os.rmdir(self._transport.base)
-        mutter("%r destroyed" % self)
-

=== modified file 'bzrlib/textinv.py'
--- bzrlib/textinv.py	2005-10-03 05:54:35 +0000
+++ bzrlib/textinv.py	2005-09-26 08:56:15 +0000
@@ -69,6 +69,8 @@
     outf.write(END_MARK)
 
 
+
+
 def read_text_inventory(tf):
     """Return an inventory read in from tf"""
     if tf.readline() != START_MARK:

=== modified file 'bzrlib/trace.py'
--- bzrlib/trace.py	2005-10-06 07:28:41 +0000
+++ bzrlib/trace.py	2005-09-27 07:24:40 +0000
@@ -54,10 +54,9 @@
     # can get the exception details is we suppress them here.
 
     def format(self, record):
+        s = 'bzr: '
         if record.levelno >= logging.WARNING:
-            s = 'bzr: ' + record.levelname + ': '
-        else:
-            s = ''
+            s += record.levelname + ': '
             
         s += record.getMessage()
 
@@ -164,9 +163,10 @@
     if msg == None:
         ei = sys.exc_info()
         msg = str(ei[1])
+
     if msg and (msg[-1] == '\n'):
         msg = msg[:-1]
-    ## msg = "(%s) %s" % (str(type(ei[1])), msg)
+        
     _bzr_logger.exception(msg)
 
 

=== removed directory 'bzrlib/transport'
=== removed file 'bzrlib/transport/__init__.py'
--- bzrlib/transport/__init__.py	2005-10-04 04:37:29 +0000
+++ bzrlib/transport/__init__.py	1970-01-01 00:00:00 +0000
@@ -1,359 +0,0 @@
-# Copyright (C) 2005 Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-"""Transport is an abstraction layer to handle file access.
-
-The abstraction is to allow access from the local filesystem, as well
-as remote (such as http or sftp).
-"""
-
-from bzrlib.trace import mutter
-from bzrlib.errors import (BzrError, 
-    TransportError, TransportNotPossible, NonRelativePath,
-    NoSuchFile, FileExists, PermissionDenied,
-    ConnectionReset)
-
-_protocol_handlers = {
-}
-
-def register_transport(prefix, klass, override=True):
-    global _protocol_handlers
-
-    if _protocol_handlers.has_key(prefix):
-        if override:
-            mutter('overriding transport: %s => %s' % (prefix, klass.__name__))
-            _protocol_handlers[prefix] = klass
-    else:
-        mutter('registering transport: %s => %s' % (prefix, klass.__name__))
-        _protocol_handlers[prefix] = klass
-
-class Transport(object):
-    """This class encapsulates methods for retrieving or putting a file
-    from/to a storage location.
-
-    Most functions have a _multi variant, which allows you to queue up
-    multiple requests. They generally have a dumb base implementation 
-    which just iterates over the arguments, but smart Transport
-    implementations can do pipelining.
-    In general implementations should support having a generator or a list
-    as an argument (ie always iterate, never index)
-    """
-
-    def __init__(self, base):
-        super(Transport, self).__init__()
-        self.base = base
-
-    def clone(self, offset=None):
-        """Return a new Transport object, cloned from the current location,
-        using a subdirectory or parent directory. This allows connections 
-        to be pooled, rather than a new one needed for each subdir.
-        """
-        raise NotImplementedError
-
-    def should_cache(self):
-        """Return True if the data pulled across should be cached locally.
-        """
-        return False
-
-    def _pump(self, from_file, to_file):
-        """Most children will need to copy from one file-like 
-        object or string to another one.
-        This just gives them something easy to call.
-        """
-        if isinstance(from_file, basestring):
-            to_file.write(from_file)
-        else:
-            from bzrlib.osutils import pumpfile
-            pumpfile(from_file, to_file)
-
-    def _get_total(self, multi):
-        """Try to figure out how many entries are in multi,
-        but if not possible, return None.
-        """
-        try:
-            return len(multi)
-        except TypeError: # We can't tell how many, because relpaths is a generator
-            return None
-
-    def _update_pb(self, pb, msg, count, total):
-        """Update the progress bar based on the current count
-        and total available, total may be None if it was
-        not possible to determine.
-        """
-        if pb is None:
-            return
-        if total is None:
-            pb.update(msg, count, count+1)
-        else:
-            pb.update(msg, count, total)
-
-    def _iterate_over(self, multi, func, pb, msg, expand=True):
-        """Iterate over all entries in multi, passing them to func,
-        and update the progress bar as you go along.
-
-        :param expand:  If True, the entries will be passed to the function
-                        by expanding the tuple. If False, it will be passed
-                        as a single parameter.
-        """
-        total = self._get_total(multi)
-        count = 0
-        for entry in multi:
-            self._update_pb(pb, msg, count, total)
-            if expand:
-                func(*entry)
-            else:
-                func(entry)
-            count += 1
-        return count
-
-    def abspath(self, relpath):
-        """Return the full url to the given relative path.
-        This can be supplied with a string or a list
-        """
-        raise NotImplementedError
-
-    def relpath(self, abspath):
-        """Return the local path portion from a given absolute path.
-        """
-        raise NotImplementedError
-
-    def has(self, relpath):
-        """Does the target location exist?"""
-        raise NotImplementedError
-
-    def has_multi(self, relpaths, pb=None):
-        """Return True/False for each entry in relpaths"""
-        total = self._get_total(relpaths)
-        count = 0
-        for relpath in relpaths:
-            self._update_pb(pb, 'has', count, total)
-            yield self.has(relpath)
-            count += 1
-
-    def get(self, relpath):
-        """Get the file at the given relative path.
-
-        :param relpath: The relative path to the file
-        """
-        raise NotImplementedError
-
-    def get_multi(self, relpaths, pb=None):
-        """Get a list of file-like objects, one for each entry in relpaths.
-
-        :param relpaths: A list of relative paths.
-        :param pb:  An optional ProgressBar for indicating percent done.
-        :return: A list or generator of file-like objects
-        """
-        # TODO: Consider having this actually buffer the requests,
-        # in the default mode, it probably won't give worse performance,
-        # and all children wouldn't have to implement buffering
-        total = self._get_total(relpaths)
-        count = 0
-        for relpath in relpaths:
-            self._update_pb(pb, 'get', count, total)
-            yield self.get(relpath)
-            count += 1
-
-    def get_partial(self, relpath, start, length=None):
-        """Get just part of a file.
-
-        :param relpath: Path to the file, relative to base
-        :param start: The starting position to read from
-        :param length: The length to read. A length of None indicates
-                       read to the end of the file.
-        :return: A file-like object containing at least the specified bytes.
-                 Some implementations may return objects which can be read
-                 past this length, but this is not guaranteed.
-        """
-        raise NotImplementedError
-
-    def get_partial_multi(self, offsets, pb=None):
-        """Put a set of files or strings into the location.
-
-        Requesting multiple portions of the same file can be dangerous.
-
-        :param offsets: A list of tuples of relpath, start, length
-                         [(path1, start1, length1),
-                          (path2, start2, length2),
-                          (path3, start3), ...]
-                         length is optional, defaulting to None
-        :param pb:  An optional ProgressBar for indicating percent done.
-        :return: A generator of file-like objects.
-        """
-        total = self._get_total(offsets)
-        count = 0
-        for offset in offsets:
-            self._update_pb(pb, 'get_partial', count, total)
-            yield self.get_partial(*offset)
-            count += 1
-
-    def put(self, relpath, f):
-        """Copy the file-like or string object into the location.
-
-        :param relpath: Location to put the contents, relative to base.
-        :param f:       File-like or string object.
-        """
-        raise NotImplementedError
-
-    def put_multi(self, files, pb=None):
-        """Put a set of files or strings into the location.
-
-        :param files: A list of tuples of relpath, file object [(path1, file1), (path2, file2),...]
-        :param pb:  An optional ProgressBar for indicating percent done.
-        :return: The number of files copied.
-        """
-        return self._iterate_over(files, self.put, pb, 'put', expand=True)
-
-    def mkdir(self, relpath):
-        """Create a directory at the given path."""
-        raise NotImplementedError
-
-    def mkdir_multi(self, relpaths, pb=None):
-        """Create a group of directories"""
-        return self._iterate_over(relpaths, self.mkdir, pb, 'mkdir', expand=False)
-
-    def append(self, relpath, f):
-        """Append the text in the file-like or string object to 
-        the supplied location.
-        """
-        raise NotImplementedError
-
-    def append_multi(self, files, pb=None):
-        """Append the text in each file-like or string object to
-        the supplied location.
-
-        :param files: A set of (path, f) entries
-        :param pb:  An optional ProgressBar for indicating percent done.
-        """
-        return self._iterate_over(files, self.append, pb, 'append', expand=True)
-
-    def copy(self, rel_from, rel_to):
-        """Copy the item at rel_from to the location at rel_to"""
-        raise NotImplementedError
-
-    def copy_multi(self, relpaths, pb=None):
-        """Copy a bunch of entries.
-        
-        :param relpaths: A list of tuples of the form [(from, to), (from, to),...]
-        """
-        # This is the non-pipelined implementation, so that
-        # implementors don't have to implement everything.
-        return self._iterate_over(relpaths, self.copy, pb, 'copy', expand=True)
-
-    def copy_to(self, relpaths, other, pb=None):
-        """Copy a set of entries from self into another Transport.
-
-        :param relpaths: A list/generator of entries to be copied.
-        """
-        # The dummy implementation just does a simple get + put
-        def copy_entry(path):
-            other.put(path, self.get(path))
-
-        return self._iterate_over(relpaths, copy_entry, pb, 'copy_to', expand=False)
-
-
-    def move(self, rel_from, rel_to):
-        """Move the item at rel_from to the location at rel_to"""
-        raise NotImplementedError
-
-    def move_multi(self, relpaths, pb=None):
-        """Move a bunch of entries.
-        
-        :param relpaths: A list of tuples of the form [(from1, to1), (from2, to2),...]
-        """
-        return self._iterate_over(relpaths, self.move, pb, 'move', expand=True)
-
-    def move_multi_to(self, relpaths, rel_to):
-        """Move a bunch of entries to a single location.
-        This differs from move_multi in that you give a list of from, and
-        a single destination, rather than multiple destinations.
-
-        :param relpaths: A list of relative paths [from1, from2, from3, ...]
-        :param rel_to: A directory where each entry should be placed.
-        """
-        # This is not implemented, because you need to do special tricks to
-        # extract the basename, and add it to rel_to
-        raise NotImplementedError
-
-    def delete(self, relpath):
-        """Delete the item at relpath"""
-        raise NotImplementedError
-
-    def delete_multi(self, relpaths, pb=None):
-        """Queue up a bunch of deletes to be done.
-        """
-        return self._iterate_over(relpaths, self.delete, pb, 'delete', expand=False)
-
-    def stat(self, relpath):
-        """Return the stat information for a file.
-        WARNING: This may not be implementable for all protocols, so use
-        sparingly.
-        """
-        raise NotImplementedError
-
-    def stat_multi(self, relpaths, pb=None):
-        """Stat multiple files and return the information.
-        """
-        #TODO:  Is it worth making this a generator instead of a
-        #       returning a list?
-        stats = []
-        def gather(path):
-            stats.append(self.stat(path))
-
-        count = self._iterate_over(relpaths, gather, pb, 'stat', expand=False)
-        return stats
-
-    def listable(self):
-        """Return True if this store supports listing."""
-        raise NotImplementedError
-
-    def list_dir(self, relpath):
-        """Return a list of all files at the given location.
-        WARNING: many transports do not support this, so trying avoid using
-        it if at all possible.
-        """
-        raise TransportNotPossible("This transport has not "
-                                   "implemented list_dir.")
-
-    def lock_read(self, relpath):
-        """Lock the given file for shared (read) access.
-        WARNING: many transports do not support this, so trying avoid using it
-
-        :return: A lock object, which should contain an unlock() function.
-        """
-        raise NotImplementedError
-
-    def lock_write(self, relpath):
-        """Lock the given file for exclusive (write) access.
-        WARNING: many transports do not support this, so trying avoid using it
-
-        :return: A lock object, which should contain an unlock() function.
-        """
-        raise NotImplementedError
-
-
-def get_transport(base):
-    global _protocol_handlers
-    if base is None:
-        base = '.'
-    for proto, klass in _protocol_handlers.iteritems():
-        if proto is not None and base.startswith(proto):
-            return klass(base)
-    # The default handler is the filesystem handler
-    # which has a lookup of None
-    return _protocol_handlers[None](base)
-
-# Local transport should always be initialized
-import bzrlib.transport.local

=== removed file 'bzrlib/transport/http.py'
--- bzrlib/transport/http.py	2005-10-04 04:37:29 +0000
+++ bzrlib/transport/http.py	1970-01-01 00:00:00 +0000
@@ -1,250 +0,0 @@
-# Copyright (C) 2005 Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-"""Implementation of Transport over http.
-"""
-
-from bzrlib.transport import Transport, register_transport
-from bzrlib.errors import (TransportNotPossible, NoSuchFile, 
-                           NonRelativePath, TransportError)
-import os, errno
-from cStringIO import StringIO
-import urllib2
-import urlparse
-
-from bzrlib.errors import BzrError, BzrCheckError
-from bzrlib.branch import Branch
-from bzrlib.trace import mutter
-
-# velocitynet.com.au transparently proxies connections and thereby
-# breaks keep-alive -- sucks!
-
-
-def get_url(url):
-    import urllib2
-    mutter("get_url %s" % url)
-    url_f = urllib2.urlopen(url)
-    return url_f
-
-class HttpTransportError(TransportError):
-    pass
-
-class HttpTransport(Transport):
-    """This is the transport agent for http:// access.
-    
-    TODO: Implement pipelined versions of all of the *_multi() functions.
-    """
-
-    def __init__(self, base):
-        """Set the base path where files will be stored."""
-        assert base.startswith('http://') or base.startswith('https://')
-        super(HttpTransport, self).__init__(base)
-        # In the future we might actually connect to the remote host
-        # rather than using get_url
-        # self._connection = None
-        (self._proto, self._host,
-            self._path, self._parameters,
-            self._query, self._fragment) = urlparse.urlparse(self.base)
-
-    def should_cache(self):
-        """Return True if the data pulled across should be cached locally.
-        """
-        return True
-
-    def clone(self, offset=None):
-        """Return a new HttpTransport with root at self.base + offset
-        For now HttpTransport does not actually connect, so just return
-        a new HttpTransport object.
-        """
-        if offset is None:
-            return HttpTransport(self.base)
-        else:
-            return HttpTransport(self.abspath(offset))
-
-    def abspath(self, relpath):
-        """Return the full url to the given relative path.
-        This can be supplied with a string or a list
-        """
-        if isinstance(relpath, basestring):
-            relpath = [relpath]
-        basepath = self._path.split('/')
-        if len(basepath) > 0 and basepath[-1] == '':
-            basepath = basepath[:-1]
-
-        for p in relpath:
-            if p == '..':
-                if len(basepath) < 0:
-                    # In most filesystems, a request for the parent
-                    # of root, just returns root.
-                    continue
-                basepath.pop()
-            elif p == '.':
-                continue # No-op
-            else:
-                basepath.append(p)
-
-        # Possibly, we could use urlparse.urljoin() here, but
-        # I'm concerned about when it chooses to strip the last
-        # portion of the path, and when it doesn't.
-        path = '/'.join(basepath)
-        return urlparse.urlunparse((self._proto,
-                self._host, path, '', '', ''))
-
-    def relpath(self, abspath):
-        if not abspath.startswith(self.base):
-            raise NonRelativePath('path %r is not under base URL %r'
-                           % (abspath, self.base))
-        pl = len(self.base)
-        return abspath[pl:].lstrip('/')
-
-    def has(self, relpath):
-        """Does the target location exist?
-
-        TODO: HttpTransport.has() should use a HEAD request,
-        not a full GET request.
-
-        TODO: This should be changed so that we don't use
-        urllib2 and get an exception, the code path would be
-        cleaner if we just do an http HEAD request, and parse
-        the return code.
-        """
-        try:
-            f = get_url(self.abspath(relpath))
-            # Without the read and then close()
-            # we tend to have busy sockets.
-            f.read()
-            f.close()
-            return True
-        except BzrError:
-            return False
-        except urllib2.URLError:
-            return False
-        except IOError, e:
-            if e.errno == errno.ENOENT:
-                return False
-            raise HttpTransportError(orig_error=e)
-
-    def get(self, relpath, decode=False):
-        """Get the file at the given relative path.
-
-        :param relpath: The relative path to the file
-        """
-        try:
-            return get_url(self.abspath(relpath))
-        except (BzrError, urllib2.URLError, IOError), e:
-            raise NoSuchFile(orig_error=e)
-        except Exception,e:
-            raise HttpTransportError(orig_error=e)
-
-    def get_partial(self, relpath, start, length=None):
-        """Get just part of a file.
-
-        :param relpath: Path to the file, relative to base
-        :param start: The starting position to read from
-        :param length: The length to read. A length of None indicates
-                       read to the end of the file.
-        :return: A file-like object containing at least the specified bytes.
-                 Some implementations may return objects which can be read
-                 past this length, but this is not guaranteed.
-        """
-        # TODO: You can make specialized http requests for just
-        # a portion of the file. Figure out how to do that.
-        # For now, urllib2 returns files that cannot seek() so
-        # we just read bytes off the beginning, until we
-        # get to the point that we care about.
-        f = self.get(relpath)
-        # TODO: read in smaller chunks, in case things are
-        # buffered internally.
-        f.read(start)
-        return f
-
-    def put(self, relpath, f):
-        """Copy the file-like or string object into the location.
-
-        :param relpath: Location to put the contents, relative to base.
-        :param f:       File-like or string object.
-        """
-        raise TransportNotPossible('http PUT not supported')
-
-    def mkdir(self, relpath):
-        """Create a directory at the given path."""
-        raise TransportNotPossible('http does not support mkdir()')
-
-    def append(self, relpath, f):
-        """Append the text in the file-like object into the final
-        location.
-        """
-        raise TransportNotPossible('http does not support append()')
-
-    def copy(self, rel_from, rel_to):
-        """Copy the item at rel_from to the location at rel_to"""
-        raise TransportNotPossible('http does not support copy()')
-
-    def copy_to(self, relpaths, other, pb=None):
-        """Copy a set of entries from self into another Transport.
-
-        :param relpaths: A list/generator of entries to be copied.
-
-        TODO: if other is LocalTransport, is it possible to
-              do better than put(get())?
-        """
-        # At this point HttpTransport might be able to check and see if
-        # the remote location is the same, and rather than download, and
-        # then upload, it could just issue a remote copy_this command.
-        if isinstance(other, HttpTransport):
-            raise TransportNotPossible('http cannot be the target of copy_to()')
-        else:
-            return super(HttpTransport, self).copy_to(relpaths, other, pb=pb)
-
-    def move(self, rel_from, rel_to):
-        """Move the item at rel_from to the location at rel_to"""
-        raise TransportNotPossible('http does not support move()')
-
-    def delete(self, relpath):
-        """Delete the item at relpath"""
-        raise TransportNotPossible('http does not support delete()')
-
-    def listable(self):
-        """See Transport.listable."""
-        return False
-
-    def stat(self, relpath):
-        """Return the stat information for a file.
-        """
-        raise TransportNotPossible('http does not support stat()')
-
-    def lock_read(self, relpath):
-        """Lock the given file for shared (read) access.
-        :return: A lock object, which should be passed to Transport.unlock()
-        """
-        # The old RemoteBranch ignore lock for reading, so we will
-        # continue that tradition and return a bogus lock object.
-        class BogusLock(object):
-            def __init__(self, path):
-                self.path = path
-            def unlock(self):
-                pass
-        return BogusLock(relpath)
-
-    def lock_write(self, relpath):
-        """Lock the given file for exclusive (write) access.
-        WARNING: many transports do not support this, so trying avoid using it
-
-        :return: A lock object, which should be passed to Transport.unlock()
-        """
-        raise TransportNotPossible('http does not support lock_write()')
-
-register_transport('http://', HttpTransport)
-register_transport('https://', HttpTransport)

=== removed file 'bzrlib/transport/local.py'
--- bzrlib/transport/local.py	2005-10-04 04:37:29 +0000
+++ bzrlib/transport/local.py	1970-01-01 00:00:00 +0000
@@ -1,232 +0,0 @@
-# Copyright (C) 2005 Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-"""Implementation of Transport for the local filesystem.
-"""
-
-from bzrlib.transport import Transport, register_transport, \
-    TransportError, NoSuchFile, FileExists
-import os, errno
-
-class LocalTransportError(TransportError):
-    pass
-
-class LocalTransport(Transport):
-    """This is the transport agent for local filesystem access."""
-
-    def __init__(self, base):
-        """Set the base path where files will be stored."""
-        if base.startswith('file://'):
-            base = base[7:]
-        # realpath is incompatible with symlinks. When we traverse
-        # up we might be able to normpath stuff. RBC 20051003
-        super(LocalTransport, self).__init__(
-            os.path.normpath(os.path.abspath(base)))
-
-    def should_cache(self):
-        return False
-
-    def clone(self, offset=None):
-        """Return a new LocalTransport with root at self.base + offset
-        Because the local filesystem does not require a connection, 
-        we can just return a new object.
-        """
-        if offset is None:
-            return LocalTransport(self.base)
-        else:
-            return LocalTransport(self.abspath(offset))
-
-    def abspath(self, relpath):
-        """Return the full url to the given relative path.
-        This can be supplied with a string or a list
-        """
-        if isinstance(relpath, basestring):
-            relpath = [relpath]
-        return os.path.join(self.base, *relpath)
-
-    def relpath(self, abspath):
-        """Return the local path portion from a given absolute path.
-        """
-        from bzrlib.branch import _relpath
-        return _relpath(self.base, abspath)
-
-    def has(self, relpath):
-        return os.access(self.abspath(relpath), os.F_OK)
-
-    def get(self, relpath):
-        """Get the file at the given relative path.
-
-        :param relpath: The relative path to the file
-        """
-        try:
-            path = self.abspath(relpath)
-            return open(path, 'rb')
-        except IOError,e:
-            if e.errno == errno.ENOENT:
-                raise NoSuchFile('File %r does not exist' % path, orig_error=e)
-            raise LocalTransportError(orig_error=e)
-
-    def get_partial(self, relpath, start, length=None):
-        """Get just part of a file.
-
-        :param relpath: Path to the file, relative to base
-        :param start: The starting position to read from
-        :param length: The length to read. A length of None indicates
-                       read to the end of the file.
-        :return: A file-like object containing at least the specified bytes.
-                 Some implementations may return objects which can be read
-                 past this length, but this is not guaranteed.
-        """
-        # LocalTransport.get_partial() doesn't care about the length
-        # argument, because it is using a local file, and thus just
-        # returns the file seek'ed to the appropriate location.
-        try:
-            path = self.abspath(relpath)
-            f = open(path, 'rb')
-            f.seek(start, 0)
-            return f
-        except IOError,e:
-            if e.errno == errno.ENOENT:
-                raise NoSuchFile('File %r does not exist' % path, orig_error=e)
-            raise LocalTransportError(orig_error=e)
-
-    def put(self, relpath, f):
-        """Copy the file-like or string object into the location.
-
-        :param relpath: Location to put the contents, relative to base.
-        :param f:       File-like or string object.
-        """
-        from bzrlib.atomicfile import AtomicFile
-
-        try:
-            path = self.abspath(relpath)
-            fp = AtomicFile(path, 'wb')
-        except IOError, e:
-            if e.errno == errno.ENOENT:
-                raise NoSuchFile('File %r does not exist' % path, orig_error=e)
-            raise LocalTransportError(orig_error=e)
-        try:
-            self._pump(f, fp)
-            fp.commit()
-        finally:
-            fp.close()
-
-    def mkdir(self, relpath):
-        """Create a directory at the given path."""
-        try:
-            os.mkdir(self.abspath(relpath))
-        except OSError,e:
-            if e.errno == errno.EEXIST:
-                raise FileExists(orig_error=e)
-            elif e.errno == errno.ENOENT:
-                raise NoSuchFile(orig_error=e)
-            raise LocalTransportError(orig_error=e)
-
-    def append(self, relpath, f):
-        """Append the text in the file-like object into the final
-        location.
-        """
-        fp = open(self.abspath(relpath), 'ab')
-        self._pump(f, fp)
-
-    def copy(self, rel_from, rel_to):
-        """Copy the item at rel_from to the location at rel_to"""
-        import shutil
-        path_from = self.abspath(rel_from)
-        path_to = self.abspath(rel_to)
-        try:
-            shutil.copy(path_from, path_to)
-        except OSError,e:
-            raise LocalTransportError(orig_error=e)
-
-    def move(self, rel_from, rel_to):
-        """Move the item at rel_from to the location at rel_to"""
-        path_from = self.abspath(rel_from)
-        path_to = self.abspath(rel_to)
-
-        try:
-            os.rename(path_from, path_to)
-        except OSError,e:
-            raise LocalTransportError(orig_error=e)
-
-    def delete(self, relpath):
-        """Delete the item at relpath"""
-        try:
-            os.remove(self.abspath(relpath))
-        except OSError,e:
-            raise LocalTransportError(orig_error=e)
-
-    def copy_to(self, relpaths, other, pb=None):
-        """Copy a set of entries from self into another Transport.
-
-        :param relpaths: A list/generator of entries to be copied.
-        """
-        if isinstance(other, LocalTransport):
-            # Both from & to are on the local filesystem
-            # Unfortunately, I can't think of anything faster than just
-            # copying them across, one by one :(
-            import shutil
-
-            total = self._get_total(relpaths)
-            count = 0
-            for path in relpaths:
-                self._update_pb(pb, 'copy-to', count, total)
-                shutil.copy(self.abspath(path), other.abspath(path))
-                count += 1
-            return count
-        else:
-            return super(LocalTransport, self).copy_to(relpaths, other, pb=pb)
-
-    def listable(self):
-        """See Transport.listable."""
-        return True
-
-    def list_dir(self, relpath):
-        """Return a list of all files at the given location.
-        WARNING: many transports do not support this, so trying avoid using
-        it if at all possible.
-        """
-        try:
-            return os.listdir(self.abspath(relpath))
-        except OSError,e:
-            raise LocalTransportError(orig_error=e)
-
-    def stat(self, relpath):
-        """Return the stat information for a file.
-        """
-        try:
-            return os.stat(self.abspath(relpath))
-        except OSError,e:
-            raise LocalTransportError(orig_error=e)
-
-    def lock_read(self, relpath):
-        """Lock the given file for shared (read) access.
-        :return: A lock object, which should be passed to Transport.unlock()
-        """
-        from bzrlib.lock import ReadLock
-        return ReadLock(self.abspath(relpath))
-
-    def lock_write(self, relpath):
-        """Lock the given file for exclusive (write) access.
-        WARNING: many transports do not support this, so trying avoid using it
-
-        :return: A lock object, which should be passed to Transport.unlock()
-        """
-        from bzrlib.lock import WriteLock
-        return WriteLock(self.abspath(relpath))
-
-# If nothing else matches, try the LocalTransport
-register_transport(None, LocalTransport)
-register_transport('file://', LocalTransport)

=== modified file 'bzrlib/tree.py'
--- bzrlib/tree.py	2005-10-03 05:54:35 +0000
+++ bzrlib/tree.py	2005-09-22 06:54:01 +0000
@@ -24,7 +24,7 @@
 from bzrlib.trace import mutter, note
 from bzrlib.errors import BzrError, BzrCheckError
 from bzrlib.inventory import Inventory
-from bzrlib.osutils import appendpath, fingerprint_file
+from bzrlib.osutils import pumpfile, appendpath, fingerprint_file
 
 
 exporters = {}
@@ -134,7 +134,7 @@
     def get_file_lines(self, file_id):
         ie = self._inventory[file_id]
         weave = self.get_weave(file_id)
-        return weave.get(ie.revision)
+        return weave.get(ie.text_version)
         
 
     def get_file_text(self, file_id):
@@ -152,34 +152,25 @@
         if ie.kind == "file":
             return ie.text_sha1
 
-    def is_executable(self, file_id):
-        return self._inventory[file_id].executable
-
     def has_filename(self, filename):
         return bool(self.inventory.path2id(filename))
 
     def list_files(self):
         # The only files returned by this are those from the version
         for path, entry in self.inventory.iter_entries():
-            yield path, 'V', entry.kind, entry.file_id, entry
-
-    def get_symlink_target(self, file_id):
-        ie = self._inventory[file_id]
-        return ie.symlink_target;
+            yield path, 'V', entry.kind, entry.file_id
 
 
 class EmptyTree(Tree):
     def __init__(self):
         self._inventory = Inventory()
 
-    def get_symlink_target(self, file_id):
-        return None
-
     def has_filename(self, filename):
         return False
 
     def list_files(self):
-        return iter([])
+        if False:  # just to make it a generator
+            yield None
     
     def __contains__(self, file_id):
         return file_id in self._inventory
@@ -189,6 +180,8 @@
         return None
 
 
+
+
 ######################################################################
 # diff
 
@@ -275,8 +268,15 @@
     mutter('export version %r' % tree)
     inv = tree.inventory
     for dp, ie in inv.iter_entries():
-        ie.put_on_disk(dest, dp, tree)
-
+        kind = ie.kind
+        fullpath = appendpath(dest, dp)
+        if kind == 'directory':
+            os.mkdir(fullpath)
+        elif kind == 'file':
+            pumpfile(tree.get_file(ie.file_id), file(fullpath, 'wb'))
+        else:
+            raise BzrError("don't know how to export {%s} of kind %r" % (ie.file_id, kind))
+        mutter("  export {%s} kind %s to %s" % (ie.file_id, kind, fullpath))
 exporters['dir'] = dir_exporter
 
 try:
@@ -325,10 +325,27 @@
         inv = tree.inventory
         for dp, ie in inv.iter_entries():
             mutter("  export {%s} kind %s to %s" % (ie.file_id, ie.kind, dest))
-            item, fileobj = ie.get_tar_item(root, dp, now, tree)
+            item = tarfile.TarInfo(os.path.join(root, dp))
+            # TODO: would be cool to actually set it to the timestamp of the
+            # revision it was last changed
+            item.mtime = now
+            if ie.kind == 'directory':
+                item.type = tarfile.DIRTYPE
+                fileobj = None
+                item.name += '/'
+                item.size = 0
+                item.mode = 0755
+            elif ie.kind == 'file':
+                item.type = tarfile.REGTYPE
+                fileobj = tree.get_file(ie.file_id)
+                item.size = _find_file_size(fileobj)
+                item.mode = 0644
+            else:
+                raise BzrError("don't know how to export {%s} of kind %r" %
+                        (ie.file_id, ie.kind))
+
             ball.addfile(item, fileobj)
         ball.close()
-
     exporters['tar'] = tar_exporter
 
     def tgz_exporter(tree, dest, root):
@@ -338,3 +355,21 @@
     def tbz_exporter(tree, dest, root):
         tar_exporter(tree, dest, root, compression='bz2')
     exporters['tbz2'] = tbz_exporter
+
+
+def _find_file_size(fileobj):
+    offset = fileobj.tell()
+    try:
+        fileobj.seek(0, 2)
+        size = fileobj.tell()
+    except TypeError:
+        # gzip doesn't accept second argument to seek()
+        fileobj.seek(0)
+        size = 0
+        while True:
+            nread = len(fileobj.read())
+            if nread == 0:
+                break
+            size += nread
+    fileobj.seek(offset)
+    return size

=== modified file 'bzrlib/upgrade.py'
--- bzrlib/upgrade.py	2005-10-06 06:31:33 +0000
+++ bzrlib/upgrade.py	2005-09-23 04:13:53 +0000
@@ -68,9 +68,6 @@
 # versions.
 
 
-# TODO: Don't create a progress bar here, have it passed by the caller.  
-# At least do it from the UI factory.
-
 if False:
     try:
         import psyco
@@ -89,12 +86,13 @@
 from bzrlib.revfile import Revfile
 from bzrlib.weave import Weave
 from bzrlib.weavefile import read_weave, write_weave
-from bzrlib.ui import ui_factory
+from bzrlib.progress import ProgressBar
 from bzrlib.atomicfile import AtomicFile
 from bzrlib.xml4 import serializer_v4
 from bzrlib.xml5 import serializer_v5
 from bzrlib.trace import mutter, note, warning, enable_default_logging
 from bzrlib.osutils import sha_strings, sha_string
+from bzrlib.commit import merge_ancestry_lines
 
 
 class Convert(object):
@@ -114,10 +112,12 @@
         self._backup_control_dir()
         note('starting upgrade')
         note('note: upgrade may be faster if all store files are ungzipped first')
-        self.pb = ui_factory.progress_bar()
+        self.pb = ProgressBar()
         if not os.path.isdir(self.base + '/.bzr/weaves'):
             os.mkdir(self.base + '/.bzr/weaves')
         self.inv_weave = Weave('inventory')
+        self.anc_weave = Weave('ancestry')
+        self.ancestries = {}
         # holds in-memory weaves for all files
         self.text_weaves = {}
         os.remove(self.branch.controlfilename('branch-format'))
@@ -140,7 +140,7 @@
         self.pb.clear()
         note('upgraded to weaves:')
         note('  %6d revisions and inventories' % len(self.revisions))
-        note('  %6d revisions not present' % len(self.absent_revisions))
+        note('  %6d absent revisions removed' % len(self.absent_revisions))
         note('  %6d texts' % self.text_count)
         self._write_all_weaves()
         self._write_all_revs()
@@ -149,7 +149,7 @@
 
 
     def _open_branch(self):
-        self.branch = Branch.open_downlevel(self.base)
+        self.branch = Branch(self.base, relax_version_check=True)
         if self.branch._branch_format == 5:
             note('this branch is already in the most current format')
             return False
@@ -160,7 +160,11 @@
 
 
     def _set_new_format(self):
-        self.branch.put_controlfile('branch-format', BZR_BRANCH_FORMAT_5)
+        f = self.branch.controlfile('branch-format', 'wb')
+        try:
+            f.write(BZR_BRANCH_FORMAT_5)
+        finally:
+            f.close()
 
 
     def _cleanup_spare_files(self):
@@ -187,13 +191,13 @@
     def _convert_working_inv(self):
         branch = self.branch
         inv = serializer_v4.read_inventory(branch.controlfile('inventory', 'rb'))
-        new_inv_xml = serializer_v5.write_inventory_to_string(inv)
-        branch.put_controlfile('inventory', new_inv_xml)
+        serializer_v5.write_inventory(inv, branch.controlfile('inventory', 'wb'))
 
 
 
     def _write_all_weaves(self):
         write_a_weave(self.inv_weave, self.base + '/.bzr/inventory.weave')
+        write_a_weave(self.anc_weave, self.base + '/.bzr/ancestry.weave')
         i = 0
         try:
             for file_id, file_weave in self.text_weaves.items():
@@ -231,7 +235,7 @@
         if rev_id not in self.branch.revision_store:
             self.pb.clear()
             note('revision {%s} not present in branch; '
-                 'will be converted as a ghost',
+                 'will not be converted',
                  rev_id)
             self.absent_revisions.add(rev_id)
         else:
@@ -265,91 +269,134 @@
         """Convert revision and all referenced objects to new format."""
         rev = self.revisions[rev_id]
         inv = self._load_old_inventory(rev_id)
-        present_parents = [p for p in rev.parent_ids
-                           if p not in self.absent_revisions]
-        self._convert_revision_contents(rev, inv, present_parents)
-        self._store_new_weave(rev, inv, present_parents)
+        for parent_id in rev.parent_ids[:]:
+            if parent_id in self.absent_revisions:
+                rev.parent_ids.remove(parent_id)
+                self.pb.clear()
+                note('remove {%s} as parent of {%s}', parent_id, rev_id)
+        self._convert_revision_contents(rev, inv)
+        self._store_new_weave(rev, inv)
+        self._make_rev_ancestry(rev)
         self.converted_revs.add(rev_id)
 
 
-    def _store_new_weave(self, rev, inv, present_parents):
+    def _store_new_weave(self, rev, inv):
         # the XML is now updated with text versions
         if __debug__:
             for file_id in inv:
                 ie = inv[file_id]
                 if ie.kind == 'root_directory':
                     continue
-                assert hasattr(ie, 'revision'), \
-                    'no revision on {%s} in {%s}' % \
+                assert hasattr(ie, 'name_version'), \
+                    'no name_version on {%s} in {%s}' % \
                     (file_id, rev.revision_id)
+                if ie.kind == 'file':
+                    assert hasattr(ie, 'text_version')
+
         new_inv_xml = serializer_v5.write_inventory_to_string(inv)
         new_inv_sha1 = sha_string(new_inv_xml)
-        self.inv_weave.add(rev.revision_id, 
-                           present_parents,
+        self.inv_weave.add(rev.revision_id, rev.parent_ids,
                            new_inv_xml.splitlines(True),
                            new_inv_sha1)
         rev.inventory_sha1 = new_inv_sha1
 
-    def _convert_revision_contents(self, rev, inv, present_parents):
+
+    def _make_rev_ancestry(self, rev):
+        rev_id = rev.revision_id
+        for parent_id in rev.parent_ids:
+            assert parent_id in self.converted_revs
+        if rev.parent_ids:
+            lines = list(self.anc_weave.mash_iter(rev.parent_ids))
+        else:
+            lines = []
+        lines.append(rev_id + '\n')
+        if __debug__:
+            parent_ancestries = [self.ancestries[p] for p in rev.parent_ids]
+            new_lines = merge_ancestry_lines(rev_id, parent_ancestries)
+            assert set(lines) == set(new_lines)
+            self.ancestries[rev_id] = new_lines
+        self.anc_weave.add(rev_id, rev.parent_ids, lines)
+
+
+    def _convert_revision_contents(self, rev, inv):
         """Convert all the files within a revision.
 
         Also upgrade the inventory to refer to the text revision ids."""
         rev_id = rev.revision_id
         mutter('converting texts of revision {%s}',
                rev_id)
-        parent_invs = map(self._load_updated_inventory, present_parents)
+        parent_invs = map(self._load_updated_inventory, rev.parent_ids)
         for file_id in inv:
             ie = inv[file_id]
+            self._set_name_version(rev, ie, parent_invs)
+            if ie.kind != 'file':
+                continue
             self._convert_file_version(rev, ie, parent_invs)
 
+
+    def _set_name_version(self, rev, ie, parent_invs):
+        """Set name version for a file.
+
+        Done in a slightly lazy way: if the file is renamed or in a merge revision
+        it gets a new version, otherwise the same as before.
+        """
+        file_id = ie.file_id
+        if ie.kind == 'root_directory':
+            return
+        if len(parent_invs) != 1:
+            ie.name_version = rev.revision_id
+        else:
+            old_inv = parent_invs[0]
+            if not old_inv.has_id(file_id):
+                ie.name_version = rev.revision_id
+            else:
+                old_ie = old_inv[file_id]
+                if (old_ie.parent_id != ie.parent_id
+                    or old_ie.name != ie.name):
+                    ie.name_version = rev.revision_id
+                else:
+                    ie.name_version = old_ie.name_version
+
+
+
     def _convert_file_version(self, rev, ie, parent_invs):
         """Convert one version of one file.
 
         The file needs to be added into the weave if it is a merge
         of >=2 parents or if it's changed from its parent.
         """
-        if ie.kind == 'root_directory':
-            return
         file_id = ie.file_id
         rev_id = rev.revision_id
         w = self.text_weaves.get(file_id)
         if w is None:
             w = Weave(file_id)
             self.text_weaves[file_id] = w
+        file_parents = []
         text_changed = False
-        previous_entries = ie.find_previous_heads(parent_invs, w)
-        for old_revision in previous_entries:
-                # if this fails, its a ghost ?
-                assert old_revision in self.converted_revs 
-        self.snapshot_ie(previous_entries, ie, w, rev_id)
-        del ie.text_id
-        assert getattr(ie, 'revision', None) is not None
-
-    def snapshot_ie(self, previous_revisions, ie, w, rev_id):
-        # TODO: convert this logic, which is ~= snapshot to
-        # a call to:. This needs the path figured out. rather than a work_tree
-        # a v4 revision_tree can be given, or something that looks enough like
-        # one to give the file content to the entry if it needs it.
-        # and we need something that looks like a weave store for snapshot to 
-        # save against.
-        #ie.snapshot(rev, PATH, previous_revisions, REVISION_TREE, InMemoryWeaveStore(self.text_weaves))
-        if len(previous_revisions) == 1:
-            previous_ie = previous_revisions.values()[0]
-            if ie._unchanged(previous_ie):
-                ie.revision = previous_ie.revision
-                return
-        parent_indexes = map(w.lookup, previous_revisions)
-        if ie.has_text():
+        for parent_inv in parent_invs:
+            if parent_inv.has_id(file_id):
+                parent_ie = parent_inv[file_id]
+                old_text_version = parent_ie.text_version
+                assert old_text_version in self.converted_revs 
+                if old_text_version not in file_parents:
+                    file_parents.append(old_text_version)
+                if parent_ie.text_sha1 != ie.text_sha1:
+                    text_changed = True
+        if len(file_parents) != 1 or text_changed:
             file_lines = self.branch.text_store[ie.text_id].readlines()
             assert sha_strings(file_lines) == ie.text_sha1
             assert sum(map(len, file_lines)) == ie.text_size
-            w.add(rev_id, parent_indexes, file_lines, ie.text_sha1)
+            w.add(rev_id, file_parents, file_lines, ie.text_sha1)
+            ie.text_version = rev_id
             self.text_count += 1
+            ##mutter('import text {%s} of {%s}',
+            ##       ie.text_id, file_id)
         else:
-            w.add(rev_id, parent_indexes, [], None)
-        ie.revision = rev_id
-        ##mutter('import text {%s} of {%s}',
-        ##       ie.text_id, file_id)
+            ##mutter('text of {%s} unchanged from parent', file_id)
+            ie.text_version = file_parents[0]
+        del ie.text_id
+
+
 
     def _make_order(self):
         """Return a suitable order for importing revisions.

=== modified file 'bzrlib/weave.py'
--- bzrlib/weave.py	2005-10-06 08:11:46 +0000
+++ bzrlib/weave.py	2005-09-22 06:54:01 +0000
@@ -21,6 +21,37 @@
 
 """Weave - storage of related text file versions"""
 
+# before intset (r923) 2000 versions in 41.5s
+# with intset (r926) 2000 versions in 93s !!!
+# better to just use plain sets.
+
+# making _extract build and return a list, rather than being a generator
+# takes 37.94s
+
+# with python -O, r923 does 2000 versions in 36.87s
+
+# with optimizations to avoid mutating lists - 35.75!  I guess copying
+# all the elements every time costs more than the small manipulations.
+# a surprisingly small change.
+
+# r931, which avoids using a generator for extract, does 36.98s
+
+# with memoized inclusions, takes 41.49s; not very good
+
+# with slots, takes 37.35s; without takes 39.16, a bit surprising
+
+# with the delta calculation mixed in with the add method, rather than
+# separated, takes 36.78s
+
+# with delta folded in and mutation of the list, 36.13s
+
+# with all this and simplification of add code, 33s
+
+
+
+
+
+# TODO: Perhaps have copy method for Weave instances?
 
 # XXX: If we do weaves this way, will a merge still behave the same
 # way if it's done in a different order?  That's a pretty desirable
@@ -43,7 +74,7 @@
 
 # TODO: Parallel-extract that passes back each line along with a
 # description of which revisions include it.  Nice for checking all
-# shas or calculating stats in parallel.
+# shas in parallel.
 
 # TODO: Using a single _extract routine and then processing the output
 # is probably inefficient.  It's simple enough that we can afford to
@@ -57,24 +88,13 @@
 # variant that is passed a pre-cooked version of the single basis
 # version?
 
-# TODO: Have a way to go back and insert a revision V1 that is a parent 
-# of an already-stored revision V2.  This means some lines previously 
-# counted as new in V2 will be discovered to have actually come from V1.  
-# It is probably necessary to insert V1, then compute a whole new diff 
-# from the mashed ancestors to V2.  This must be repeated for every 
-# direct child of V1.  The deltas from V2 to its descendents won't change,
-# although their location within the weave may change.  It may be possible
-# to just adjust the location of those instructions rather than 
-# re-weaving the whole thing.  This is expected to be a fairly rare
-# operation, only used when inserting data that was previously a ghost.
-
-
 
 
 import sha
 from difflib import SequenceMatcher
 
 
+from bzrlib.osutils import sha_strings
 
 
 class WeaveError(Exception):
@@ -186,19 +206,6 @@
         self._weave_name = weave_name
 
 
-    def copy(self):
-        """Return a deep copy of self.
-        
-        The copy can be modified without affecting the original weave."""
-        other = Weave()
-        other._weave = self._weave[:]
-        other._parents = self._parents[:]
-        other._sha1s = self._sha1s[:]
-        other._names = self._names[:]
-        other._name_map = self._name_map.copy()
-        other._weave_name = self._weave_name
-        return other
-
     def __eq__(self, other):
         if not isinstance(other, Weave):
             return False
@@ -228,10 +235,6 @@
                              (name, self._weave_name))
 
 
-    def iter_names(self):
-        """Yield a list of all names in this weave."""
-        return iter(self._names)
-
     def idx_to_name(self, version):
         return self._names[version]
 
@@ -270,7 +273,6 @@
         sha -- SHA-1 of the file, if known.  This is trusted to be
             correct if supplied.
         """
-        from bzrlib.osutils import sha_strings
 
         assert isinstance(name, basestring)
         if sha1 is None:
@@ -377,10 +379,6 @@
 
         return new_version
 
-    def add_identical(self, old_rev_id, new_rev_id, parents):
-        """Add an identical text to old_rev_id as new_rev_id."""
-        old_lines = self.get(self.lookup(old_rev_id))
-        self.add(new_rev_id, parents, old_lines)
 
     def inclusions(self, versions):
         """Return set of all ancestors of given version(s)."""
@@ -641,6 +639,7 @@
         If there is a chunk of the file where there's no diagreement,
         only one alternative is given.
         """
+
         # approach: find the included versions common to all the
         # merged versions
         raise NotImplementedError()
@@ -666,7 +665,7 @@
         If line1=line2, this is a pure insert; if newlines=[] this is a
         pure delete.  (Similar to difflib.)
         """
-        raise NotImplementedError()
+
 
             
     def plan_merge(self, ver_a, ver_b):
@@ -766,75 +765,9 @@
                        state
 
                 
-    def join(self, other):
-        """Integrate versions from other into this weave.
-
-        The resulting weave contains all the history of both weaves; 
-        any version you could retrieve from either self or other can be 
-        retrieved from self after this call.
-
-        It is illegal for the two weaves to contain different values 
-        for any version.
-        """
-        if other.numversions() == 0:
-            return          # nothing to update, easy
-        # work through in index order to make sure we get all dependencies
-        for other_idx, name in enumerate(other._names):
-            # TODO: If all the parents of the other version are already 
-            # present then we can avoid some work by just taking the delta
-            # and adjusting the offsets.
-            if self._check_version_consistent(other, other_idx, name):
-                continue
-            new_parents = self._imported_parents(other, other_idx)
-            lines = other.get_lines(other_idx)
-            sha1 = other._sha1s[other_idx]
-            self.add(name, new_parents, lines, sha1)
-
-
-    def _imported_parents(self, other, other_idx):
-        """Return list of parents in self corresponding to indexes in other."""
-        new_parents = []
-        for parent_idx in other._parents[other_idx]:
-            parent_name = other._names[parent_idx]
-            if parent_name not in self._names:
-                # should not be possible
-                raise WeaveError("missing parent {%s} of {%s} in %r" 
-                                 % (parent_name, other._name_map[other_idx], self))
-            new_parents.append(self._name_map[parent_name])
-        return new_parents
-
-    def _check_version_consistent(self, other, other_idx, name):
-        """Check if a version in consistent in this and other.
-
-        To be consistent it must have:
-
-         * the same text
-         * the same direct parents (by name, not index, and disregarding
-           order)
-        
-        If present & correct return True;
-        if not present in self return False; 
-        if inconsistent raise error."""
-        this_idx = self._name_map.get(name, -1)
-        if this_idx != -1:
-            if self._sha1s[this_idx] != other._sha1s[other_idx]:
-                raise WeaveError("inconsistent texts for version {%s} "
-                                 "when joining weaves"
-                                 % (name))
-            self_parents = self._parents[this_idx]
-            other_parents = other._parents[other_idx]
-            n1 = [self._names[i] for i in self_parents]
-            n2 = [other._names[i] for i in other_parents]
-            n1.sort()
-            n2.sort()
-            if n1 != n2:
-                raise WeaveError("inconsistent parents for version {%s}: "
-                                 "%s vs %s"
-                                 % (name, n1, n2))
-            else:
-                return True         # ok!
-        else:
-            return False
+
+
+
 
 
 def weave_toc(w):
@@ -851,9 +784,12 @@
 
 
 
-def weave_stats(weave_file, pb):
+def weave_stats(weave_file):
+    from bzrlib.progress import ProgressBar
     from bzrlib.weavefile import read_weave
 
+    pb = ProgressBar()
+
     wf = file(weave_file, 'rb')
     w = read_weave(wf)
     # FIXME: doesn't work on pipes
@@ -863,7 +799,7 @@
     vers = len(w)
     for i in range(vers):
         pb.update('checking sizes', i, vers)
-        for origin, lineno, line in w._extract([i]):
+        for line in w.get_iter(i):
             total += len(line)
 
     pb.clear()
@@ -932,12 +868,6 @@
 def main(argv):
     import sys
     import os
-    try:
-        import bzrlib
-    except ImportError:
-        # in case we're run directly from the subdirectory
-        sys.path.append('..')
-        import bzrlib
     from bzrlib.weavefile import write_weave, read_weave
     from bzrlib.progress import ProgressBar
 
@@ -1010,7 +940,7 @@
         weave_toc(readit())
 
     elif cmd == 'stats':
-        weave_stats(argv[2], ProgressBar())
+        weave_stats(argv[2])
         
     elif cmd == 'check':
         w = readit()

=== renamed file 'bzrlib/store/weave.py' => 'bzrlib/weavestore.py'
--- bzrlib/store/weave.py	2005-10-05 06:44:02 +0000
+++ bzrlib/weavestore.py	2005-09-29 02:01:49 +0000
@@ -16,62 +16,43 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-# XXX: Some consideration of the problems that might occur if there are
-# files whose id differs only in case.  That should probably be forbidden.
-
-
-from cStringIO import StringIO
+# Author: Martin Pool <mbp@canonical.com>
+
+
 import os
 import errno
 
 from bzrlib.weavefile import read_weave, write_weave_v5
 from bzrlib.weave import Weave
-from bzrlib.store import Store
 from bzrlib.atomicfile import AtomicFile
-from bzrlib.errors import NoSuchFile
-from bzrlib.trace import mutter
-
-
-class WeaveStore(Store):
+
+
+
+
+class WeaveStore(object):
     """Collection of several weave files in a directory.
 
     This has some shortcuts for reading and writing them.
     """
-    FILE_SUFFIX = '.weave'
-
-    def __init__(self, transport):
-        self._transport = transport
+    def __init__(self, dir, get_file=None):
+        self._dir = dir
         self._cache = {}
         self.enable_cache = False
+        if get_file is not None:
+            self.get_file = get_file
 
+    def get_file(self, filename):
+        return file(filename, 'rb')
 
     def filename(self, file_id):
-        """Return the path relative to the transport root."""
-        return file_id + WeaveStore.FILE_SUFFIX
-
-    def __iter__(self):
-        l = len(WeaveStore.FILE_SUFFIX)
-        for f in self._transport.list_dir('.'):
-            if f.endswith(WeaveStore.FILE_SUFFIX):
-                f = f[:-l]
-                yield f
-
-    def __contains__(self, fileid):
-        """"""
-        return self._transport.has(self.filename(fileid))
-
-    def _get(self, file_id):
-        return self._transport.get(self.filename(file_id))
-
-    def _put(self, file_id, f):
-        return self._transport.put(self.filename(file_id), f)
+        return self._dir + os.sep + file_id + '.weave'
+
 
     def get_weave(self, file_id):
         if self.enable_cache:
             if file_id in self._cache:
-                mutter("cache hit in %s for %s", self, file_id)
                 return self._cache[file_id]
-        w = read_weave(self._get(file_id))
+        w = read_weave(self.get_file(self.filename(file_id)))
         if self.enable_cache:
             self._cache[file_id] = w
         return w
@@ -88,23 +69,31 @@
     def get_weave_or_empty(self, file_id):
         """Return a weave, or an empty one if it doesn't exist.""" 
         try:
-            inf = self._get(file_id)
-        except NoSuchFile:
-            return Weave(weave_name=file_id)
+            inf = self.get_file(self.filename(file_id))
+        except IOError, e:
+            if e.errno == errno.ENOENT:
+                return Weave(weave_name=file_id)
+            else:
+                raise
         else:
             return read_weave(inf)
     
 
+    def put_empty_weave(self, file_id):
+        self.put_weave(file_id, Weave())
+
+
     def put_weave(self, file_id, weave):
         """Write back a modified weave"""
         if self.enable_cache:
             self._cache[file_id] = weave
-
-        sio = StringIO()
-        write_weave_v5(weave, sio)
-        sio.seek(0)
-
-        self._put(file_id, sio)
+        weave_fn = self.filename(file_id)
+        af = AtomicFile(weave_fn)
+        try:
+            write_weave_v5(weave, af)
+            af.commit()
+        finally:
+            af.close()
 
 
     def add_text(self, file_id, rev_id, new_lines, parents):
@@ -113,14 +102,4 @@
         w.add(rev_id, parent_idxs, new_lines)
         self.put_weave(file_id, w)
         
-    def add_identical_text(self, file_id, old_rev_id, new_rev_id, parents):
-        w = self.get_weave_or_empty(file_id)
-        parent_idxs = map(w.lookup, parents)
-        w.add_identical(old_rev_id, new_rev_id, parent_idxs)
-        self.put_weave(file_id, w)
      
-    def copy_multi(self, from_store, file_ids):
-        assert isinstance(from_store, WeaveStore)
-        for f in file_ids:
-            mutter("copy weave {%s} into %s", f, self)
-            self._put(f, from_store._get(f))

=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2005-10-06 04:29:10 +0000
+++ bzrlib/workingtree.py	2005-09-15 04:32:41 +0000
@@ -21,7 +21,6 @@
 # it's not predictable when it will be written out.
 
 import os
-import stat
 import fnmatch
         
 import bzrlib.tree
@@ -29,61 +28,6 @@
 from bzrlib.errors import BzrCheckError
 from bzrlib.trace import mutter
 
-class TreeEntry(object):
-    """An entry that implements the minium interface used by commands.
-
-    This needs further inspection, it may be better to have 
-    InventoryEntries without ids - though that seems wrong. For now,
-    this is a parallel hierarchy to InventoryEntry, and needs to become
-    one of several things: decorates to that hierarchy, children of, or
-    parents of it.
-    Another note is that these objects are currently only used when there is
-    no InventoryEntry available - i.e. for unversioned objects.
-    Perhaps they should be UnversionedEntry et al. ? - RBC 20051003
-    """
- 
-    def __eq__(self, other):
-        # yes, this us ugly, TODO: best practice __eq__ style.
-        return (isinstance(other, TreeEntry)
-                and other.__class__ == self.__class__)
- 
-    def kind_character(self):
-        return "???"
-
-
-class TreeDirectory(TreeEntry):
-    """See TreeEntry. This is a directory in a working tree."""
-
-    def __eq__(self, other):
-        return (isinstance(other, TreeDirectory)
-                and other.__class__ == self.__class__)
-
-    def kind_character(self):
-        return "/"
-
-
-class TreeFile(TreeEntry):
-    """See TreeEntry. This is a regular file in a working tree."""
-
-    def __eq__(self, other):
-        return (isinstance(other, TreeFile)
-                and other.__class__ == self.__class__)
-
-    def kind_character(self):
-        return ''
-
-
-class TreeLink(TreeEntry):
-    """See TreeEntry. This is a symlink in a working tree."""
-
-    def __eq__(self, other):
-        return (isinstance(other, TreeLink)
-                and other.__class__ == self.__class__)
-
-    def kind_character(self):
-        return ''
-
-
 class WorkingTree(bzrlib.tree.Tree):
     """Working copy tree.
 
@@ -125,7 +69,7 @@
         """
         inv = self._inventory
         for path, ie in inv.iter_entries():
-            if bzrlib.osutils.lexists(self.abspath(path)):
+            if os.path.exists(self.abspath(path)):
                 yield ie.file_id
 
 
@@ -139,7 +83,7 @@
         return os.path.join(self.basedir, filename)
 
     def has_filename(self, filename):
-        return bzrlib.osutils.lexists(self.abspath(filename))
+        return os.path.exists(self.abspath(filename))
 
     def get_file(self, file_id):
         return self.get_file_byname(self.id2path(file_id))
@@ -162,7 +106,7 @@
         if not inv.has_id(file_id):
             return False
         path = inv.id2path(file_id)
-        return bzrlib.osutils.lexists(self.abspath(path))
+        return os.path.exists(self.abspath(path))
 
 
     __contains__ = has_id
@@ -171,22 +115,12 @@
     def get_file_size(self, file_id):
         return os.path.getsize(self.id2abspath(file_id))
 
+
     def get_file_sha1(self, file_id):
         path = self._inventory.id2path(file_id)
         return self._hashcache.get_sha1(path)
 
 
-    def is_executable(self, file_id):
-        if os.name == "nt":
-            return self._inventory[file_id].executable
-        else:
-            path = self._inventory.id2path(file_id)
-            mode = os.lstat(self.abspath(path)).st_mode
-            return bool(stat.S_ISREG(mode) and stat.S_IEXEC&mode)
-
-    def get_symlink_target(self, file_id):
-        return os.readlink(self.id2path(file_id))
-
     def file_class(self, filename):
         if self.path2id(filename):
             return 'V'
@@ -240,20 +174,7 @@
                                             "now of kind %r"
                                             % (fap, f_ie.kind, f_ie.file_id, fk))
 
-                # make a last minute entry
-                if f_ie:
-                    entry = f_ie
-                else:
-                    if fk == 'directory':
-                        entry = TreeDirectory()
-                    elif fk == 'file':
-                        entry = TreeFile()
-                    elif fk == 'symlink':
-                        entry = TreeLink()
-                    else:
-                        entry = TreeEntry()
-                
-                yield fp, c, fk, (f_ie and f_ie.file_id), entry
+                yield fp, c, fk, (f_ie and f_ie.file_id)
 
                 if fk != 'directory':
                     continue
@@ -275,15 +196,6 @@
             if not self.is_ignored(subp):
                 yield subp
 
-    def iter_conflicts(self):
-        conflicted = set()
-        for path in (s[0] for s in self.list_files()):
-            stem = get_conflicted_stem(path)
-            if stem is None:
-                continue
-            if stem not in conflicted:
-                conflicted.add(stem)
-                yield stem
 
     def extras(self):
         """Yield all unknown files in this WorkingTree.
@@ -375,9 +287,4 @@
                     return pat
         else:
             return None
-
-CONFLICT_SUFFIXES = ('.THIS', '.BASE', '.OTHER')
-def get_conflicted_stem(path):
-    for suffix in CONFLICT_SUFFIXES:
-        if path.endswith(suffix):
-            return path[:-len(suffix)]
+        

=== modified file 'bzrlib/xml.py'
--- bzrlib/xml.py	2005-10-03 14:28:37 +0000
+++ bzrlib/xml.py	2005-09-27 07:24:40 +0000
@@ -1,4 +1,3 @@
-#! /usr/bin/env python
 # -*- coding: UTF-8 -*-
 
 # This program is free software; you can redistribute it and/or modify
@@ -35,6 +34,7 @@
                                               Element, XMLTreeBuilder,
                                               fromstring, tostring)
 
+from bzrlib.inventory import ROOT_ID, Inventory, InventoryEntry
 from bzrlib.errors import BzrError
 
 
@@ -72,3 +72,4 @@
 
     def _read_element(self, f):
         return ElementTree().parse(f)
+

=== modified file 'bzrlib/xml4.py'
--- bzrlib/xml4.py	2005-10-03 15:19:25 +0000
+++ bzrlib/xml4.py	2005-09-19 08:04:06 +0000
@@ -17,7 +17,6 @@
 
 from bzrlib.xml import ElementTree, SubElement, Element, Serializer
 from bzrlib.inventory import ROOT_ID, Inventory, InventoryEntry
-import bzrlib.inventory as inventory
 from bzrlib.revision import Revision        
 from bzrlib.errors import BzrError
 
@@ -54,7 +53,7 @@
         if ie.text_size != None:
             e.set('text_size', '%d' % ie.text_size)
 
-        for f in ['text_id', 'text_sha1', 'symlink_target']:
+        for f in ['text_id', 'text_sha1']:
             v = getattr(ie, f)
             if v != None:
                 e.set(f, v)
@@ -95,29 +94,18 @@
         if parent_id == None:
             parent_id = ROOT_ID
 
-        kind = elt.get('kind')
-        if kind == 'directory':
-            ie = inventory.InventoryDirectory(elt.get('file_id'),
-                                              elt.get('name'),
-                                              parent_id)
-        elif kind == 'file':
-            ie = inventory.InventoryFile(elt.get('file_id'),
-                                         elt.get('name'),
-                                         parent_id)
-            ie.text_id = elt.get('text_id')
-            ie.text_sha1 = elt.get('text_sha1')
-            v = elt.get('text_size')
-            ie.text_size = v and int(v)
-        elif kind == 'symlink':
-            ie = inventory.InventoryLink(elt.get('file_id'),
-                                         elt.get('name'),
-                                         parent_id)
-            ie.symlink_target = elt.get('symlink_target')
-        else:
-            raise BzrError("unknown kind %r" % kind)
+        ie = InventoryEntry(elt.get('file_id'),
+                            elt.get('name'),
+                            elt.get('kind'),
+                            parent_id)
+        ie.text_id = elt.get('text_id')
+        ie.text_sha1 = elt.get('text_sha1')
 
         ## mutter("read inventoryentry: %r" % (elt.attrib))
 
+        v = elt.get('text_size')
+        ie.text_size = v and int(v)
+
         return ie
 
 

=== modified file 'bzrlib/xml5.py'
--- bzrlib/xml5.py	2005-10-06 06:31:16 +0000
+++ bzrlib/xml5.py	2005-09-22 01:20:17 +0000
@@ -17,7 +17,6 @@
 
 from bzrlib.xml import ElementTree, SubElement, Element, Serializer
 from bzrlib.inventory import ROOT_ID, Inventory, InventoryEntry
-import bzrlib.inventory as inventory
 from bzrlib.revision import Revision        
 from bzrlib.errors import BzrError
 
@@ -35,8 +34,7 @@
     
     def _pack_inventory(self, inv):
         """Convert to XML Element"""
-        e = Element('inventory',
-                    format='5')
+        e = Element('inventory')
         e.text = '\n'
         if inv.root.file_id not in (None, ROOT_ID):
             e.set('file_id', inv.root.file_id)
@@ -47,8 +45,7 @@
 
     def _pack_entry(self, ie):
         """Convert InventoryEntry to XML element"""
-        if not InventoryEntry.versionable_kind(ie.kind):
-            raise AssertionError('unsupported entry kind %s' % ie.kind)
+        assert ie.kind == 'directory' or ie.kind == 'file'
         e = Element(ie.kind)
         e.set('name', ie.name)
         e.set('file_id', ie.file_id)
@@ -56,14 +53,11 @@
         if ie.text_size != None:
             e.set('text_size', '%d' % ie.text_size)
 
-        for f in ['text_sha1', 'revision', 'symlink_target']:
+        for f in ['text_version', 'text_sha1', 'name_version']:
             v = getattr(ie, f)
             if v != None:
                 e.set(f, v)
 
-        if ie.executable:
-            e.set('executable', 'yes')
-
         # to be conservative, we don't externalize the root pointers
         # for now, leaving them as null in the xml form.  in a future
         # version it will be implied by nested elements.
@@ -83,14 +77,15 @@
                        timestamp = '%.9f' % rev.timestamp,
                        revision_id = rev.revision_id,
                        inventory_sha1 = rev.inventory_sha1,
-                       format='5',
                        )
         if rev.timezone:
             root.set('timezone', str(rev.timezone))
         root.text = '\n'
+
         msg = SubElement(root, 'message')
         msg.text = rev.message
         msg.tail = '\n'
+
         if rev.parent_ids:
             pelts = SubElement(root, 'parents')
             pelts.tail = pelts.text = '\n'
@@ -100,6 +95,7 @@
                 p.tail = '\n'
                 p.set('revision_id', parent_id)
         return root
+
     
 
     def _unpack_inventory(self, elt):
@@ -107,11 +103,6 @@
         """
         assert elt.tag == 'inventory'
         root_id = elt.get('file_id') or ROOT_ID
-        format = elt.get('format')
-        if format is not None:
-            if format != '5':
-                raise BzrError("invalid format version %r on inventory"
-                                % format)
         inv = Inventory(root_id)
         for e in elt:
             ie = self._unpack_entry(e)
@@ -123,34 +114,22 @@
 
     def _unpack_entry(self, elt):
         kind = elt.tag
-        if not InventoryEntry.versionable_kind(kind):
-            raise AssertionError('unsupported entry kind %s' % kind)
+        assert kind == 'directory' or kind == 'file', \
+	    'unsupported entry kind %s' % kind
 
         parent_id = elt.get('parent_id')
         if parent_id == None:
             parent_id = ROOT_ID
 
-        if kind == 'directory':
-            ie = inventory.InventoryDirectory(elt.get('file_id'),
-                                              elt.get('name'),
-                                              parent_id)
-        elif kind == 'file':
-            ie = inventory.InventoryFile(elt.get('file_id'),
-                                         elt.get('name'),
-                                         parent_id)
-            ie.text_sha1 = elt.get('text_sha1')
-            if elt.get('executable') == 'yes':
-                ie.executable = True
-            v = elt.get('text_size')
-            ie.text_size = v and int(v)
-        elif kind == 'symlink':
-            ie = inventory.InventoryLink(elt.get('file_id'),
-                                         elt.get('name'),
-                                         parent_id)
-            ie.symlink_target = elt.get('symlink_target')
-        else:
-            raise BzrError("unknown kind %r" % kind)
-        ie.revision = elt.get('revision')
+        ie = InventoryEntry(elt.get('file_id'),
+                            elt.get('name'),
+                            kind,
+                            parent_id)
+        ie.text_version = elt.get('text_version')
+        ie.name_version = elt.get('name_version')
+        ie.text_sha1 = elt.get('text_sha1')
+        v = elt.get('text_size')
+        ie.text_size = v and int(v)
 
         return ie
 
@@ -158,16 +137,13 @@
     def _unpack_revision(self, elt):
         """XML Element -> Revision object"""
         assert elt.tag == 'revision'
-        format = elt.get('format')
-        if format is not None:
-            if format != '5':
-                raise BzrError("invalid format version %r on inventory"
-                                % format)
+        
         rev = Revision(committer = elt.get('committer'),
                        timestamp = float(elt.get('timestamp')),
                        revision_id = elt.get('revision_id'),
                        inventory_sha1 = elt.get('inventory_sha1')
                        )
+
         parents = elt.find('parents') or []
         for p in parents:
             assert p.tag == 'revision_ref', \
@@ -181,4 +157,5 @@
         return rev
 
 
+
 serializer_v5 = Serializer_v5()

=== added file 'patches/symlink-support.patch'
--- patches/symlink-support.patch	1970-01-01 00:00:00 +0000
+++ patches/symlink-support.patch	2005-05-17 07:01:47 +0000
@@ -0,0 +1,629 @@
+Return-Path: <erik@tntech.dk>
+X-Original-To: mbp@sourcefrog.net
+Delivered-To: mbp@ozlabs.org
+X-Greylist: delayed 1826 seconds by postgrey-1.21 at ozlabs; Sun, 15 May 2005 06:59:11 EST
+Received: from upstroke.tntech.dk (cpe.atm2-0-1041078.0x503eaf62.odnxx4.customer.tele.dk [80.62.175.98])
+	by ozlabs.org (Postfix) with ESMTP id B968E679EA
+	for <mbp@sourcefrog.net>; Sun, 15 May 2005 06:59:11 +1000 (EST)
+Received: by upstroke.tntech.dk (Postfix, from userid 1001)
+	id 63F83542FF; Sat, 14 May 2005 22:28:37 +0200 (CEST)
+To: Martin Pool <mbp@sourcefrog.net>
+Subject: [PATCH] symlink support patch
+From: Erik Toubro Nielsen <erik@tntech.dk>
+Date: Sat, 14 May 2005 22:28:37 +0200
+Message-ID: <86u0l57dsa.fsf@upstroke.tntech.dk>
+User-Agent: Gnus/5.1006 (Gnus v5.10.6) XEmacs/21.4 (Security Through
+ Obscurity, linux)
+MIME-Version: 1.0
+Content-Type: multipart/mixed; boundary="=-=-="
+X-Spam-Checker-Version: SpamAssassin 3.0.3 (2005-04-27) on ozlabs.org
+X-Spam-Level: 
+X-Spam-Status: No, score=-1.4 required=3.2 tests=BAYES_00,NO_MORE_FUNN,
+	RCVD_IN_BLARS_RBL autolearn=no version=3.0.3
+Content-Length: 19688
+Lines: 604
+
+--=-=-=
+
+I'm not sending this to the list as it is pretty large. 
+
+Let me know if its usefull and if I should rework anything.
+
+Erik
+
+
+Overview:
+
+        (Bugfix: in class TreeDelta I've moved kind= one level up, since
+        kind is also used in the else part)
+
+        Since both the InventoryEntry and stat cache is changed, perhaps
+        the branch format number should be increased?
+
+        Added test cases for symlinks to testbzr
+
+        Cannot use realpath since it expands path/L to path/LinkTarget
+        Cannot use exists, use new osutils.lexists
+
+        I'm overloading the text_modified to signify that a link        
+        target is changed. Perhaps text_modified should be renamed
+        content_modified?
+
+        InventoryEntry has a new member "symlink_target", 
+
+        The stat cache entry has been extended to contain the symlink
+        target and the st_mode. I try to ignore an old format cache
+        file.
+
+
+
+--=-=-=
+Content-Type: text/x-patch
+Content-Disposition: inline; filename=symlinksupport.patch
+
+*** modified file 'bzrlib/add.py'
+--- bzrlib/add.py 
++++ bzrlib/add.py 
+@@ -38,7 +38,7 @@
+     for f in file_list:
+         kind = bzrlib.osutils.file_kind(f)
+ 
+-        if kind != 'file' and kind != 'directory':
++        if kind != 'file' and kind != 'directory' and kind != 'symlink':
+             if f not in user_list:
+                 print "Skipping %s (can't add file of kind '%s')" % (f, kind)
+                 continue
+@@ -56,7 +56,7 @@
+ 
+         kind = bzrlib.osutils.file_kind(f)
+ 
+-        if kind != 'file' and kind != 'directory':
++        if kind != 'file' and kind != 'directory' and kind != 'symlink':
+             bailout("can't add file '%s' of kind %r" % (f, kind))
+             
+         versioned = (inv.path2id(rf) != None)
+
+*** modified file 'bzrlib/branch.py'
+--- bzrlib/branch.py 
++++ bzrlib/branch.py 
+@@ -58,11 +58,9 @@
+     run into the root."""
+     if f == None:
+         f = os.getcwd()
+-    elif hasattr(os.path, 'realpath'):
+-        f = os.path.realpath(f)
+     else:
+-        f = os.path.abspath(f)
+-    if not os.path.exists(f):
++        f = bzrlib.osutils.normalizepath(f)
++    if not bzrlib.osutils.lexists(f):
+         raise BzrError('%r does not exist' % f)
+         
+ 
+@@ -189,7 +187,7 @@
+         """Return path relative to this branch of something inside it.
+ 
+         Raises an error if path is not in this branch."""
+-        rp = os.path.realpath(path)
++        rp = bzrlib.osutils.normalizepath(path)
+         # FIXME: windows
+         if not rp.startswith(self.base):
+             bailout("path %r is not within branch %r" % (rp, self.base))
+@@ -531,7 +529,9 @@
+             file_id = entry.file_id
+             mutter('commit prep file %s, id %r ' % (p, file_id))
+ 
+-            if not os.path.exists(p):
++            # it should be enough to use os.lexists instead of exists
++            # but lexists in an 2.4 function
++            if not bzrlib.osutils.lexists(p):
+                 mutter("    file is missing, removing from inventory")
+                 if verbose:
+                     show_status('D', entry.kind, quotefn(path))
+@@ -554,6 +554,10 @@
+             if entry.kind == 'directory':
+                 if not isdir(p):
+                     bailout("%s is entered as directory but not a directory" % quotefn(p))
++            elif entry.kind == 'symlink':
++                if not os.path.islink(p):
++                    bailout("%s is entered as symbolic link but is not a symbolic link" % quotefn(p))
++                entry.read_symlink_target(p)
+             elif entry.kind == 'file':
+                 if not isfile(p):
+                     bailout("%s is entered as file but is not a file" % quotefn(p))
+
+*** modified file 'bzrlib/diff.py'
+--- bzrlib/diff.py 
++++ bzrlib/diff.py 
+@@ -66,6 +66,11 @@
+         print >>to_file, "\\ No newline at end of file"
+     print >>to_file
+ 
++def _diff_symlink(old_tree, new_tree, file_id):
++    t1 = old_tree.get_symlink_target(file_id)
++    t2 = new_tree.get_symlink_target(file_id)
++    print '*** *** target changed %r => %r' % (t1, t2)
++    
+ 
+ def show_diff(b, revision, specific_files):
+     import sys
+@@ -112,12 +117,15 @@
+ 
+     for old_path, new_path, file_id, kind, text_modified in delta.renamed:
+         print '*** renamed %s %r => %r' % (kind, old_path, new_path)
+-        if text_modified:
++        if kind == 'file' and text_modified:
+             _diff_one(old_tree.get_file(file_id).readlines(),
+                    new_tree.get_file(file_id).readlines(),
+                    sys.stdout,
+                    fromfile=old_label + old_path,
+                    tofile=new_label + new_path)
++
++        elif kind == 'symlink' and text_modified:
++            _diff_symlink(old_tree, new_tree, file_id)
+ 
+     for path, file_id, kind in delta.modified:
+         print '*** modified %s %r' % (kind, path)
+@@ -128,6 +136,8 @@
+                    fromfile=old_label + path,
+                    tofile=new_label + path)
+ 
++        elif kind == 'symlink':
++            _diff_symlink(old_tree, new_tree, file_id)
+ 
+ 
+ class TreeDelta:
+@@ -149,7 +159,9 @@
+     Each id is listed only once.
+ 
+     Files that are both modified and renamed are listed only in
+-    renamed, with the text_modified flag true.
++    renamed, with the text_modified flag true. The text_modified
++    applies either to the the content of the file or the target of the
++    symbolic link, depending of the kind of file.
+ 
+     The lists are normally sorted when the delta is created.
+     """
+@@ -224,8 +236,8 @@
+         specific_files = ImmutableSet(specific_files)
+ 
+     for file_id in old_tree:
++        kind = old_inv.get_file_kind(file_id)
+         if file_id in new_tree:
+-            kind = old_inv.get_file_kind(file_id)
+             assert kind == new_inv.get_file_kind(file_id)
+             
+             assert kind in ('file', 'directory', 'symlink', 'root_directory'), \
+@@ -246,6 +258,14 @@
+                 old_sha1 = old_tree.get_file_sha1(file_id)
+                 new_sha1 = new_tree.get_file_sha1(file_id)
+                 text_modified = (old_sha1 != new_sha1)
++            elif kind == 'symlink':
++                t1 = old_tree.get_symlink_target(file_id)
++                t2 = new_tree.get_symlink_target(file_id)
++                if t1 != t2:
++                    mutter("    symlink target changed")
++                    text_modified = True
++                else:
++                    text_modified = False
+             else:
+                 ## mutter("no text to check for %r %r" % (file_id, kind))
+                 text_modified = False
+
+*** modified file 'bzrlib/inventory.py'
+--- bzrlib/inventory.py 
++++ bzrlib/inventory.py 
+@@ -125,14 +125,22 @@
+         self.kind = kind
+         self.text_id = text_id
+         self.parent_id = parent_id
++        self.symlink_target = None
+         if kind == 'directory':
+             self.children = {}
+         elif kind == 'file':
+             pass
++        elif kind == 'symlink':
++            pass
+         else:
+             raise BzrError("unhandled entry kind %r" % kind)
+ 
+-
++    def read_symlink_target(self, path):
++        if self.kind == 'symlink':
++            try:
++                self.symlink_target = os.readlink(path)
++            except OSError,e:
++                raise BzrError("os.readlink error, %s" % e)
+ 
+     def sorted_children(self):
+         l = self.children.items()
+@@ -145,6 +153,7 @@
+                                self.parent_id, text_id=self.text_id)
+         other.text_sha1 = self.text_sha1
+         other.text_size = self.text_size
++        other.symlink_target = self.symlink_target
+         return other
+ 
+ 
+@@ -168,7 +177,7 @@
+         if self.text_size != None:
+             e.set('text_size', '%d' % self.text_size)
+             
+-        for f in ['text_id', 'text_sha1']:
++        for f in ['text_id', 'text_sha1', 'symlink_target']:
+             v = getattr(self, f)
+             if v != None:
+                 e.set(f, v)
+@@ -198,6 +207,7 @@
+         self = cls(elt.get('file_id'), elt.get('name'), elt.get('kind'), parent_id)
+         self.text_id = elt.get('text_id')
+         self.text_sha1 = elt.get('text_sha1')
++        self.symlink_target = elt.get('symlink_target')
+         
+         ## mutter("read inventoryentry: %r" % (elt.attrib))
+ 
+
+*** modified file 'bzrlib/osutils.py'
+--- bzrlib/osutils.py 
++++ bzrlib/osutils.py 
+@@ -58,7 +58,30 @@
+     else:
+         raise BzrError("can't handle file kind with mode %o of %r" % (mode, f)) 
+ 
+-
++def lexists(f):
++    try:
++        if hasattr(os, 'lstat'):
++            os.lstat(f)
++        else:
++            os.stat(f)
++        return True
++    except OSError,e:
++        if e.errno == errno.ENOENT:
++            return False;
++        else:
++            raise BzrError("lstat/stat of (%r): %r" % (f, e))
++
++def normalizepath(f):
++    if hasattr(os.path, 'realpath'):
++        F = os.path.realpath
++    else:
++        F = os.path.abspath
++    [p,e] = os.path.split(f)
++    if e == "" or e == "." or e == "..":
++        return F(f)
++    else:
++        return os.path.join(F(p), e)
++    
+ 
+ def isdir(f):
+     """True if f is an accessible directory."""
+
+*** modified file 'bzrlib/statcache.py'
+--- bzrlib/statcache.py 
++++ bzrlib/statcache.py 
+@@ -53,7 +53,7 @@
+ to use a tdb instead.
+ 
+ The cache is represented as a map from file_id to a tuple of (file_id,
+-sha1, path, size, mtime, ctime, ino, dev).
++sha1, path, symlink target, size, mtime, ctime, ino, dev, mode).
+ """
+ 
+ 
+@@ -62,11 +62,13 @@
+ FP_CTIME = 2
+ FP_INO   = 3
+ FP_DEV   = 4
+-
++FP_ST_MODE=5
+ 
+ SC_FILE_ID = 0
+ SC_SHA1    = 1 
+-
++SC_SYMLINK_TARGET = 3
++
++CACHE_ENTRY_SIZE = 10
+ 
+ def fingerprint(abspath):
+     try:
+@@ -79,7 +81,7 @@
+         return None
+ 
+     return (fs.st_size, fs.st_mtime,
+-            fs.st_ctime, fs.st_ino, fs.st_dev)
++            fs.st_ctime, fs.st_ino, fs.st_dev, fs.st_mode)
+ 
+ 
+ def _write_cache(basedir, entry_iter, dangerfiles):
+@@ -93,7 +95,9 @@
+                 continue
+             outf.write(entry[0] + ' ' + entry[1] + ' ')
+             outf.write(b2a_qp(entry[2], True))
+-            outf.write(' %d %d %d %d %d\n' % entry[3:])
++            outf.write(' ')
++            outf.write(b2a_qp(entry[3], True)) # symlink_target
++            outf.write(' %d %d %d %d %d %d\n' % entry[4:])
+ 
+         outf.commit()
+     finally:
+@@ -114,10 +118,13 @@
+     
+     for l in cachefile:
+         f = l.split(' ')
++        if len(f) != CACHE_ENTRY_SIZE:
++            mutter("cache is in old format, must recreate it")
++            return {}
+         file_id = f[0]
+         if file_id in cache:
+             raise BzrError("duplicated file_id in cache: {%s}" % file_id)
+-        cache[file_id] = (f[0], f[1], a2b_qp(f[2])) + tuple([long(x) for x in f[3:]])
++        cache[file_id] = (f[0], f[1], a2b_qp(f[2]), a2b_qp(f[3])) + tuple([long(x) for x in f[4:]])
+     return cache
+ 
+ 
+@@ -125,7 +132,7 @@
+ 
+ def _files_from_inventory(inv):
+     for path, ie in inv.iter_entries():
+-        if ie.kind != 'file':
++        if ie.kind != 'file' and ie.kind != 'symlink':
+             continue
+         yield ie.file_id, path
+     
+@@ -190,17 +197,24 @@
+         if (fp[FP_MTIME] >= now) or (fp[FP_CTIME] >= now):
+             dangerfiles.add(file_id)
+ 
+-        if cacheentry and (cacheentry[3:] == fp):
++        if cacheentry and (cacheentry[4:] == fp):
+             continue                    # all stat fields unchanged
+ 
+         hardcheck += 1
+ 
+-        dig = sha.new(file(abspath, 'rb').read()).hexdigest()
+-
++        mode = fp[FP_ST_MODE]
++        if stat.S_ISREG(mode):
++            link_target = '-' # can be anything, but must be non-empty
++            dig = sha.new(file(abspath, 'rb').read()).hexdigest()
++        elif stat.S_ISLNK(mode):
++            link_target = os.readlink(abspath)
++            dig = sha.new(link_target).hexdigest()
++        else:
++            raise BzrError("file %r: unknown file stat mode: %o"%(abspath,mode))
+         if cacheentry == None or dig != cacheentry[1]: 
+             # if there was no previous entry for this file, or if the
+             # SHA has changed, then update the cache
+-            cacheentry = (file_id, dig, path) + fp
++            cacheentry = (file_id, dig, path, link_target) + fp
+             cache[file_id] = cacheentry
+             change_cnt += 1
+ 
+
+*** modified file 'bzrlib/tree.py'
+--- bzrlib/tree.py 
++++ bzrlib/tree.py 
+@@ -125,6 +125,11 @@
+                 os.mkdir(fullpath)
+             elif kind == 'file':
+                 pumpfile(self.get_file(ie.file_id), file(fullpath, 'wb'))
++            elif kind == 'symlink':
++                try:
++                    os.symlink(ie.symlink_target, fullpath)
++                except OSError,e:
++                    bailout("Failed to create symlink %r -> %r, error: %s" % (fullpath, ie.symlink_target, e))
+             else:
+                 bailout("don't know how to export {%s} of kind %r" % (ie.file_id, kind))
+             mutter("  export {%s} kind %s to %s" % (ie.file_id, kind, fullpath))
+@@ -167,6 +172,9 @@
+         for path, entry in self.inventory.iter_entries():
+             yield path, 'V', entry.kind, entry.file_id
+ 
++    def get_symlink_target(self, file_id):
++        ie = self._inventory[file_id]
++        return ie.symlink_target;
+ 
+ class EmptyTree(Tree):
+     def __init__(self):
+@@ -179,7 +187,8 @@
+         if False:  # just to make it a generator
+             yield None
+     
+-
++    def get_symlink_target(self, file_id):
++        return None
+ 
+ ######################################################################
+ # diff
+@@ -245,3 +254,7 @@
+         if old_name != new_name:
+             yield (old_name, new_name)
+             
++
++    def get_symlink_target(self, file_id):
++        ie = self._inventory[file_id]        
++        return ie.symlink_target
+
+*** modified file 'bzrlib/workingtree.py'
+--- bzrlib/workingtree.py 
++++ bzrlib/workingtree.py 
+@@ -53,7 +53,7 @@
+             ie = inv[file_id]
+             if ie.kind == 'file':
+                 if ((file_id in self._statcache)
+-                    or (os.path.exists(self.abspath(inv.id2path(file_id))))):
++                    or (bzrlib.osutils.lexists(self.abspath(inv.id2path(file_id))))):
+                     yield file_id
+ 
+ 
+@@ -66,7 +66,7 @@
+         return os.path.join(self.basedir, filename)
+ 
+     def has_filename(self, filename):
+-        return os.path.exists(self.abspath(filename))
++        return bzrlib.osutils.lexists(self.abspath(filename))
+ 
+     def get_file(self, file_id):
+         return self.get_file_byname(self.id2path(file_id))
+@@ -86,7 +86,7 @@
+         self._update_statcache()
+         if file_id in self._statcache:
+             return True
+-        return os.path.exists(self.abspath(self.id2path(file_id)))
++        return bzrlib.osutils.lexists(self.abspath(self.id2path(file_id)))
+ 
+ 
+     __contains__ = has_id
+@@ -108,6 +108,12 @@
+         return self._statcache[file_id][statcache.SC_SHA1]
+ 
+ 
++    def get_symlink_target(self, file_id):
++        import statcache
++        self._update_statcache()
++        target = self._statcache[file_id][statcache.SC_SYMLINK_TARGET]
++        return target
++        
+     def file_class(self, filename):
+         if self.path2id(filename):
+             return 'V'
+
+*** modified file 'testbzr'
+--- testbzr 
++++ testbzr 
+@@ -1,4 +1,4 @@
+-#! /usr/bin/python
++#! /usr/bin/env python
+ 
+ # Copyright (C) 2005 Canonical Ltd
+ 
+@@ -113,6 +113,17 @@
+     logfile.write('   at %s:%d\n' % stack[:2])
+ 
+ 
++def has_symlinks():
++    import os;
++    if hasattr(os, 'symlink'):
++        return True
++    else:
++        return False
++
++def listdir_sorted(dir):
++    L = os.listdir(dir)
++    L.sort()
++    return L
+ 
+ # prepare an empty scratch directory
+ if os.path.exists(TESTDIR):
+@@ -320,8 +331,105 @@
+     runcmd('bzr ignore *.blah')
+     assert backtick('bzr unknowns') == ''
+     assert file('.bzrignore', 'rt').read() == '*.blah\n'
+-
+-
++    cd("..")
++    
++    if has_symlinks():
++        progress("symlinks")
++        mkdir('symlinks')
++        cd('symlinks')
++        runcmd('bzr init')
++        os.symlink("NOWHERE1", "link1")
++        runcmd('bzr add link1')
++        assert backtick('bzr unknowns') == ''
++        runcmd(['bzr', 'commit', '-m', '1: added symlink link1'])
++
++        mkdir('d1')
++        runcmd('bzr add d1')
++        assert backtick('bzr unknowns') == ''
++        os.symlink("NOWHERE2", "d1/link2")
++        assert backtick('bzr unknowns') == 'd1/link2\n'
++        # is d1/link2 found when adding d1
++        runcmd('bzr add d1')
++        assert backtick('bzr unknowns') == ''
++        os.symlink("NOWHERE3", "d1/link3")
++        assert backtick('bzr unknowns') == 'd1/link3\n'
++        runcmd(['bzr', 'commit', '-m', '2: added dir, symlink'])
++
++        runcmd('bzr rename d1 d2')
++        runcmd('bzr move d2/link2 .')
++        runcmd('bzr move link1 d2')
++        assert os.readlink("./link2") == "NOWHERE2"
++        assert os.readlink("d2/link1") == "NOWHERE1"
++        runcmd('bzr add d2/link3')
++        runcmd('bzr diff')
++        runcmd(['bzr', 'commit', '-m', '3: rename of dir, move symlinks, add link3'])
++
++        os.unlink("link2")
++        os.symlink("TARGET 2", "link2")
++        os.unlink("d2/link1")
++        os.symlink("TARGET 1", "d2/link1")
++        runcmd('bzr diff')
++        assert backtick("bzr relpath d2/link1") == "d2/link1\n"
++        runcmd(['bzr', 'commit', '-m', '4: retarget of two links'])
++
++        runcmd('bzr remove d2/link1')
++        assert backtick('bzr unknowns') == 'd2/link1\n'
++        runcmd(['bzr', 'commit', '-m', '5: remove d2/link1'])
++
++        os.mkdir("d1")
++        runcmd('bzr add d1')
++        runcmd('bzr rename d2/link3 d1/link3new')
++        assert backtick('bzr unknowns') == 'd2/link1\n'
++        runcmd(['bzr', 'commit', '-m', '6: remove d2/link1, move/rename link3'])
++        
++        runcmd(['bzr', 'check'])
++        
++        runcmd(['bzr', 'export', '-r', '1', 'exp1.tmp'])
++        cd("exp1.tmp")
++        assert listdir_sorted(".") == [ "link1" ]
++        assert os.readlink("link1") == "NOWHERE1"
++        cd("..")
++        
++        runcmd(['bzr', 'export', '-r', '2', 'exp2.tmp'])
++        cd("exp2.tmp")
++        assert listdir_sorted(".") == [ "d1", "link1" ]
++        cd("..")
++        
++        runcmd(['bzr', 'export', '-r', '3', 'exp3.tmp'])
++        cd("exp3.tmp")
++        assert listdir_sorted(".") == [ "d2", "link2" ]
++        assert listdir_sorted("d2") == [ "link1", "link3" ]
++        assert os.readlink("d2/link1") == "NOWHERE1"
++        assert os.readlink("link2")    == "NOWHERE2"
++        cd("..")
++        
++        runcmd(['bzr', 'export', '-r', '4', 'exp4.tmp'])
++        cd("exp4.tmp")
++        assert listdir_sorted(".") == [ "d2", "link2" ]
++        assert os.readlink("d2/link1") == "TARGET 1"
++        assert os.readlink("link2")    == "TARGET 2"
++        assert listdir_sorted("d2") == [ "link1", "link3" ]
++        cd("..")
++        
++        runcmd(['bzr', 'export', '-r', '5', 'exp5.tmp'])
++        cd("exp5.tmp")
++        assert listdir_sorted(".") == [ "d2", "link2" ]
++        assert os.path.islink("link2")
++        assert listdir_sorted("d2")== [ "link3" ]
++        cd("..")
++        
++        runcmd(['bzr', 'export', '-r', '6', 'exp6.tmp'])
++        cd("exp6.tmp")
++        assert listdir_sorted(".") == [ "d1", "d2", "link2" ]
++        assert listdir_sorted("d1") == [ "link3new" ]
++        assert listdir_sorted("d2") == []
++        assert os.readlink("d1/link3new") == "NOWHERE3"
++        cd("..")
++
++        cd("..")
++    else:
++        progress("skipping symlink tests")
++        
+     progress("all tests passed!")
+ except Exception, e:
+     sys.stderr.write('*' * 50 + '\n'
+
+
+--=-=-=--

=== modified file 'setup.py'
--- setup.py	2005-10-06 12:34:22 +0000
+++ setup.py	2005-09-23 09:25:16 +0000
@@ -51,7 +51,7 @@
 ########################
 
 setup(name='bzr',
-      version='0.1',
+      version='0.0.6',
       author='Martin Pool',
       author_email='mbp@sourcefrog.net',
       url='http://www.bazaar-ng.org/',
@@ -61,8 +61,6 @@
                 'bzrlib.plugins',
                 'bzrlib.selftest',
                 'bzrlib.util',
-                'bzrlib.transport',
-                'bzrlib.store',
                 'bzrlib.util.elementtree',
                 'bzrlib.util.effbot.org',
                 ],

=== added file 'testsweet.py'
--- testsweet.py	1970-01-01 00:00:00 +0000
+++ testsweet.py	2005-09-27 06:15:35 +0000
@@ -0,0 +1,175 @@
+# Copyright (C) 2005 by Canonical Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+
+"""Enhanced layer on unittest.
+
+This does several things:
+
+* nicer reporting as tests run
+
+* test code can log messages into a buffer that is recorded to disk
+  and displayed if the test fails
+
+* tests can be run in a separate directory, which is useful for code that
+  wants to create files
+
+* utilities to run external commands and check their return code
+  and/or output
+
+Test cases should normally subclass testsweet.TestCase.  The test runner should
+call runsuite().
+
+This is meant to become independent of bzr, though that's not quite
+true yet.
+"""  
+
+import unittest
+import sys
+from bzrlib.selftest import TestUtil
+
+# XXX: Don't need this anymore now we depend on python2.4
+def _need_subprocess():
+    sys.stderr.write("sorry, this test suite requires the subprocess module\n"
+                     "this is shipped with python2.4 and available separately for 2.3\n")
+    
+
+class CommandFailed(Exception):
+    pass
+
+
+class TestSkipped(Exception):
+    """Indicates that a test was intentionally skipped, rather than failing."""
+    # XXX: Not used yet
+
+class EarlyStoppingTestResultAdapter(object):
+    """An adapter for TestResult to stop at the first first failure or error"""
+
+    def __init__(self, result):
+        self._result = result
+
+    def addError(self, test, err):
+        self._result.addError(test, err)
+        self._result.stop()
+
+    def addFailure(self, test, err):
+        self._result.addFailure(test, err)
+        self._result.stop()
+
+    def __getattr__(self, name):
+        return getattr(self._result, name)
+
+    def __setattr__(self, name, value):
+        if name == '_result':
+            object.__setattr__(self, name, value)
+        return setattr(self._result, name, value)
+
+
+class _MyResult(unittest._TextTestResult):
+    """
+    Custom TestResult.
+
+    No special behaviour for now.
+    """
+
+    def startTest(self, test):
+        unittest.TestResult.startTest(self, test)
+        # TODO: Maybe show test.shortDescription somewhere?
+        what = test.shortDescription() or test.id()        
+        if self.showAll:
+            self.stream.write('%-70.70s' % what)
+        self.stream.flush()
+
+    def addError(self, test, err):
+        super(_MyResult, self).addError(test, err)
+        self.stream.flush()
+
+    def addFailure(self, test, err):
+        super(_MyResult, self).addFailure(test, err)
+        self.stream.flush()
+
+    def addSuccess(self, test):
+        if self.showAll:
+            self.stream.writeln('OK')
+        elif self.dots:
+            self.stream.write('~')
+        self.stream.flush()
+        unittest.TestResult.addSuccess(self, test)
+
+    def printErrorList(self, flavour, errors):
+        for test, err in errors:
+            self.stream.writeln(self.separator1)
+            self.stream.writeln("%s: %s" % (flavour,self.getDescription(test)))
+            if hasattr(test, '_get_log'):
+                self.stream.writeln()
+                self.stream.writeln('log from this test:')
+                print >>self.stream, test._get_log()
+            self.stream.writeln(self.separator2)
+            self.stream.writeln("%s" % err)
+
+
+class TextTestRunner(unittest.TextTestRunner):
+
+    def _makeResult(self):
+        result = _MyResult(self.stream, self.descriptions, self.verbosity)
+        return EarlyStoppingTestResultAdapter(result)
+
+
+class filteringVisitor(TestUtil.TestVisitor):
+    """I accruse all the testCases I visit that pass a regexp filter on id
+    into my suite
+    """
+
+    def __init__(self, filter):
+        import re
+        TestUtil.TestVisitor.__init__(self)
+        self._suite=None
+        self.filter=re.compile(filter)
+
+    def suite(self):
+        """answer the suite we are building"""
+        if self._suite is None:
+            self._suite=TestUtil.TestSuite()
+        return self._suite
+
+    def visitCase(self, aCase):
+        if self.filter.match(aCase.id()):
+            self.suite().addTest(aCase)
+
+
+def run_suite(suite, name='test', verbose=False, pattern=".*"):
+    import shutil
+    from bzrlib.selftest import TestCaseInTempDir
+    TestCaseInTempDir._TEST_NAME = name
+    if verbose:
+        verbosity = 2
+    else:
+        verbosity = 1
+    runner = TextTestRunner(stream=sys.stdout,
+                            descriptions=0,
+                            verbosity=verbosity)
+    visitor = filteringVisitor(pattern)
+    suite.visit(visitor)
+    result = runner.run(visitor.suite())
+    # This is still a little bogus, 
+    # but only a little. Folk not using our testrunner will
+    # have to delete their temp directories themselves.
+    if result.wasSuccessful():
+        if TestCaseInTempDir.TEST_ROOT is not None:
+            shutil.rmtree(TestCaseInTempDir.TEST_ROOT) 
+    else:
+        print "Failed tests working directories are in '%s'\n" % TestCaseInTempDir.TEST_ROOT
+    return result.wasSuccessful()

=== removed file 'tools/capture_tree.py'
--- tools/capture_tree.py	2005-10-04 11:13:33 +0000
+++ tools/capture_tree.py	1970-01-01 00:00:00 +0000
@@ -1,40 +0,0 @@
-#! /usr/bin/env python2.4
-
-# Copyright (C) 2005 Canonical Ltd
-
-"""Print to stdout a description of the current directory, 
-formatted as a Python data structure.
-
-This can be useful in tests that need to recreate directory
-contents."""
-
-import sys
-import os
-
-from bzrlib.trace import enable_default_logging
-enable_default_logging()
-from bzrlib.selftest.treeshape import capture_tree_contents
-
-def main(argv):
-    # a lame reimplementation of pformat that splits multi-line
-    # strings into concatenated string literals.
-    print '['
-    for tt in capture_tree_contents('.'):
-        assert isinstance(tt, tuple)
-        print '    (', repr(tt[0]) + ',',
-        if len(tt) == 1:
-            print '),'
-        else:
-            assert len(tt) == 2
-            val = tt[1]
-            print
-            if val == '':
-                print "        ''"
-            else:
-                for valline in val.splitlines(True):
-                    print '       ', repr(valline)
-            print '    ),'
-    print ']'
-
-if __name__ == '__main__':
-    sys.exit(main(sys.argv))

